/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.classicalb.core.preparser.lexer;

import java.io.*;
import java.util.*;
import de.be4.classicalb.core.preparser.node.*;
import de.hhu.stups.sablecc.patch.*;
import java.util.concurrent.LinkedBlockingQueue;

@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.NORMAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;
    private final Queue<IToken> nextList = new LinkedBlockingQueue<IToken>();

	private IToken tok;

    public Queue<IToken> getNextList() {
        return nextList;
    }

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
              nextList.add(token);
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return (Token) nextList.peek();
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = (Token) nextList.poll();
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 6: state = State.MULTILINE_STRING_STATE; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 6: state = State.MULTILINE_STRING_STATE; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NO_DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.NO_DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITION_FILE; break;
                                case 3: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 25:
                        {
                              Token token = new25(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.DEFINITION_FILE; break;
                            }
                            return token;
                        }
                    case 26:
                        {
                              Token token = new26(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 27:
                        {
                              Token token = new27(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  String text,   int line,   int pos) { return new TComment(text, line, pos); }
    Token new1(  String text,   int line,   int pos) { return new TCommentEnd(text, line, pos); }
    Token new2(  String text,   int line,   int pos) { return new TCommentContent(text, line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TMultilineStringStart(text, line, pos); }
    Token new4(  String text,   int line,   int pos) { return new TMultilineStringEnd(text, line, pos); }
    Token new5(  String text,   int line,   int pos) { return new TMultilineStringContent(text, line, pos); }
    Token new6(  String text,   int line,   int pos) { return new TLineComment(text, line, pos); }
    Token new7(  int line,   int pos) { return new TDefinitions(line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TOtherClauseBegin(text, line, pos); }
    Token new9(  String text,   int line,   int pos) { return new TEndMachine(text, line, pos); }
    Token new10(  int line,   int pos) { return new TKwDefinitions(line, pos); }
    Token new11(  String text,   int line,   int pos) { return new TKwPrefix(text, line, pos); }
    Token new12(  String text,   int line,   int pos) { return new TNoDefSomething(text, line, pos); }
    Token new13(  String text,   int line,   int pos) { return new TIdentifierLiteral(text, line, pos); }
    Token new14(  int line,   int pos) { return new TLeftPar(line, pos); }
    Token new15(  int line,   int pos) { return new TRightPar(line, pos); }
    Token new16(  String text,   int line,   int pos) { return new TSlash(text, line, pos); }
    Token new17(  int line,   int pos) { return new TComma(line, pos); }
    Token new18(  int line,   int pos) { return new TBeginDefBody(line, pos); }
    Token new19(  String text,   int line,   int pos) { return new TRhsBody(text, line, pos); }
    Token new20(  String text,   int line,   int pos) { return new TBeginNesting(text, line, pos); }
    Token new21(  String text,   int line,   int pos) { return new TEndNesting(text, line, pos); }
    Token new22(  String text,   int line,   int pos) { return new TRhsIdentifier(text, line, pos); }
    Token new23(  String text,   int line,   int pos) { return new TSemicolon(text, line, pos); }
    Token new24(  String text,   int line,   int pos) { return new TDoubleQuotation(text, line, pos); }
    Token new25(  String text,   int line,   int pos) { return new TFilename(text, line, pos); }
    Token new26(  String text,   int line,   int pos) { return new TSomething(text, line, pos); }
    Token new27(  String text,   int line,   int pos) { return new TWhiteSpace(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // NORMAL
            {{0, 32, 1}, {33, 33, 2}, {34, 34, 3}, {35, 35, 4}, {36, 38, 2}, {39, 39, 5}, {40, 46, 2}, {47, 47, 6}, {48, 64, 2}, {65, 65, 7}, {66, 66, 8}, {67, 67, 9}, {68, 68, 10}, {69, 69, 11}, {70, 72, 8}, {73, 73, 12}, {74, 75, 8}, {76, 76, 13}, {77, 77, 14}, {78, 78, 8}, {79, 79, 15}, {80, 80, 16}, {81, 81, 8}, {82, 82, 17}, {83, 83, 18}, {84, 84, 8}, {85, 85, 19}, {86, 86, 20}, {87, 90, 8}, {91, 96, 2}, {97, 122, 21}, {123, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 32, 22}, {127, 160, 22}, {8206, 8207, 22}, {8232, 8233, 22}, },
            {},
            {{0, 9, 23}, {11, 12, 23}, {14, 33, 23}, {34, 34, 24}, {35, 91, 23}, {92, 92, 25}, {93, 65535, 23}, },
            {{68, 68, 26}, {69, 69, 27}, {80, 80, 28}, {83, 83, 29}, },
            {{39, 39, 30}, },
            {{42, 42, 31}, {47, 47, 32}, },
            {{48, 57, 33}, {65, 65, 34}, {66, 66, 35}, {67, 82, 34}, {83, 83, 36}, {84, 90, 34}, {95, 95, 37}, {97, 122, 38}, },
            {{48, 57, 33}, {65, 90, 34}, {95, 122, -9}, },
            {{48, 57, 33}, {65, 78, 34}, {79, 79, 39}, {80, 90, 34}, {95, 122, -9}, },
            {{48, 57, 33}, {65, 68, 34}, {69, 69, 40}, {70, 90, 34}, {95, 122, -9}, },
            {{48, 57, 33}, {65, 77, 34}, {78, 78, 41}, {79, 85, 34}, {86, 86, 42}, {87, 87, 34}, {88, 88, 43}, {89, 90, 34}, {95, 122, -9}, },
            {{48, 57, 33}, {65, 76, 34}, {77, 77, 44}, {78, 78, 45}, {79, 90, 34}, {95, 122, -9}, },
            {{48, 78, -11}, {79, 79, 46}, {80, 122, -11}, },
            {{48, 57, 33}, {65, 65, 47}, {66, 78, 34}, {79, 79, 48}, {80, 122, -11}, },
            {{48, 57, 33}, {65, 79, 34}, {80, 80, 49}, {81, 90, 34}, {95, 122, -9}, },
            {{48, 57, 33}, {65, 81, 34}, {82, 82, 50}, {83, 90, 34}, {95, 122, -9}, },
            {{48, 68, -12}, {69, 69, 51}, {70, 84, 34}, {85, 85, 52}, {86, 90, 34}, {95, 122, -9}, },
            {{48, 68, -12}, {69, 69, 53}, {70, 88, 34}, {89, 89, 54}, {90, 90, 34}, {95, 122, -9}, },
            {{48, 57, 33}, {65, 82, 34}, {83, 83, 55}, {84, 122, -9}, },
            {{48, 57, 33}, {65, 65, 56}, {66, 90, 34}, {95, 122, -9}, },
            {{48, 122, -10}, },
            {{0, 8233, -3}, },
            {{0, 65535, -5}, },
            {},
            {{0, 33, -5}, {34, 34, 57}, {35, 65535, -5}, },
            {{69, 69, 58}, },
            {{88, 88, 59}, },
            {{82, 82, 60}, },
            {{85, 85, 61}, },
            {{39, 39, 62}, },
            {},
            {{0, 9, 63}, {10, 10, 64}, {11, 12, 63}, {13, 13, 64}, {14, 65535, 63}, },
            {{48, 122, -10}, },
            {{48, 122, -10}, },
            {{48, 82, -21}, {83, 83, 65}, {84, 122, -9}, },
            {{48, 82, -21}, {83, 83, 66}, {84, 122, -9}, },
            {{48, 122, -10}, },
            {{48, 122, -10}, },
            {{48, 77, -13}, {78, 78, 67}, {79, 122, -14}, },
            {{48, 57, 33}, {65, 69, 34}, {70, 70, 68}, {71, 90, 34}, {95, 122, -9}, },
            {{48, 57, 33}, {65, 67, 34}, {68, 68, 69}, {69, 90, 34}, {95, 122, -9}, },
            {{48, 68, -12}, {69, 69, 70}, {70, 122, -12}, },
            {{48, 57, 33}, {65, 83, 34}, {84, 84, 71}, {85, 90, 34}, {95, 122, -9}, },
            {{48, 79, -17}, {80, 80, 72}, {81, 122, -17}, },
            {{48, 57, 33}, {65, 66, 34}, {67, 67, 73}, {68, 72, 34}, {73, 73, 74}, {74, 85, 34}, {86, 86, 75}, {87, 90, 34}, {95, 122, -9}, },
            {{48, 66, -47}, {67, 67, 76}, {68, 90, 34}, {95, 122, -9}, },
            {{48, 66, -47}, {67, 67, 77}, {68, 122, -48}, },
            {{48, 67, -43}, {68, 68, 78}, {69, 122, -43}, },
            {{48, 68, -12}, {69, 69, 79}, {70, 122, -12}, },
            {{48, 78, -11}, {79, 79, 80}, {80, 122, -11}, },
            {{48, 69, -42}, {70, 70, 81}, {71, 122, -42}, },
            {{48, 57, 33}, {65, 75, 34}, {76, 76, 82}, {77, 90, 34}, {95, 122, -9}, },
            {{48, 68, -12}, {69, 69, 83}, {70, 83, 34}, {84, 84, 84}, {85, 122, -45}, },
            {{48, 82, -21}, {83, 83, 85}, {84, 122, -9}, },
            {{48, 68, -12}, {69, 69, 86}, {70, 122, -12}, },
            {{48, 75, -54}, {76, 76, 87}, {77, 81, 34}, {82, 82, 88}, {83, 122, -18}, },
            {{0, 65535, -5}, },
            {{70, 70, 89}, },
            {{80, 80, 90}, },
            {{69, 69, 91}, },
            {{66, 66, 92}, },
            {},
            {{0, 65535, -34}, },
            {},
            {{48, 83, -45}, {84, 84, 93}, {85, 122, -45}, },
            {{48, 68, -12}, {69, 69, 94}, {70, 122, -12}, },
            {{48, 66, -47}, {67, 67, 95}, {68, 82, 34}, {83, 83, 96}, {84, 122, -9}, },
            {{48, 57, 33}, {65, 72, 34}, {73, 73, 97}, {74, 90, 34}, {95, 122, -9}, },
            {{48, 122, -10}, },
            {{48, 77, -13}, {78, 78, 98}, {79, 122, -14}, },
            {{48, 68, -12}, {69, 69, 99}, {70, 122, -12}, },
            {{48, 75, -54}, {76, 76, 100}, {77, 78, 34}, {79, 79, 101}, {80, 122, -11}, },
            {{48, 75, -54}, {76, 76, 102}, {77, 122, -54}, },
            {{48, 83, -45}, {84, 84, 103}, {85, 122, -45}, },
            {{48, 57, 33}, {65, 65, 104}, {66, 122, -22}, },
            {{48, 57, 33}, {65, 65, 105}, {66, 122, -22}, },
            {{48, 57, 33}, {65, 71, 34}, {72, 72, 106}, {73, 90, 34}, {95, 122, -9}, },
            {{48, 68, -12}, {69, 69, 107}, {70, 122, -12}, },
            {{48, 81, -18}, {82, 82, 108}, {83, 122, -18}, },
            {{48, 76, -14}, {77, 77, 109}, {78, 79, 34}, {80, 80, 110}, {81, 122, -17}, },
            {{48, 72, -70}, {73, 73, 111}, {74, 122, -70}, },
            {{48, 68, -12}, {69, 69, 112}, {70, 122, -12}, },
            {{48, 82, -21}, {83, 83, 113}, {84, 122, -9}, },
            {{48, 82, -21}, {83, 83, 114}, {84, 122, -9}, },
            {{48, 83, -45}, {84, 84, 115}, {85, 122, -45}, },
            {{48, 82, -21}, {83, 83, 116}, {84, 122, -9}, },
            {{48, 57, 33}, {65, 84, 34}, {85, 85, 117}, {86, 122, -19}, },
            {{48, 72, -70}, {73, 73, 118}, {74, 122, -70}, },
            {{73, 73, 119}, },
            {{82, 82, 120}, },
            {{68, 68, 121}, },
            {{83, 83, 122}, },
            {{48, 81, -18}, {82, 82, 123}, {83, 122, -18}, },
            {{48, 81, -18}, {82, 82, 124}, {83, 122, -18}, },
            {{48, 81, -18}, {82, 82, 125}, {83, 122, -18}, },
            {{48, 83, -45}, {84, 84, 126}, {85, 122, -45}, },
            {{48, 77, -13}, {78, 78, 127}, {79, 122, -14}, },
            {{48, 83, -45}, {84, 84, 128}, {85, 122, -45}, },
            {{48, 77, -13}, {78, 78, 129}, {79, 122, -14}, },
            {{48, 68, -12}, {69, 69, 130}, {70, 122, -12}, },
            {{48, 81, -18}, {82, 82, 131}, {83, 122, -18}, },
            {{48, 84, -89}, {85, 85, 132}, {86, 122, -19}, },
            {{48, 72, -70}, {73, 73, 133}, {74, 122, -70}, },
            {{48, 81, -18}, {82, 82, 134}, {83, 122, -18}, },
            {{48, 75, -54}, {76, 76, 135}, {77, 122, -54}, },
            {{48, 72, -70}, {73, 73, 136}, {74, 122, -70}, },
            {{48, 75, -54}, {76, 76, 137}, {77, 122, -54}, },
            {{48, 57, 33}, {65, 65, 138}, {66, 122, -22}, },
            {{48, 78, -11}, {79, 79, 139}, {80, 122, -11}, },
            {{48, 68, -12}, {69, 69, 140}, {70, 122, -12}, },
            {{48, 77, -13}, {78, 78, 141}, {79, 122, -14}, },
            {{48, 82, -21}, {83, 83, 142}, {84, 122, -9}, },
            {{48, 122, -10}, },
            {{48, 122, -10}, },
            {{48, 68, -12}, {69, 69, 143}, {70, 122, -12}, },
            {{48, 122, -10}, },
            {{48, 68, -12}, {69, 69, 144}, {70, 122, -12}, },
            {{48, 57, 33}, {65, 65, 145}, {66, 122, -22}, },
            {{78, 78, 146}, },
            {{69, 69, 147}, },
            {{73, 73, 148}, },
            {{84, 84, 149}, },
            {{48, 57, 33}, {65, 65, 150}, {66, 122, -22}, },
            {{48, 83, -45}, {84, 84, 151}, {85, 122, -45}, },
            {{48, 68, -12}, {69, 69, 152}, {70, 122, -12}, },
            {{48, 57, 33}, {65, 65, 153}, {66, 81, 34}, {82, 82, 154}, {83, 122, -18}, },
            {{48, 72, -70}, {73, 73, 155}, {74, 122, -70}, },
            {{48, 82, -21}, {83, 83, 156}, {84, 122, -9}, },
            {{48, 67, -43}, {68, 68, 157}, {69, 122, -43}, },
            {{48, 76, -14}, {77, 77, 158}, {78, 90, 34}, {95, 122, -9}, },
            {{48, 83, -45}, {84, 84, 159}, {85, 122, -45}, },
            {{48, 67, -43}, {68, 68, 160}, {69, 122, -43}, },
            {{48, 57, 33}, {65, 65, 161}, {66, 122, -22}, },
            {{48, 72, -70}, {73, 73, 162}, {74, 122, -70}, },
            {{48, 90, -10}, {95, 95, 163}, {97, 122, 38}, },
            {{48, 77, -13}, {78, 78, 164}, {79, 122, -14}, },
            {{48, 122, -10}, },
            {{48, 83, -45}, {84, 84, 165}, {85, 122, -45}, },
            {{48, 83, -45}, {84, 84, 166}, {85, 122, -45}, },
            {{48, 81, -18}, {82, 82, 167}, {83, 122, -18}, },
            {{48, 68, -12}, {69, 69, 168}, {70, 122, -12}, },
            {{48, 90, -10}, {95, 95, 169}, {97, 122, 38}, },
            {{48, 76, -14}, {77, 77, 170}, {78, 122, -132}, },
            {{48, 82, -21}, {83, 83, 171}, {84, 122, -9}, },
            {{48, 65, -9}, {66, 66, 172}, {67, 90, 34}, {95, 122, -9}, },
            {{73, 73, 173}, },
            {{83, 83, 174}, },
            {{67, 67, 175}, },
            {{73, 73, 176}, },
            {{48, 66, -47}, {67, 67, 177}, {68, 122, -48}, },
            {{48, 72, -70}, {73, 73, 178}, {74, 122, -70}, },
            {{48, 83, -45}, {84, 84, 179}, {85, 122, -45}, },
            {{48, 77, -13}, {78, 78, 180}, {79, 122, -14}, },
            {{48, 57, 33}, {65, 65, 181}, {66, 122, -22}, },
            {{48, 83, -45}, {84, 84, 182}, {85, 122, -45}, },
            {{48, 122, -10}, },
            {{48, 82, -21}, {83, 83, 183}, {84, 122, -9}, },
            {{48, 68, -12}, {69, 69, 184}, {70, 122, -12}, },
            {{48, 82, -21}, {83, 83, 185}, {84, 122, -9}, },
            {{48, 68, -12}, {69, 69, 186}, {70, 122, -12}, },
            {{48, 75, -54}, {76, 76, 187}, {77, 122, -54}, },
            {{48, 57, 33}, {65, 65, 188}, {66, 122, -22}, },
            {{48, 78, -11}, {79, 79, 189}, {80, 122, -11}, },
            {{48, 68, -12}, {69, 69, 190}, {70, 122, -12}, },
            {{48, 72, -70}, {73, 73, 191}, {74, 122, -70}, },
            {{48, 68, -12}, {69, 69, 192}, {70, 122, -12}, },
            {{48, 83, -45}, {84, 84, 193}, {85, 122, -45}, },
            {{48, 76, -14}, {77, 77, 194}, {78, 82, 34}, {83, 83, 195}, {84, 122, -9}, },
            {{48, 76, -14}, {77, 77, 196}, {78, 122, -132}, },
            {{48, 122, -10}, },
            {{48, 122, -10}, },
            {{48, 75, -54}, {76, 76, 197}, {77, 122, -54}, },
            {{84, 84, 198}, },
            {{83, 83, 199}, },
            {{65, 65, 200}, },
            {{84, 84, 201}, },
            {{48, 83, -45}, {84, 84, 202}, {85, 122, -45}, },
            {{48, 78, -11}, {79, 79, 203}, {80, 122, -11}, },
            {{48, 68, -12}, {69, 69, 204}, {70, 122, -12}, },
            {{48, 83, -45}, {84, 84, 205}, {85, 122, -45}, },
            {{48, 72, -70}, {73, 73, 206}, {74, 122, -70}, },
            {{48, 72, -70}, {73, 73, 207}, {74, 122, -70}, },
            {{48, 122, -10}, },
            {{48, 77, -13}, {78, 78, 208}, {79, 122, -14}, },
            {{48, 122, -10}, },
            {{48, 82, -21}, {83, 83, 209}, {84, 122, -9}, },
            {{48, 72, -70}, {73, 73, 210}, {74, 122, -70}, },
            {{48, 77, -13}, {78, 78, 211}, {79, 122, -14}, },
            {{48, 79, -17}, {80, 80, 212}, {81, 122, -17}, },
            {{48, 122, -10}, },
            {{48, 78, -11}, {79, 79, 213}, {80, 122, -11}, },
            {{48, 82, -21}, {83, 83, 214}, {84, 122, -9}, },
            {{48, 72, -70}, {73, 73, 215}, {74, 122, -70}, },
            {{48, 68, -12}, {69, 69, 216}, {70, 122, -12}, },
            {{48, 122, -10}, },
            {{48, 57, 33}, {65, 65, 217}, {66, 122, -22}, },
            {{48, 68, -12}, {69, 69, 218}, {70, 122, -12}, },
            {{73, 73, 219}, },
            {{73, 73, 220}, },
            {{84, 84, 221}, },
            {{85, 85, 222}, },
            {{48, 90, -10}, {95, 95, 223}, {97, 122, 38}, },
            {{48, 77, -13}, {78, 78, 224}, {79, 122, -14}, },
            {{48, 90, -10}, {95, 95, 225}, {97, 122, 38}, },
            {{48, 82, -21}, {83, 83, 226}, {84, 122, -9}, },
            {{48, 77, -13}, {78, 78, 227}, {79, 122, -14}, },
            {{48, 78, -11}, {79, 79, 228}, {80, 122, -11}, },
            {{48, 83, -45}, {84, 84, 229}, {85, 122, -45}, },
            {{48, 122, -10}, },
            {{48, 82, -21}, {83, 83, 230}, {84, 89, 34}, {90, 90, 231}, {95, 122, -9}, },
            {{48, 83, -45}, {84, 84, 232}, {85, 122, -45}, },
            {{48, 68, -12}, {69, 69, 233}, {70, 122, -12}, },
            {{48, 77, -13}, {78, 78, 234}, {79, 122, -14}, },
            {{48, 122, -10}, },
            {{48, 68, -12}, {69, 69, 235}, {70, 122, -12}, },
            {{48, 77, -13}, {78, 78, 236}, {79, 122, -14}, },
            {{48, 66, -47}, {67, 67, 237}, {68, 122, -48}, },
            {{48, 82, -21}, {83, 83, 238}, {84, 122, -9}, },
            {{79, 79, 239}, },
            {{79, 79, 240}, },
            {{69, 69, 241}, },
            {{84, 84, 242}, },
            {{48, 66, -47}, {67, 67, 243}, {68, 85, 34}, {86, 86, 244}, {87, 122, -47}, },
            {{48, 82, -21}, {83, 83, 245}, {84, 122, -9}, },
            {{48, 66, -47}, {67, 67, 246}, {68, 85, 34}, {86, 86, 247}, {87, 122, -47}, },
            {{48, 122, -10}, },
            {{48, 83, -45}, {84, 84, 248}, {85, 122, -45}, },
            {{48, 77, -13}, {78, 78, 249}, {79, 122, -14}, },
            {{48, 57, 33}, {65, 65, 250}, {66, 122, -22}, },
            {{48, 57, 33}, {65, 65, 251}, {66, 122, -22}, },
            {{48, 57, 33}, {65, 65, 252}, {66, 122, -22}, },
            {{48, 122, -10}, },
            {{48, 81, -18}, {82, 82, 253}, {83, 122, -18}, },
            {{48, 82, -21}, {83, 83, 254}, {84, 122, -9}, },
            {{48, 82, -21}, {83, 83, 255}, {84, 122, -9}, },
            {{48, 83, -45}, {84, 84, 256}, {85, 122, -45}, },
            {{48, 71, -79}, {72, 72, 257}, {73, 122, -79}, },
            {{48, 122, -10}, },
            {{78, 78, 258}, },
            {{78, 78, 259}, },
            {},
            {{73, 73, 260}, },
            {{48, 78, -11}, {79, 79, 261}, {80, 122, -11}, },
            {{48, 57, 33}, {65, 65, 262}, {66, 122, -22}, },
            {{48, 122, -10}, },
            {{48, 78, -11}, {79, 79, 263}, {80, 122, -11}, },
            {{48, 57, 33}, {65, 65, 264}, {66, 122, -22}, },
            {{48, 82, -21}, {83, 83, 265}, {84, 122, -9}, },
            {{48, 82, -21}, {83, 83, 266}, {84, 122, -9}, },
            {{48, 83, -45}, {84, 84, 267}, {85, 122, -45}, },
            {{48, 83, -45}, {84, 84, 268}, {85, 122, -45}, },
            {{48, 83, -45}, {84, 84, 269}, {85, 122, -45}, },
            {{48, 57, 33}, {65, 65, 270}, {66, 122, -22}, },
            {{48, 122, -10}, },
            {{48, 122, -10}, },
            {{48, 122, -10}, },
            {{48, 72, -70}, {73, 73, 271}, {74, 122, -70}, },
            {{83, 83, 272}, },
            {},
            {{79, 79, 273}, },
            {{48, 77, -13}, {78, 78, 274}, {79, 122, -14}, },
            {{48, 81, -18}, {82, 82, 275}, {83, 122, -18}, },
            {{48, 77, -13}, {78, 78, 276}, {79, 122, -14}, },
            {{48, 81, -18}, {82, 82, 277}, {83, 122, -18}, },
            {{48, 122, -10}, },
            {{48, 122, -10}, },
            {{48, 72, -70}, {73, 73, 278}, {74, 122, -70}, },
            {{48, 72, -70}, {73, 73, 279}, {74, 122, -70}, },
            {{48, 72, -70}, {73, 73, 280}, {74, 122, -70}, },
            {{48, 83, -45}, {84, 84, 281}, {85, 122, -45}, },
            {{48, 77, -13}, {78, 78, 282}, {79, 122, -14}, },
            {},
            {{78, 78, 283}, },
            {{48, 82, -21}, {83, 83, 284}, {84, 122, -9}, },
            {{48, 72, -70}, {73, 73, 285}, {74, 122, -70}, },
            {{48, 82, -21}, {83, 83, 286}, {84, 122, -9}, },
            {{48, 72, -70}, {73, 73, 287}, {74, 122, -70}, },
            {{48, 78, -11}, {79, 79, 288}, {80, 122, -11}, },
            {{48, 78, -11}, {79, 79, 289}, {80, 122, -11}, },
            {{48, 78, -11}, {79, 79, 290}, {80, 122, -11}, },
            {{48, 72, -70}, {73, 73, 291}, {74, 122, -70}, },
            {{48, 68, -12}, {69, 69, 292}, {70, 122, -12}, },
            {},
            {{48, 83, -45}, {84, 84, 293}, {85, 122, -45}, },
            {{48, 57, 33}, {65, 65, 294}, {66, 122, -22}, },
            {{48, 83, -45}, {84, 84, 295}, {85, 122, -45}, },
            {{48, 57, 33}, {65, 65, 296}, {66, 122, -22}, },
            {{48, 77, -13}, {78, 78, 297}, {79, 122, -14}, },
            {{48, 77, -13}, {78, 78, 298}, {79, 122, -14}, },
            {{48, 77, -13}, {78, 78, 299}, {79, 122, -14}, },
            {{48, 78, -11}, {79, 79, 300}, {80, 122, -11}, },
            {{48, 122, -10}, },
            {{48, 57, 33}, {65, 65, 301}, {66, 122, -22}, },
            {{48, 65, -9}, {66, 66, 302}, {67, 122, -147}, },
            {{48, 57, 33}, {65, 65, 303}, {66, 122, -22}, },
            {{48, 65, -9}, {66, 66, 304}, {67, 122, -147}, },
            {{48, 122, -10}, },
            {{48, 122, -10}, },
            {{48, 122, -10}, },
            {{48, 77, -13}, {78, 78, 305}, {79, 122, -14}, },
            {{48, 77, -13}, {78, 78, 306}, {79, 122, -14}, },
            {{48, 75, -54}, {76, 76, 307}, {77, 122, -54}, },
            {{48, 77, -13}, {78, 78, 308}, {79, 122, -14}, },
            {{48, 75, -54}, {76, 76, 309}, {77, 122, -54}, },
            {{48, 82, -21}, {83, 83, 310}, {84, 122, -9}, },
            {{48, 83, -45}, {84, 84, 311}, {85, 122, -45}, },
            {{48, 68, -12}, {69, 69, 312}, {70, 122, -12}, },
            {{48, 83, -45}, {84, 84, 313}, {85, 122, -45}, },
            {{48, 68, -12}, {69, 69, 314}, {70, 122, -12}, },
            {{48, 122, -10}, },
            {{48, 82, -21}, {83, 83, 315}, {84, 122, -9}, },
            {{48, 82, -21}, {83, 83, 316}, {84, 122, -9}, },
            {{48, 82, -21}, {83, 83, 317}, {84, 122, -9}, },
            {{48, 82, -21}, {83, 83, 318}, {84, 122, -9}, },
            {{48, 122, -10}, },
            {{48, 122, -10}, },
            {{48, 122, -10}, },
            {{48, 122, -10}, },
        }
        { // DEFINITIONS
            {{0, 32, 1}, {34, 34, 2}, {40, 40, 3}, {41, 41, 4}, {44, 44, 5}, {47, 47, 6}, {59, 59, 7}, {61, 61, 8}, {65, 65, 9}, {66, 66, 10}, {67, 67, 11}, {68, 68, 10}, {69, 69, 12}, {70, 72, 10}, {73, 73, 13}, {74, 75, 10}, {76, 76, 14}, {77, 77, 15}, {78, 78, 10}, {79, 79, 16}, {80, 80, 17}, {81, 81, 10}, {82, 82, 18}, {83, 83, 19}, {84, 84, 10}, {85, 85, 20}, {86, 86, 21}, {87, 90, 10}, {97, 122, 22}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {{0, 32, 1}, {127, 8233, -2}, },
            {},
            {},
            {},
            {},
            {{42, 42, 23}, {47, 47, 24}, },
            {},
            {{61, 61, 25}, },
            {{48, 57, 26}, {65, 65, 27}, {66, 66, 28}, {67, 82, 27}, {83, 83, 29}, {84, 90, 27}, {95, 95, 30}, {97, 122, 31}, },
            {{48, 57, 26}, {65, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 78, 27}, {79, 79, 32}, {80, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 77, 27}, {78, 78, 33}, {79, 85, 27}, {86, 86, 34}, {87, 87, 27}, {88, 88, 35}, {89, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 76, 27}, {77, 77, 36}, {78, 78, 37}, {79, 90, 27}, {95, 122, -11}, },
            {{48, 78, -13}, {79, 79, 38}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 65, 39}, {66, 78, 27}, {79, 79, 40}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 79, 27}, {80, 80, 41}, {81, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 81, 27}, {82, 82, 42}, {83, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 68, 27}, {69, 69, 43}, {70, 84, 27}, {85, 85, 44}, {86, 90, 27}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 45}, {70, 88, 27}, {89, 89, 46}, {90, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 82, 27}, {83, 83, 47}, {84, 122, -11}, },
            {{48, 57, 26}, {65, 65, 48}, {66, 90, 27}, {95, 122, -11}, },
            {{48, 122, -12}, },
            {},
            {{0, 9, 49}, {10, 10, 50}, {11, 12, 49}, {13, 13, 50}, {14, 65535, 49}, },
            {},
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 51}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 52}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 53}, {79, 122, -15}, },
            {{48, 57, 26}, {65, 67, 27}, {68, 68, 54}, {69, 90, 27}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 55}, {70, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 83, 27}, {84, 84, 56}, {85, 90, 27}, {95, 122, -11}, },
            {{48, 79, -18}, {80, 80, 57}, {81, 122, -18}, },
            {{48, 57, 26}, {65, 66, 27}, {67, 67, 58}, {68, 72, 27}, {73, 73, 59}, {74, 85, 27}, {86, 86, 60}, {87, 90, 27}, {95, 122, -11}, },
            {{48, 66, -39}, {67, 67, 61}, {68, 90, 27}, {95, 122, -11}, },
            {{48, 66, -39}, {67, 67, 62}, {68, 122, -40}, },
            {{48, 67, -35}, {68, 68, 63}, {69, 122, -35}, },
            {{48, 68, -20}, {69, 69, 64}, {70, 122, -36}, },
            {{48, 78, -13}, {79, 79, 65}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 69, 27}, {70, 70, 66}, {71, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 75, 27}, {76, 76, 67}, {77, 90, 27}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 68}, {70, 83, 27}, {84, 84, 69}, {85, 122, -37}, },
            {{48, 82, -22}, {83, 83, 70}, {84, 122, -11}, },
            {{48, 68, -20}, {69, 69, 71}, {70, 122, -36}, },
            {{48, 75, -46}, {76, 76, 72}, {77, 81, 27}, {82, 82, 73}, {83, 122, -19}, },
            {{0, 65535, -26}, },
            {},
            {{48, 83, -37}, {84, 84, 74}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 75}, {70, 122, -36}, },
            {{48, 66, -39}, {67, 67, 76}, {68, 82, 27}, {83, 83, 77}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 78}, {79, 122, -15}, },
            {{48, 68, -20}, {69, 69, 79}, {70, 122, -36}, },
            {{48, 75, -46}, {76, 76, 80}, {77, 78, 27}, {79, 79, 81}, {80, 122, -13}, },
            {{48, 75, -46}, {76, 76, 82}, {77, 122, -46}, },
            {{48, 83, -37}, {84, 84, 83}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 84}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 65, 85}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 71, 27}, {72, 72, 86}, {73, 90, 27}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 87}, {70, 122, -36}, },
            {{48, 81, -19}, {82, 82, 88}, {83, 122, -19}, },
            {{48, 76, -15}, {77, 77, 89}, {78, 79, 27}, {80, 80, 90}, {81, 122, -18}, },
            {{48, 57, 26}, {65, 72, 27}, {73, 73, 91}, {74, 90, 27}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 92}, {70, 122, -36}, },
            {{48, 82, -22}, {83, 83, 93}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 94}, {84, 122, -11}, },
            {{48, 83, -37}, {84, 84, 95}, {85, 122, -37}, },
            {{48, 82, -22}, {83, 83, 96}, {84, 122, -11}, },
            {{48, 57, 26}, {65, 84, 27}, {85, 85, 97}, {86, 122, -20}, },
            {{48, 72, -68}, {73, 73, 98}, {74, 122, -68}, },
            {{48, 81, -19}, {82, 82, 99}, {83, 122, -19}, },
            {{48, 81, -19}, {82, 82, 100}, {83, 122, -19}, },
            {{48, 81, -19}, {82, 82, 101}, {83, 122, -19}, },
            {{48, 83, -37}, {84, 84, 102}, {85, 122, -37}, },
            {{48, 83, -37}, {84, 84, 103}, {85, 122, -37}, },
            {{48, 77, -14}, {78, 78, 104}, {79, 122, -15}, },
            {{48, 68, -20}, {69, 69, 105}, {70, 122, -36}, },
            {{48, 81, -19}, {82, 82, 106}, {83, 122, -19}, },
            {{48, 84, -74}, {85, 85, 107}, {86, 122, -20}, },
            {{48, 72, -68}, {73, 73, 108}, {74, 122, -68}, },
            {{48, 81, -19}, {82, 82, 109}, {83, 122, -19}, },
            {{48, 75, -46}, {76, 76, 110}, {77, 122, -46}, },
            {{48, 72, -68}, {73, 73, 111}, {74, 122, -68}, },
            {{48, 75, -46}, {76, 76, 112}, {77, 122, -46}, },
            {{48, 57, 26}, {65, 65, 113}, {66, 122, -23}, },
            {{48, 78, -13}, {79, 79, 114}, {80, 122, -13}, },
            {{48, 68, -20}, {69, 69, 115}, {70, 122, -36}, },
            {{48, 77, -14}, {78, 78, 116}, {79, 122, -15}, },
            {{48, 82, -22}, {83, 83, 117}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 118}, {70, 122, -36}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 119}, {70, 122, -36}, },
            {{48, 57, 26}, {65, 65, 120}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 65, 121}, {66, 122, -23}, },
            {{48, 83, -37}, {84, 84, 122}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 123}, {70, 122, -36}, },
            {{48, 57, 26}, {65, 65, 124}, {66, 81, 27}, {82, 82, 125}, {83, 122, -19}, },
            {{48, 82, -22}, {83, 83, 126}, {84, 122, -11}, },
            {{48, 67, -35}, {68, 68, 127}, {69, 122, -35}, },
            {{48, 76, -15}, {77, 77, 128}, {78, 90, 27}, {95, 122, -11}, },
            {{48, 83, -37}, {84, 84, 129}, {85, 122, -37}, },
            {{48, 67, -35}, {68, 68, 130}, {69, 122, -35}, },
            {{48, 57, 26}, {65, 65, 131}, {66, 122, -23}, },
            {{48, 72, -68}, {73, 73, 132}, {74, 122, -68}, },
            {{48, 90, -12}, {95, 95, 133}, {97, 122, 31}, },
            {{48, 77, -14}, {78, 78, 134}, {79, 122, -15}, },
            {{48, 122, -12}, },
            {{48, 83, -37}, {84, 84, 135}, {85, 122, -37}, },
            {{48, 83, -37}, {84, 84, 136}, {85, 122, -37}, },
            {{48, 81, -19}, {82, 82, 137}, {83, 122, -19}, },
            {{48, 68, -20}, {69, 69, 138}, {70, 122, -36}, },
            {{48, 90, -12}, {95, 95, 139}, {97, 122, 31}, },
            {{48, 76, -15}, {77, 77, 140}, {78, 122, -107}, },
            {{48, 82, -22}, {83, 83, 141}, {84, 122, -11}, },
            {{48, 65, -11}, {66, 66, 142}, {67, 90, 27}, {95, 122, -11}, },
            {{48, 66, -39}, {67, 67, 143}, {68, 122, -40}, },
            {{48, 72, -68}, {73, 73, 144}, {74, 122, -68}, },
            {{48, 83, -37}, {84, 84, 145}, {85, 122, -37}, },
            {{48, 77, -14}, {78, 78, 146}, {79, 122, -15}, },
            {{48, 57, 26}, {65, 65, 147}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 148}, {84, 122, -11}, },
            {{48, 68, -20}, {69, 69, 149}, {70, 122, -36}, },
            {{48, 82, -22}, {83, 83, 150}, {84, 122, -11}, },
            {{48, 68, -20}, {69, 69, 151}, {70, 122, -36}, },
            {{48, 75, -46}, {76, 76, 152}, {77, 122, -46}, },
            {{48, 57, 26}, {65, 65, 153}, {66, 122, -23}, },
            {{48, 78, -13}, {79, 79, 154}, {80, 122, -13}, },
            {{48, 68, -20}, {69, 69, 155}, {70, 122, -36}, },
            {{48, 72, -68}, {73, 73, 156}, {74, 122, -68}, },
            {{48, 68, -20}, {69, 69, 157}, {70, 122, -36}, },
            {{48, 83, -37}, {84, 84, 158}, {85, 122, -37}, },
            {{48, 76, -15}, {77, 77, 159}, {78, 82, 27}, {83, 83, 160}, {84, 122, -11}, },
            {{48, 76, -15}, {77, 77, 161}, {78, 122, -107}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 75, -46}, {76, 76, 162}, {77, 122, -46}, },
            {{48, 83, -37}, {84, 84, 163}, {85, 122, -37}, },
            {{48, 78, -13}, {79, 79, 164}, {80, 122, -13}, },
            {{48, 68, -20}, {69, 69, 165}, {70, 122, -36}, },
            {{48, 83, -37}, {84, 84, 166}, {85, 122, -37}, },
            {{48, 72, -68}, {73, 73, 167}, {74, 122, -68}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 168}, {79, 122, -15}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 169}, {84, 122, -11}, },
            {{48, 72, -68}, {73, 73, 170}, {74, 122, -68}, },
            {{48, 77, -14}, {78, 78, 171}, {79, 122, -15}, },
            {{48, 79, -18}, {80, 80, 172}, {81, 122, -18}, },
            {{48, 122, -12}, },
            {{48, 78, -13}, {79, 79, 173}, {80, 122, -13}, },
            {{48, 82, -22}, {83, 83, 174}, {84, 122, -11}, },
            {{48, 72, -68}, {73, 73, 175}, {74, 122, -68}, },
            {{48, 68, -20}, {69, 69, 176}, {70, 122, -36}, },
            {{48, 122, -12}, },
            {{48, 57, 26}, {65, 65, 177}, {66, 122, -23}, },
            {{48, 68, -20}, {69, 69, 178}, {70, 122, -36}, },
            {{48, 90, -12}, {95, 95, 179}, {97, 122, 31}, },
            {{48, 77, -14}, {78, 78, 180}, {79, 122, -15}, },
            {{48, 90, -12}, {95, 95, 181}, {97, 122, 31}, },
            {{48, 82, -22}, {83, 83, 182}, {84, 122, -11}, },
            {{48, 77, -14}, {78, 78, 183}, {79, 122, -15}, },
            {{48, 83, -37}, {84, 84, 184}, {85, 122, -37}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 185}, {84, 89, 27}, {90, 90, 186}, {95, 122, -11}, },
            {{48, 83, -37}, {84, 84, 187}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 188}, {70, 122, -36}, },
            {{48, 77, -14}, {78, 78, 189}, {79, 122, -15}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 190}, {70, 122, -36}, },
            {{48, 77, -14}, {78, 78, 191}, {79, 122, -15}, },
            {{48, 66, -39}, {67, 67, 192}, {68, 122, -40}, },
            {{48, 82, -22}, {83, 83, 193}, {84, 122, -11}, },
            {{48, 66, -39}, {67, 67, 194}, {68, 85, 27}, {86, 86, 195}, {87, 122, -39}, },
            {{48, 82, -22}, {83, 83, 196}, {84, 122, -11}, },
            {{48, 66, -39}, {67, 67, 197}, {68, 85, 27}, {86, 86, 198}, {87, 122, -39}, },
            {{48, 122, -12}, },
            {{48, 83, -37}, {84, 84, 199}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 200}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 65, 201}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 65, 202}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 81, -19}, {82, 82, 203}, {83, 122, -19}, },
            {{48, 82, -22}, {83, 83, 204}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 205}, {84, 122, -11}, },
            {{48, 83, -37}, {84, 84, 206}, {85, 122, -37}, },
            {{48, 71, -64}, {72, 72, 207}, {73, 122, -64}, },
            {{48, 122, -12}, },
            {{48, 78, -13}, {79, 79, 208}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 65, 209}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 78, -13}, {79, 79, 210}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 65, 211}, {66, 122, -23}, },
            {{48, 82, -22}, {83, 83, 212}, {84, 122, -11}, },
            {{48, 83, -37}, {84, 84, 213}, {85, 122, -37}, },
            {{48, 83, -37}, {84, 84, 214}, {85, 122, -37}, },
            {{48, 83, -37}, {84, 84, 215}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 216}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 72, -68}, {73, 73, 217}, {74, 122, -68}, },
            {{48, 77, -14}, {78, 78, 218}, {79, 122, -15}, },
            {{48, 81, -19}, {82, 82, 219}, {83, 122, -19}, },
            {{48, 77, -14}, {78, 78, 220}, {79, 122, -15}, },
            {{48, 81, -19}, {82, 82, 221}, {83, 122, -19}, },
            {{48, 122, -12}, },
            {{48, 72, -68}, {73, 73, 222}, {74, 122, -68}, },
            {{48, 72, -68}, {73, 73, 223}, {74, 122, -68}, },
            {{48, 72, -68}, {73, 73, 224}, {74, 122, -68}, },
            {{48, 83, -37}, {84, 84, 225}, {85, 122, -37}, },
            {{48, 77, -14}, {78, 78, 226}, {79, 122, -15}, },
            {{48, 82, -22}, {83, 83, 227}, {84, 122, -11}, },
            {{48, 72, -68}, {73, 73, 228}, {74, 122, -68}, },
            {{48, 82, -22}, {83, 83, 229}, {84, 122, -11}, },
            {{48, 72, -68}, {73, 73, 230}, {74, 122, -68}, },
            {{48, 78, -13}, {79, 79, 231}, {80, 122, -13}, },
            {{48, 78, -13}, {79, 79, 232}, {80, 122, -13}, },
            {{48, 78, -13}, {79, 79, 233}, {80, 122, -13}, },
            {{48, 72, -68}, {73, 73, 234}, {74, 122, -68}, },
            {{48, 68, -20}, {69, 69, 235}, {70, 122, -36}, },
            {{48, 83, -37}, {84, 84, 236}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 237}, {66, 122, -23}, },
            {{48, 83, -37}, {84, 84, 238}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 239}, {66, 122, -23}, },
            {{48, 77, -14}, {78, 78, 240}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 241}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 242}, {79, 122, -15}, },
            {{48, 78, -13}, {79, 79, 243}, {80, 122, -13}, },
            {{48, 122, -12}, },
            {{48, 57, 26}, {65, 65, 244}, {66, 122, -23}, },
            {{48, 65, -11}, {66, 66, 245}, {67, 122, -122}, },
            {{48, 57, 26}, {65, 65, 246}, {66, 122, -23}, },
            {{48, 65, -11}, {66, 66, 247}, {67, 122, -122}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 248}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 249}, {79, 122, -15}, },
            {{48, 75, -46}, {76, 76, 250}, {77, 122, -46}, },
            {{48, 77, -14}, {78, 78, 251}, {79, 122, -15}, },
            {{48, 75, -46}, {76, 76, 252}, {77, 122, -46}, },
            {{48, 82, -22}, {83, 83, 253}, {84, 122, -11}, },
            {{48, 83, -37}, {84, 84, 254}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 255}, {70, 122, -36}, },
            {{48, 83, -37}, {84, 84, 256}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 257}, {70, 122, -36}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 258}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 259}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 260}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 261}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
        }
        { // DEFINITIONS_RHS
            {{0, 32, 1}, {33, 33, 2}, {34, 34, 3}, {35, 38, 2}, {39, 39, 4}, {40, 40, 5}, {41, 41, 6}, {42, 46, 2}, {47, 47, 7}, {48, 58, 2}, {59, 59, 8}, {60, 64, 2}, {65, 65, 9}, {66, 66, 10}, {67, 67, 11}, {68, 68, 12}, {69, 69, 13}, {70, 72, 12}, {73, 73, 14}, {74, 75, 12}, {76, 76, 15}, {77, 77, 16}, {78, 78, 12}, {79, 79, 17}, {80, 80, 18}, {81, 81, 12}, {82, 82, 19}, {83, 83, 20}, {84, 84, 12}, {85, 85, 21}, {86, 86, 22}, {87, 87, 23}, {88, 90, 12}, {91, 96, 2}, {97, 122, 24}, {123, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 32, 1}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {},
            {{0, 9, 25}, {11, 12, 25}, {14, 33, 25}, {34, 34, 26}, {35, 91, 25}, {92, 92, 27}, {93, 65535, 25}, },
            {{39, 39, 28}, },
            {},
            {},
            {{42, 42, 29}, {47, 47, 30}, },
            {},
            {{48, 57, 31}, {65, 65, 32}, {66, 66, 33}, {67, 77, 32}, {78, 78, 34}, {79, 82, 32}, {83, 83, 35}, {84, 90, 32}, {95, 95, 36}, {97, 122, 37}, },
            {{48, 57, 31}, {65, 68, 32}, {69, 69, 38}, {70, 90, 32}, {95, 122, -11}, },
            {{48, 57, 31}, {65, 65, 39}, {66, 71, 32}, {72, 72, 40}, {73, 78, 32}, {79, 79, 41}, {80, 90, 32}, {95, 122, -11}, },
            {{48, 57, 31}, {65, 90, 32}, {95, 122, -11}, },
            {{48, 57, 31}, {65, 77, 32}, {78, 78, 42}, {79, 85, 32}, {86, 86, 43}, {87, 87, 32}, {88, 88, 44}, {89, 90, 32}, {95, 122, -11}, },
            {{48, 57, 31}, {65, 69, 32}, {70, 70, 45}, {71, 76, 32}, {77, 77, 46}, {78, 78, 47}, {79, 90, 32}, {95, 122, -11}, },
            {{48, 68, -12}, {69, 69, 48}, {70, 78, 32}, {79, 79, 49}, {80, 122, -13}, },
            {{48, 57, 31}, {65, 65, 50}, {66, 78, 32}, {79, 79, 51}, {80, 122, -13}, },
            {{48, 57, 31}, {65, 79, 32}, {80, 80, 52}, {81, 90, 32}, {95, 122, -11}, },
            {{48, 57, 31}, {65, 81, 32}, {82, 82, 53}, {83, 90, 32}, {95, 122, -11}, },
            {{48, 68, -12}, {69, 69, 54}, {70, 84, 32}, {85, 85, 55}, {86, 90, 32}, {95, 122, -11}, },
            {{48, 68, -12}, {69, 69, 56}, {70, 88, 32}, {89, 89, 57}, {90, 90, 32}, {95, 122, -11}, },
            {{48, 57, 31}, {65, 82, 32}, {83, 83, 58}, {84, 122, -11}, },
            {{48, 57, 31}, {65, 65, 59}, {66, 90, 32}, {95, 122, -11}, },
            {{48, 57, 31}, {65, 71, 32}, {72, 72, 60}, {73, 90, 32}, {95, 122, -11}, },
            {{48, 122, -14}, },
            {{0, 65535, -5}, },
            {},
            {{0, 33, -5}, {34, 34, 61}, {35, 65535, -5}, },
            {{39, 39, 62}, },
            {},
            {{0, 9, 63}, {10, 10, 64}, {11, 12, 63}, {13, 13, 64}, {14, 65535, 63}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
            {{48, 82, -23}, {83, 83, 65}, {84, 122, -11}, },
            {{48, 57, 31}, {65, 88, 32}, {89, 89, 66}, {90, 122, -22}, },
            {{48, 82, -23}, {83, 83, 67}, {84, 122, -11}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
            {{48, 57, 31}, {65, 70, 32}, {71, 71, 68}, {72, 90, 32}, {95, 122, -11}, },
            {{48, 82, -23}, {83, 83, 69}, {84, 122, -11}, },
            {{48, 57, 31}, {65, 78, 32}, {79, 79, 70}, {80, 122, -13}, },
            {{48, 77, -15}, {78, 78, 71}, {79, 122, -16}, },
            {{48, 57, 31}, {65, 67, 32}, {68, 68, 72}, {69, 90, 32}, {95, 122, -11}, },
            {{48, 68, -12}, {69, 69, 73}, {70, 122, -12}, },
            {{48, 57, 31}, {65, 83, 32}, {84, 84, 74}, {85, 90, 32}, {95, 122, -11}, },
            {{48, 122, -14}, },
            {{48, 79, -19}, {80, 80, 75}, {81, 122, -19}, },
            {{48, 57, 31}, {65, 66, 32}, {67, 67, 76}, {68, 72, 32}, {73, 73, 77}, {74, 85, 32}, {86, 86, 78}, {87, 90, 32}, {95, 122, -11}, },
            {{48, 83, -46}, {84, 84, 79}, {85, 122, -46}, },
            {{48, 66, -49}, {67, 67, 80}, {68, 90, 32}, {95, 122, -11}, },
            {{48, 66, -49}, {67, 67, 81}, {68, 122, -51}, },
            {{48, 67, -44}, {68, 68, 82}, {69, 122, -44}, },
            {{48, 68, -12}, {69, 69, 83}, {70, 122, -12}, },
            {{48, 68, -12}, {69, 69, 84}, {70, 78, 32}, {79, 79, 85}, {80, 122, -13}, },
            {{48, 69, -16}, {70, 70, 86}, {71, 90, 32}, {95, 122, -11}, },
            {{48, 57, 31}, {65, 75, 32}, {76, 76, 87}, {77, 90, 32}, {95, 122, -11}, },
            {{48, 68, -12}, {69, 69, 88}, {70, 75, 32}, {76, 76, 89}, {77, 83, 32}, {84, 84, 90}, {85, 122, -46}, },
            {{48, 82, -23}, {83, 83, 91}, {84, 122, -11}, },
            {{48, 68, -12}, {69, 69, 92}, {70, 122, -12}, },
            {{48, 75, -57}, {76, 76, 93}, {77, 81, 32}, {82, 82, 94}, {83, 122, -20}, },
            {{48, 57, 31}, {65, 72, 32}, {73, 73, 95}, {74, 90, 32}, {95, 122, -11}, },
            {{0, 65535, -5}, },
            {},
            {{0, 65535, -32}, },
            {},
            {{48, 83, -46}, {84, 84, 96}, {85, 122, -46}, },
            {{48, 122, -14}, },
            {{48, 68, -12}, {69, 69, 97}, {70, 122, -12}, },
            {{48, 72, -62}, {73, 73, 98}, {74, 122, -62}, },
            {{48, 68, -12}, {69, 69, 99}, {70, 122, -12}, },
            {{48, 72, -62}, {73, 73, 100}, {74, 122, -62}, },
            {{48, 66, -49}, {67, 67, 101}, {68, 82, 32}, {83, 83, 102}, {84, 122, -11}, },
            {{48, 122, -14}, },
            {{48, 77, -15}, {78, 78, 103}, {79, 122, -16}, },
            {{48, 68, -12}, {69, 69, 104}, {70, 122, -12}, },
            {{48, 75, -57}, {76, 76, 105}, {77, 78, 32}, {79, 79, 106}, {80, 122, -13}, },
            {{48, 75, -57}, {76, 76, 107}, {77, 122, -57}, },
            {{48, 83, -46}, {84, 84, 108}, {85, 122, -46}, },
            {{48, 57, 31}, {65, 65, 109}, {66, 122, -24}, },
            {{48, 122, -14}, },
            {{48, 57, 31}, {65, 65, 110}, {66, 122, -24}, },
            {{48, 71, -25}, {72, 72, 111}, {73, 122, -25}, },
            {{48, 68, -12}, {69, 69, 112}, {70, 122, -12}, },
            {{48, 81, -20}, {82, 82, 113}, {83, 122, -20}, },
            {{48, 122, -14}, },
            {{48, 57, 31}, {65, 76, 32}, {77, 77, 114}, {78, 79, 32}, {80, 80, 115}, {81, 122, -19}, },
            {{48, 72, -62}, {73, 73, 116}, {74, 122, -62}, },
            {{48, 68, -12}, {69, 69, 117}, {70, 122, -12}, },
            {{48, 82, -23}, {83, 83, 118}, {84, 122, -11}, },
            {{48, 68, -12}, {69, 69, 119}, {70, 122, -12}, },
            {{48, 82, -23}, {83, 83, 120}, {84, 122, -11}, },
            {{48, 83, -46}, {84, 84, 121}, {85, 122, -46}, },
            {{48, 82, -23}, {83, 83, 122}, {84, 122, -11}, },
            {{48, 57, 31}, {65, 84, 32}, {85, 85, 123}, {86, 122, -21}, },
            {{48, 72, -62}, {73, 73, 124}, {74, 122, -62}, },
            {{48, 75, -57}, {76, 76, 125}, {77, 122, -57}, },
            {{48, 81, -20}, {82, 82, 126}, {83, 122, -20}, },
            {{48, 81, -20}, {82, 82, 127}, {83, 122, -20}, },
            {{48, 77, -15}, {78, 78, 128}, {79, 122, -16}, },
            {{48, 122, -14}, },
            {{48, 66, -49}, {67, 67, 129}, {68, 122, -51}, },
            {{48, 81, -20}, {82, 82, 130}, {83, 122, -20}, },
            {{48, 83, -46}, {84, 84, 131}, {85, 122, -46}, },
            {{48, 83, -46}, {84, 84, 132}, {85, 122, -46}, },
            {{48, 77, -15}, {78, 78, 133}, {79, 122, -16}, },
            {{48, 68, -12}, {69, 69, 134}, {70, 122, -12}, },
            {{48, 81, -20}, {82, 82, 135}, {83, 122, -20}, },
            {{48, 84, -95}, {85, 85, 136}, {86, 122, -21}, },
            {{48, 72, -62}, {73, 73, 137}, {74, 122, -62}, },
            {{48, 81, -20}, {82, 82, 138}, {83, 122, -20}, },
            {{48, 75, -57}, {76, 76, 139}, {77, 122, -57}, },
            {{48, 72, -62}, {73, 73, 140}, {74, 122, -62}, },
            {{48, 75, -57}, {76, 76, 141}, {77, 122, -57}, },
            {{48, 57, 31}, {65, 65, 142}, {66, 122, -24}, },
            {{48, 78, -42}, {79, 79, 143}, {80, 122, -13}, },
            {{48, 68, -12}, {69, 69, 144}, {70, 122, -12}, },
            {{48, 77, -15}, {78, 78, 145}, {79, 122, -16}, },
            {{48, 82, -23}, {83, 83, 146}, {84, 122, -11}, },
            {{48, 122, -14}, },
            {{48, 66, -49}, {67, 67, 147}, {68, 122, -51}, },
            {{48, 122, -14}, },
            {{48, 68, -12}, {69, 69, 148}, {70, 122, -12}, },
            {{48, 122, -14}, },
            {{48, 68, -12}, {69, 69, 149}, {70, 122, -12}, },
            {{48, 57, 31}, {65, 65, 150}, {66, 122, -24}, },
            {{48, 68, -12}, {69, 69, 151}, {70, 122, -12}, },
            {{48, 57, 31}, {65, 65, 152}, {66, 122, -24}, },
            {{48, 83, -46}, {84, 84, 153}, {85, 122, -46}, },
            {{48, 122, -14}, },
            {{48, 68, -12}, {69, 69, 154}, {70, 122, -12}, },
            {{48, 68, -12}, {69, 69, 155}, {70, 122, -12}, },
            {{48, 57, 31}, {65, 65, 156}, {66, 81, 32}, {82, 82, 157}, {83, 122, -20}, },
            {{48, 82, -23}, {83, 83, 158}, {84, 122, -11}, },
            {{48, 67, -44}, {68, 68, 159}, {69, 122, -44}, },
            {{48, 76, -87}, {77, 77, 160}, {78, 90, 32}, {95, 122, -11}, },
            {{48, 83, -46}, {84, 84, 161}, {85, 122, -46}, },
            {{48, 67, -44}, {68, 68, 162}, {69, 122, -44}, },
            {{48, 57, 31}, {65, 65, 163}, {66, 122, -24}, },
            {{48, 72, -62}, {73, 73, 164}, {74, 122, -62}, },
            {{48, 90, -14}, {95, 95, 165}, {97, 122, 37}, },
            {{48, 77, -15}, {78, 78, 166}, {79, 122, -16}, },
            {{48, 122, -14}, },
            {{48, 83, -46}, {84, 84, 167}, {85, 122, -46}, },
            {{48, 83, -46}, {84, 84, 168}, {85, 122, -46}, },
            {{48, 81, -20}, {82, 82, 169}, {83, 122, -20}, },
            {{48, 68, -12}, {69, 69, 170}, {70, 122, -12}, },
            {{48, 90, -14}, {95, 95, 171}, {97, 122, 37}, },
            {{48, 83, -46}, {84, 84, 172}, {85, 122, -46}, },
            {{48, 76, -87}, {77, 77, 173}, {78, 122, -136}, },
            {{48, 82, -23}, {83, 83, 174}, {84, 122, -11}, },
            {{48, 65, -11}, {66, 66, 175}, {67, 90, 32}, {95, 122, -11}, },
            {{48, 122, -14}, },
            {{48, 66, -49}, {67, 67, 176}, {68, 122, -51}, },
            {{48, 72, -62}, {73, 73, 177}, {74, 122, -62}, },
            {{48, 122, -14}, },
            {{48, 83, -46}, {84, 84, 178}, {85, 122, -46}, },
            {{48, 77, -15}, {78, 78, 179}, {79, 122, -16}, },
            {{48, 57, 31}, {65, 65, 180}, {66, 122, -24}, },
            {{48, 122, -14}, },
            {{48, 82, -23}, {83, 83, 181}, {84, 122, -11}, },
            {{48, 68, -12}, {69, 69, 182}, {70, 122, -12}, },
            {{48, 82, -23}, {83, 83, 183}, {84, 122, -11}, },
            {{48, 68, -12}, {69, 69, 184}, {70, 122, -12}, },
            {{48, 75, -57}, {76, 76, 185}, {77, 122, -57}, },
            {{48, 57, 31}, {65, 65, 186}, {66, 122, -24}, },
            {{48, 78, -42}, {79, 79, 187}, {80, 122, -13}, },
            {{48, 68, -12}, {69, 69, 188}, {70, 122, -12}, },
            {{48, 72, -62}, {73, 73, 189}, {74, 122, -62}, },
            {{48, 68, -12}, {69, 69, 190}, {70, 122, -12}, },
            {{48, 83, -46}, {84, 84, 191}, {85, 122, -46}, },
            {{48, 76, -87}, {77, 77, 192}, {78, 82, 32}, {83, 83, 193}, {84, 122, -11}, },
            {{48, 76, -87}, {77, 77, 194}, {78, 122, -136}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
            {{48, 75, -57}, {76, 76, 195}, {77, 122, -57}, },
            {{48, 83, -46}, {84, 84, 196}, {85, 122, -46}, },
            {{48, 78, -42}, {79, 79, 197}, {80, 122, -13}, },
            {{48, 68, -12}, {69, 69, 198}, {70, 122, -12}, },
            {{48, 83, -46}, {84, 84, 199}, {85, 122, -46}, },
            {{48, 72, -62}, {73, 73, 200}, {74, 122, -62}, },
            {{48, 122, -14}, },
            {{48, 77, -15}, {78, 78, 201}, {79, 122, -16}, },
            {{48, 122, -14}, },
            {{48, 82, -23}, {83, 83, 202}, {84, 122, -11}, },
            {{48, 72, -62}, {73, 73, 203}, {74, 122, -62}, },
            {{48, 77, -15}, {78, 78, 204}, {79, 122, -16}, },
            {{48, 79, -19}, {80, 80, 205}, {81, 122, -19}, },
            {{48, 122, -14}, },
            {{48, 78, -42}, {79, 79, 206}, {80, 122, -13}, },
            {{48, 82, -23}, {83, 83, 207}, {84, 122, -11}, },
            {{48, 72, -62}, {73, 73, 208}, {74, 122, -62}, },
            {{48, 68, -12}, {69, 69, 209}, {70, 122, -12}, },
            {{48, 122, -14}, },
            {{48, 57, 31}, {65, 65, 210}, {66, 122, -24}, },
            {{48, 68, -12}, {69, 69, 211}, {70, 122, -12}, },
            {{48, 90, -14}, {95, 95, 212}, {97, 122, 37}, },
            {{48, 77, -15}, {78, 78, 213}, {79, 122, -16}, },
            {{48, 90, -14}, {95, 95, 214}, {97, 122, 37}, },
            {{48, 82, -23}, {83, 83, 215}, {84, 122, -11}, },
            {{48, 77, -15}, {78, 78, 216}, {79, 122, -16}, },
            {{48, 83, -46}, {84, 84, 217}, {85, 122, -46}, },
            {{48, 122, -14}, },
            {{48, 82, -23}, {83, 83, 218}, {84, 89, 32}, {90, 90, 219}, {95, 122, -11}, },
            {{48, 83, -46}, {84, 84, 220}, {85, 122, -46}, },
            {{48, 68, -12}, {69, 69, 221}, {70, 122, -12}, },
            {{48, 77, -15}, {78, 78, 222}, {79, 122, -16}, },
            {{48, 122, -14}, },
            {{48, 68, -12}, {69, 69, 223}, {70, 122, -12}, },
            {{48, 77, -15}, {78, 78, 224}, {79, 122, -16}, },
            {{48, 66, -49}, {67, 67, 225}, {68, 122, -51}, },
            {{48, 82, -23}, {83, 83, 226}, {84, 122, -11}, },
            {{48, 66, -49}, {67, 67, 227}, {68, 85, 32}, {86, 86, 228}, {87, 122, -49}, },
            {{48, 82, -23}, {83, 83, 229}, {84, 122, -11}, },
            {{48, 66, -49}, {67, 67, 230}, {68, 85, 32}, {86, 86, 231}, {87, 122, -49}, },
            {{48, 122, -14}, },
            {{48, 83, -46}, {84, 84, 232}, {85, 122, -46}, },
            {{48, 57, 31}, {65, 65, 233}, {66, 122, -24}, },
            {{48, 57, 31}, {65, 65, 234}, {66, 122, -24}, },
            {{48, 57, 31}, {65, 65, 235}, {66, 122, -24}, },
            {{48, 122, -14}, },
            {{48, 81, -20}, {82, 82, 236}, {83, 122, -20}, },
            {{48, 82, -23}, {83, 83, 237}, {84, 122, -11}, },
            {{48, 82, -23}, {83, 83, 238}, {84, 122, -11}, },
            {{48, 83, -46}, {84, 84, 239}, {85, 122, -46}, },
            {{48, 71, -25}, {72, 72, 240}, {73, 122, -25}, },
            {{48, 122, -14}, },
            {{48, 78, -42}, {79, 79, 241}, {80, 122, -13}, },
            {{48, 57, 31}, {65, 65, 242}, {66, 122, -24}, },
            {{48, 122, -14}, },
            {{48, 78, -42}, {79, 79, 243}, {80, 122, -13}, },
            {{48, 57, 31}, {65, 65, 244}, {66, 122, -24}, },
            {{48, 82, -23}, {83, 83, 245}, {84, 122, -11}, },
            {{48, 83, -46}, {84, 84, 246}, {85, 122, -46}, },
            {{48, 83, -46}, {84, 84, 247}, {85, 122, -46}, },
            {{48, 83, -46}, {84, 84, 248}, {85, 122, -46}, },
            {{48, 57, 31}, {65, 65, 249}, {66, 122, -24}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
            {{48, 72, -62}, {73, 73, 250}, {74, 122, -62}, },
            {{48, 77, -15}, {78, 78, 251}, {79, 122, -16}, },
            {{48, 81, -20}, {82, 82, 252}, {83, 122, -20}, },
            {{48, 77, -15}, {78, 78, 253}, {79, 122, -16}, },
            {{48, 81, -20}, {82, 82, 254}, {83, 122, -20}, },
            {{48, 122, -14}, },
            {{48, 72, -62}, {73, 73, 255}, {74, 122, -62}, },
            {{48, 72, -62}, {73, 73, 256}, {74, 122, -62}, },
            {{48, 72, -62}, {73, 73, 257}, {74, 122, -62}, },
            {{48, 83, -46}, {84, 84, 258}, {85, 122, -46}, },
            {{48, 77, -15}, {78, 78, 259}, {79, 122, -16}, },
            {{48, 82, -23}, {83, 83, 260}, {84, 122, -11}, },
            {{48, 72, -62}, {73, 73, 261}, {74, 122, -62}, },
            {{48, 82, -23}, {83, 83, 262}, {84, 122, -11}, },
            {{48, 72, -62}, {73, 73, 263}, {74, 122, -62}, },
            {{48, 78, -42}, {79, 79, 264}, {80, 122, -13}, },
            {{48, 78, -42}, {79, 79, 265}, {80, 122, -13}, },
            {{48, 78, -42}, {79, 79, 266}, {80, 122, -13}, },
            {{48, 72, -62}, {73, 73, 267}, {74, 122, -62}, },
            {{48, 68, -12}, {69, 69, 268}, {70, 122, -12}, },
            {{48, 83, -46}, {84, 84, 269}, {85, 122, -46}, },
            {{48, 57, 31}, {65, 65, 270}, {66, 122, -24}, },
            {{48, 83, -46}, {84, 84, 271}, {85, 122, -46}, },
            {{48, 57, 31}, {65, 65, 272}, {66, 122, -24}, },
            {{48, 77, -15}, {78, 78, 273}, {79, 122, -16}, },
            {{48, 77, -15}, {78, 78, 274}, {79, 122, -16}, },
            {{48, 77, -15}, {78, 78, 275}, {79, 122, -16}, },
            {{48, 78, -42}, {79, 79, 276}, {80, 122, -13}, },
            {{48, 122, -14}, },
            {{48, 57, 31}, {65, 65, 277}, {66, 122, -24}, },
            {{48, 65, -11}, {66, 66, 278}, {67, 122, -152}, },
            {{48, 57, 31}, {65, 65, 279}, {66, 122, -24}, },
            {{48, 65, -11}, {66, 66, 280}, {67, 122, -152}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
            {{48, 77, -15}, {78, 78, 281}, {79, 122, -16}, },
            {{48, 77, -15}, {78, 78, 282}, {79, 122, -16}, },
            {{48, 75, -57}, {76, 76, 283}, {77, 122, -57}, },
            {{48, 77, -15}, {78, 78, 284}, {79, 122, -16}, },
            {{48, 75, -57}, {76, 76, 285}, {77, 122, -57}, },
            {{48, 82, -23}, {83, 83, 286}, {84, 122, -11}, },
            {{48, 83, -46}, {84, 84, 287}, {85, 122, -46}, },
            {{48, 68, -12}, {69, 69, 288}, {70, 122, -12}, },
            {{48, 83, -46}, {84, 84, 289}, {85, 122, -46}, },
            {{48, 68, -12}, {69, 69, 290}, {70, 122, -12}, },
            {{48, 122, -14}, },
            {{48, 82, -23}, {83, 83, 291}, {84, 122, -11}, },
            {{48, 82, -23}, {83, 83, 292}, {84, 122, -11}, },
            {{48, 82, -23}, {83, 83, 293}, {84, 122, -11}, },
            {{48, 82, -23}, {83, 83, 294}, {84, 122, -11}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
        }
        { // DEFINITION_FILE
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 33, 3}, {34, 34, 4}, {35, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 33, -2}, {35, 65535, -2}, },
            {{0, 32, 2}, {127, 160, 2}, {8206, 8207, 2}, {8232, 8233, 2}, },
            {{0, 9, 3}, {11, 12, 3}, {14, 33, 3}, {35, 65535, 3}, },
            {},
        }
        { // NO_DEFINITIONS
            {{0, 32, 1}, {33, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 65535, -2}, },
            {{0, 65535, 2}, },
        }
        { // COMMENT
            {{0, 32, 1}, {33, 41, 2}, {42, 42, 3}, {43, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 32, 4}, {127, 160, 4}, {8206, 8207, 4}, {8232, 8233, 4}, },
            {},
            {{47, 47, 5}, },
            {{0, 8233, -3}, },
            {},
        }
        { // MULTILINE_STRING_STATE
            {{0, 32, 1}, {33, 38, 2}, {39, 39, 3}, {40, 91, 2}, {92, 92, 4}, {93, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 38, -2}, {39, 39, 5}, {40, 65535, -2}, },
            {{0, 38, 2}, {39, 92, -3}, {93, 65535, 2}, },
            {{0, 38, 6}, {39, 39, 7}, {40, 65535, 6}, },
            {{0, 38, 2}, {39, 39, 8}, {40, 65535, -4}, },
            {{0, 38, 6}, {39, 39, 9}, {40, 65535, 6}, },
            {{0, 65535, -4}, },
            {{0, 38, 10}, {39, 39, 11}, {40, 65535, 10}, },
            {{0, 38, 12}, {39, 39, 13}, {40, 91, 12}, {92, 92, 14}, {93, 65535, 12}, },
            {{0, 38, 10}, {40, 65535, 10}, },
            {{0, 65535, -4}, },
            {},
            {{0, 65535, -4}, },
            {{0, 38, 15}, {39, 39, 9}, {40, 65535, 15}, },
            {{0, 65535, -6}, },
            {{0, 65535, -4}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // NORMAL
        {-1, 26, 26, -1, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 27, -1, 26, -1, -1, -1, -1, -1, -1, 0, 6, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, -1, -1, -1, -1, 3, 6, 6, 26, 26, 26, 26, 9, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, -1, -1, -1, -1, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 8, 8, 26, 8, 26, 26, -1, -1, -1, -1, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 8, 26, 26, 26, 26, 26, 26, 26, 26, -1, -1, -1, -1, 26, 26, 26, 26, 26, 26, 8, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 8, 8, 26, -1, -1, -1, -1, 26, 26, 26, 26, 26, 26, 8, 26, 8, 26, 26, 26, 26, 8, 26, 26, 26, 26, 8, 26, 26, -1, -1, -1, -1, 26, 26, 26, 26, 26, 26, 26, 8, 26, 26, 26, 26, 8, 26, 26, 26, 26, -1, -1, -1, -1, 26, 26, 26, 8, 26, 26, 26, 26, 26, 8, 26, 26, 26, 26, 26, 8, -1, -1, 11, -1, 26, 26, 8, 26, 26, 26, 26, 26, 26, 26, 26, 8, 8, 8, 26, -1, 11, -1, 26, 26, 26, 26, 8, 7, 26, 26, 26, 26, 26, 10, -1, 26, 26, 26, 26, 26, 26, 26, 26, 26, 11, 26, 26, 26, 26, 26, 26, 26, 26, 8, 26, 26, 26, 26, 8, 8, 8, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 8, 26, 26, 26, 26, 8, 8, 8, 8, },
        // DEFINITIONS
        {-1, 27, 24, 14, 15, 17, 16, 23, -1, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 0, 6, 18, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 6, 6, 13, 13, 13, 9, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 8, 8, 13, 8, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 8, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 8, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 8, 8, 13, 13, 13, 13, 13, 13, 8, 13, 8, 13, 13, 13, 13, 8, 13, 13, 13, 13, 8, 13, 13, 13, 13, 13, 13, 13, 13, 8, 13, 13, 13, 13, 8, 13, 13, 13, 13, 13, 13, 13, 8, 13, 13, 13, 13, 8, 13, 13, 13, 13, 13, 8, 13, 13, 8, 13, 13, 13, 13, 13, 13, 13, 8, 8, 8, 13, 13, 13, 13, 13, 8, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 8, 13, 13, 13, 13, 8, 8, 8, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 8, 13, 13, 13, 13, 8, 8, 8, 8, },
        // DEFINITIONS_RHS
        {-1, 27, 19, -1, 19, 14, 15, 16, 23, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, -1, 19, -1, -1, 0, 6, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 19, 3, 6, 6, 22, 20, 22, 22, 22, 22, 22, 21, 22, 22, 22, 22, 22, 22, 20, 22, 22, 22, 22, 20, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 22, 22, 22, 22, 20, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 8, 22, 8, 22, 8, 22, 22, 22, 22, 22, 20, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 8, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 22, 20, 20, 22, 22, 22, 8, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 20, 8, 8, 22, 22, 22, 22, 22, 22, 8, 22, 8, 22, 22, 22, 22, 8, 22, 22, 22, 22, 8, 22, 22, 22, 22, 22, 22, 22, 22, 8, 22, 22, 22, 22, 8, 22, 22, 22, 22, 22, 22, 22, 8, 22, 22, 22, 22, 8, 22, 22, 22, 22, 22, 8, 22, 22, 8, 22, 22, 22, 22, 22, 22, 22, 8, 8, 8, 22, 22, 22, 22, 22, 8, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 8, 22, 22, 22, 22, 8, 8, 8, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 8, 22, 22, 22, 22, 8, 8, 8, 8, },
        // DEFINITION_FILE
        {25, 25, 27, 25, 24, },
        // NO_DEFINITIONS
        {12, 12, 12, },
        // COMMENT
        {-1, 2, 2, 2, 27, 1, },
        // MULTILINE_STRING_STATE
        {5, 5, 5, -1, 5, -1, 5, -1, 5, -1, 5, 4, 5, -1, 5, 5, },

    };*/

    public static class State
    {
        public final static State NORMAL = new State(0);
        public final static State DEFINITIONS = new State(1);
        public final static State DEFINITIONS_RHS = new State(2);
        public final static State DEFINITION_FILE = new State(3);
        public final static State NO_DEFINITIONS = new State(4);
        public final static State COMMENT = new State(5);
        public final static State MULTILINE_STRING_STATE = new State(6);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
