/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.prob.unicode.lexer;

import java.io.*;
import java.util.*;
import de.prob.unicode.node.*;
import de.hhu.stups.sablecc.patch.*;
import java.util.concurrent.LinkedBlockingQueue;

@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;
    private final Queue<IToken> nextList = new LinkedBlockingQueue<IToken>();

	private IToken tok;

    public Queue<IToken> getNextList() {
        return nextList;
    }

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
              nextList.add(token);
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return (Token) nextList.peek();
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = (Token) nextList.poll();
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                              Token token = new25(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                              Token token = new26(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                              Token token = new27(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                              Token token = new28(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                              Token token = new29(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                              Token token = new30(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                              Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                              Token token = new32(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                              Token token = new33(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                              Token token = new34(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                              Token token = new35(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                              Token token = new36(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                              Token token = new37(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                              Token token = new38(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                              Token token = new39(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                              Token token = new40(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                              Token token = new41(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                              Token token = new42(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                              Token token = new43(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                              Token token = new44(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 45:
                        {
                              Token token = new45(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                              Token token = new46(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                              Token token = new47(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                              Token token = new48(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                              Token token = new49(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                              Token token = new50(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                              Token token = new51(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                              Token token = new52(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                              Token token = new53(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 54:
                        {
                              Token token = new54(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 55:
                        {
                              Token token = new55(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 56:
                        {
                              Token token = new56(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 57:
                        {
                              Token token = new57(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 58:
                        {
                              Token token = new58(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 59:
                        {
                              Token token = new59(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 60:
                        {
                              Token token = new60(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 61:
                        {
                              Token token = new61(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 62:
                        {
                              Token token = new62(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 63:
                        {
                              Token token = new63(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 64:
                        {
                              Token token = new64(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 65:
                        {
                              Token token = new65(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 66:
                        {
                              Token token = new66(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 67:
                        {
                              Token token = new67(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 68:
                        {
                              Token token = new68(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 69:
                        {
                              Token token = new69(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 70:
                        {
                              Token token = new70(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 71:
                        {
                              Token token = new71(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  String text,   int line,   int pos) { return new TDoubleQuote(text, line, pos); }
    Token new1(  int line,   int pos) { return new TTypeofOpen(line, pos); }
    Token new2(  int line,   int pos) { return new TTypeofClose(line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TIn(text, line, pos); }
    Token new4(  String text,   int line,   int pos) { return new TNotsubseteq(text, line, pos); }
    Token new5(  String text,   int line,   int pos) { return new TNotsubset(text, line, pos); }
    Token new6(  String text,   int line,   int pos) { return new TSubseteq(text, line, pos); }
    Token new7(  String text,   int line,   int pos) { return new TSetminus(text, line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TDotdot(text, line, pos); }
    Token new9(  String text,   int line,   int pos) { return new TNat1(text, line, pos); }
    Token new10(  String text,   int line,   int pos) { return new TNat(text, line, pos); }
    Token new11(  String text,   int line,   int pos) { return new TEmptyset(text, line, pos); }
    Token new12(  String text,   int line,   int pos) { return new TBcmsuch(text, line, pos); }
    Token new13(  String text,   int line,   int pos) { return new TBfalse(text, line, pos); }
    Token new14(  String text,   int line,   int pos) { return new TForall(text, line, pos); }
    Token new15(  String text,   int line,   int pos) { return new TExists(text, line, pos); }
    Token new16(  String text,   int line,   int pos) { return new TMapsto(text, line, pos); }
    Token new17(  String text,   int line,   int pos) { return new TBtrue(text, line, pos); }
    Token new18(  String text,   int line,   int pos) { return new TSubset(text, line, pos); }
    Token new19(  String text,   int line,   int pos) { return new TBunion(text, line, pos); }
    Token new20(  String text,   int line,   int pos) { return new TBinter(text, line, pos); }
    Token new21(  String text,   int line,   int pos) { return new TDomres(text, line, pos); }
    Token new22(  String text,   int line,   int pos) { return new TRanres(text, line, pos); }
    Token new23(  String text,   int line,   int pos) { return new TDomsub(text, line, pos); }
    Token new24(  String text,   int line,   int pos) { return new TRansub(text, line, pos); }
    Token new25(  String text,   int line,   int pos) { return new TLambda(text, line, pos); }
    Token new26(  String text,   int line,   int pos) { return new TOftype(text, line, pos); }
    Token new27(  String text,   int line,   int pos) { return new TNotin(text, line, pos); }
    Token new28(  String text,   int line,   int pos) { return new TCprod(text, line, pos); }
    Token new29(  String text,   int line,   int pos) { return new TUnion(text, line, pos); }
    Token new30(  String text,   int line,   int pos) { return new TInter(text, line, pos); }
    Token new31(  String text,   int line,   int pos) { return new TFcomp(text, line, pos); }
    Token new32(  String text,   int line,   int pos) { return new TBcomp(text, line, pos); }
    Token new33(  String text,   int line,   int pos) { return new TStrel(text, line, pos); }
    Token new34(  String text,   int line,   int pos) { return new TDprod(text, line, pos); }
    Token new35(  String text,   int line,   int pos) { return new TPprod(text, line, pos); }
    Token new36(  String text,   int line,   int pos) { return new TBcmeq(text, line, pos); }
    Token new37(  String text,   int line,   int pos) { return new TBcmin(text, line, pos); }
    Token new38(  String text,   int line,   int pos) { return new TIntg(text, line, pos); }
    Token new39(  String text,   int line,   int pos) { return new TLand(text, line, pos); }
    Token new40(  String text,   int line,   int pos) { return new TLimp(text, line, pos); }
    Token new41(  String text,   int line,   int pos) { return new TLeqv(text, line, pos); }
    Token new42(  String text,   int line,   int pos) { return new TLnot(text, line, pos); }
    Token new43(  String text,   int line,   int pos) { return new TQdot(text, line, pos); }
    Token new44(  String text,   int line,   int pos) { return new TConv(text, line, pos); }
    Token new45(  String text,   int line,   int pos) { return new TTrel(text, line, pos); }
    Token new46(  String text,   int line,   int pos) { return new TSrel(text, line, pos); }
    Token new47(  String text,   int line,   int pos) { return new TPfun(text, line, pos); }
    Token new48(  String text,   int line,   int pos) { return new TTfun(text, line, pos); }
    Token new49(  String text,   int line,   int pos) { return new TPinj(text, line, pos); }
    Token new50(  String text,   int line,   int pos) { return new TTinj(text, line, pos); }
    Token new51(  String text,   int line,   int pos) { return new TPsur(text, line, pos); }
    Token new52(  String text,   int line,   int pos) { return new TTsur(text, line, pos); }
    Token new53(  String text,   int line,   int pos) { return new TTbij(text, line, pos); }
    Token new54(  String text,   int line,   int pos) { return new TExpn(text, line, pos); }
    Token new55(  String text,   int line,   int pos) { return new TLor(text, line, pos); }
    Token new56(  String text,   int line,   int pos) { return new TPow1(text, line, pos); }
    Token new57(  String text,   int line,   int pos) { return new TPow(text, line, pos); }
    Token new58(  String text,   int line,   int pos) { return new TMid(text, line, pos); }
    Token new59(  String text,   int line,   int pos) { return new TNeq(text, line, pos); }
    Token new60(  String text,   int line,   int pos) { return new TRel(text, line, pos); }
    Token new61(  String text,   int line,   int pos) { return new TOvl(text, line, pos); }
    Token new62(  String text,   int line,   int pos) { return new TLeq(text, line, pos); }
    Token new63(  String text,   int line,   int pos) { return new TGeq(text, line, pos); }
    Token new64(  String text,   int line,   int pos) { return new TDiv(text, line, pos); }
    Token new65(  String text,   int line,   int pos) { return new TMult(text, line, pos); }
    Token new66(  String text,   int line,   int pos) { return new TMinus(text, line, pos); }
    Token new67(  int line,   int pos) { return new TTake(line, pos); }
    Token new68(  int line,   int pos) { return new TDrop(line, pos); }
    Token new69(  String text,   int line,   int pos) { return new TAnyChar(text, line, pos); }
    Token new70(  String text,   int line,   int pos) { return new TWhitespace(text, line, pos); }
    Token new71(  String text,   int line,   int pos) { return new TSeparator(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{0, 8, 1}, {9, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 31, 1}, {32, 32, 2}, {33, 33, 3}, {34, 34, 4}, {35, 35, 5}, {36, 36, 1}, {37, 37, 6}, {38, 38, 7}, {39, 39, 1}, {40, 41, 8}, {42, 42, 9}, {43, 43, 10}, {44, 44, 8}, {45, 45, 11}, {46, 46, 12}, {47, 47, 13}, {48, 57, 1}, {58, 58, 14}, {59, 59, 15}, {60, 60, 16}, {61, 61, 17}, {62, 62, 18}, {63, 72, 1}, {73, 73, 19}, {74, 77, 1}, {78, 78, 20}, {79, 79, 1}, {80, 80, 21}, {81, 84, 1}, {85, 85, 22}, {86, 91, 1}, {92, 92, 23}, {93, 93, 1}, {94, 94, 24}, {95, 98, 1}, {99, 99, 25}, {100, 101, 1}, {102, 102, 26}, {103, 109, 1}, {110, 110, 27}, {111, 111, 28}, {112, 115, 1}, {116, 116, 29}, {117, 122, 1}, {123, 123, 30}, {124, 124, 31}, {125, 125, 8}, {126, 126, 32}, {127, 171, 1}, {172, 172, 33}, {173, 182, 1}, {183, 183, 34}, {184, 214, 1}, {215, 215, 35}, {216, 246, 1}, {247, 247, 36}, {248, 954, 1}, {955, 955, 37}, {956, 8228, 1}, {8229, 8229, 38}, {8230, 8468, 1}, {8469, 8469, 39}, {8470, 8472, 1}, {8473, 8473, 40}, {8474, 8483, 1}, {8484, 8484, 41}, {8485, 8593, 1}, {8594, 8594, 42}, {8595, 8595, 1}, {8596, 8596, 43}, {8597, 8607, 1}, {8608, 8608, 44}, {8609, 8610, 1}, {8611, 8611, 45}, {8612, 8613, 1}, {8614, 8614, 46}, {8615, 8657, 1}, {8658, 8658, 47}, {8659, 8659, 1}, {8660, 8660, 48}, {8661, 8695, 1}, {8696, 8696, 49}, {8697, 8703, 1}, {8704, 8704, 50}, {8705, 8706, 1}, {8707, 8707, 51}, {8708, 8708, 1}, {8709, 8709, 52}, {8710, 8711, 1}, {8712, 8712, 53}, {8713, 8713, 54}, {8714, 8721, 1}, {8722, 8722, 55}, {8723, 8725, 1}, {8726, 8726, 56}, {8727, 8727, 57}, {8728, 8728, 58}, {8729, 8738, 1}, {8739, 8739, 59}, {8740, 8740, 1}, {8741, 8741, 60}, {8742, 8742, 1}, {8743, 8743, 61}, {8744, 8744, 62}, {8745, 8745, 63}, {8746, 8746, 64}, {8747, 8763, 1}, {8764, 8764, 65}, {8765, 8787, 1}, {8788, 8788, 66}, {8789, 8799, 1}, {8800, 8800, 67}, {8801, 8803, 1}, {8804, 8804, 68}, {8805, 8805, 69}, {8806, 8833, 1}, {8834, 8834, 70}, {8835, 8835, 1}, {8836, 8836, 71}, {8837, 8837, 1}, {8838, 8838, 72}, {8839, 8839, 1}, {8840, 8840, 73}, {8841, 8854, 1}, {8855, 8855, 74}, {8856, 8867, 1}, {8868, 8868, 75}, {8869, 8869, 76}, {8870, 8897, 1}, {8898, 8898, 77}, {8899, 8899, 78}, {8900, 9654, 1}, {9655, 9655, 79}, {9656, 9664, 1}, {9665, 9665, 80}, {9666, 10495, 1}, {10496, 10496, 81}, {10497, 10515, 1}, {10516, 10516, 82}, {10517, 10517, 1}, {10518, 10518, 83}, {10519, 10625, 1}, {10626, 10626, 84}, {10627, 10851, 1}, {10852, 10852, 85}, {10853, 10853, 86}, {10854, 57599, 1}, {57600, 57600, 87}, {57601, 57601, 88}, {57602, 57602, 89}, {57603, 57603, 90}, {57604, 65535, 1}, },
            {{0, 8, 1}, {11, 12, 1}, {14, 31, 1}, {36, 36, 1}, {39, 39, 1}, {48, 57, 1}, {63, 91, 1}, {93, 93, 1}, {95, 122, 1}, {127, 171, 1}, {173, 182, 1}, {184, 214, 1}, {216, 246, 1}, {248, 954, 1}, {956, 8228, 1}, {8230, 8468, 1}, {8470, 8472, 1}, {8474, 8483, 1}, {8485, 8593, 1}, {8595, 8595, 1}, {8597, 8607, 1}, {8609, 8610, 1}, {8612, 8613, 1}, {8615, 8657, 1}, {8659, 8659, 1}, {8661, 8695, 1}, {8697, 8703, 1}, {8705, 8706, 1}, {8708, 8708, 1}, {8710, 8711, 1}, {8714, 8721, 1}, {8723, 8725, 1}, {8729, 8738, 1}, {8740, 8740, 1}, {8742, 8742, 1}, {8747, 8763, 1}, {8765, 8787, 1}, {8789, 8799, 1}, {8801, 8803, 1}, {8806, 8833, 1}, {8835, 8835, 1}, {8837, 8837, 1}, {8839, 8839, 1}, {8841, 8854, 1}, {8856, 8867, 1}, {8870, 8897, 1}, {8900, 9654, 1}, {9656, 9664, 1}, {9666, 10495, 1}, {10497, 10515, 1}, {10517, 10517, 1}, {10519, 10625, 1}, {10627, 10851, 1}, {10854, 57599, 1}, {57604, 65535, 1}, },
            {{9, 10, 2}, {13, 13, 2}, {32, 32, 2}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{42, 42, 91}, {47, 47, 92}, },
            {{45, 45, 93}, {62, 62, 94}, },
            {{45, 45, 95}, {62, 62, 96}, },
            {{46, 46, 97}, },
            {{42, 42, 98}, {58, 58, 99}, {60, 60, 100}, {61, 61, 101}, {92, 92, 102}, {124, 124, 103}, },
            {{58, 58, 104}, {61, 61, 105}, {124, 124, 106}, {8712, 8712, 107}, {8739, 8739, 108}, },
            {},
            {{43, 43, 109}, {45, 45, 110}, {58, 58, 111}, {60, 60, 112}, {61, 61, 113}, {124, 124, 114}, },
            {{62, 62, 115}, },
            {{43, 43, 116}, {45, 45, 117}, {60, 60, 118}, {61, 61, 119}, },
            {{0, 57, -3}, {63, 77, 1}, {78, 78, 120}, {79, 91, 1}, {93, 65535, -3}, },
            {{0, 57, -3}, {63, 64, 1}, {65, 65, 121}, {66, 91, 1}, {93, 65535, -3}, },
            {{0, 57, -3}, {63, 78, 1}, {79, 79, 122}, {80, 91, 1}, {93, 65535, -3}, },
            {{0, 77, -21}, {78, 78, 123}, {79, 65535, -21}, },
            {{47, 47, 124}, {48, 48, 125}, {73, 73, 126}, {85, 85, 127}, {98, 98, 128}, {99, 99, 129}, {100, 100, 130}, {101, 101, 131}, {102, 102, 132}, {103, 103, 133}, {105, 105, 134}, {108, 108, 135}, {109, 109, 136}, {110, 110, 137}, {111, 111, 138}, {112, 112, 139}, {113, 113, 140}, {114, 114, 141}, {115, 115, 142}, {116, 116, 143}, {124, 124, 144}, },
            {},
            {{0, 93, -3}, {95, 104, 1}, {105, 105, 145}, {106, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 96, 1}, {97, 97, 146}, {98, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 110, 1}, {111, 111, 147}, {112, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 101, 1}, {102, 102, 148}, {103, 113, 1}, {114, 114, 149}, {115, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 113, 1}, {114, 114, 150}, {115, 65535, -30}, },
            {{125, 125, 151}, },
            {{45, 45, 152}, {62, 62, 153}, {124, 124, 154}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{49, 49, 155}, },
            {{49, 49, 156}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 157}, },
            {{62, 62, 158}, },
            {{62, 62, 159}, },
            {{62, 62, 160}, },
            {},
            {},
            {},
            {{58, 58, 161}, {60, 60, 162}, },
            {},
            {},
            {{92, 92, 163}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 164}, },
            {},
            {{45, 45, 165}, {58, 58, 166}, {124, 124, 167}, },
            {{62, 62, 168}, },
            {},
            {},
            {{62, 62, 169}, },
            {{62, 62, 170}, },
            {},
            {},
            {{0, 57, -3}, {63, 83, 1}, {84, 84, 171}, {85, 91, 1}, {93, 65535, -3}, },
            {{0, 83, -122}, {84, 84, 172}, {85, 65535, -122}, },
            {{0, 57, -3}, {63, 86, 1}, {87, 87, 173}, {88, 91, 1}, {93, 65535, -3}, },
            {{0, 57, -3}, {63, 72, 1}, {73, 73, 174}, {74, 91, 1}, {93, 65535, -3}, },
            {},
            {{120, 120, 175}, },
            {{110, 110, 176}, },
            {{110, 110, 177}, },
            {{99, 99, 178}, {102, 102, 179}, {105, 105, 180}, {116, 116, 181}, {117, 117, 182}, },
            {{111, 111, 183}, {112, 112, 184}, },
            {{105, 105, 185}, {111, 111, 186}, {112, 112, 187}, },
            {{109, 109, 188}, {120, 120, 189}, },
            {{99, 99, 190}, {111, 111, 191}, },
            {{101, 101, 192}, },
            {{110, 110, 193}, },
            {{97, 97, 194}, {101, 101, 195}, {105, 105, 196}, {110, 110, 197}, {111, 111, 198}, },
            {{97, 97, 199}, {105, 105, 200}, },
            {{97, 97, 201}, {101, 101, 202}, {111, 111, 203}, },
            {{102, 102, 204}, {118, 118, 205}, },
            {{102, 102, 206}, {105, 105, 207}, {111, 111, 208}, {112, 112, 209}, {115, 115, 210}, },
            {{100, 100, 211}, },
            {{97, 97, 212}, {101, 101, 213}, },
            {{101, 101, 214}, {114, 114, 215}, {116, 116, 216}, {117, 117, 217}, },
            {{98, 98, 218}, {102, 102, 219}, {105, 105, 220}, {114, 114, 221}, {115, 115, 222}, },
            {{47, 47, 223}, },
            {{0, 113, -31}, {114, 114, 224}, {115, 65535, -30}, },
            {{0, 93, -3}, {95, 107, 1}, {108, 108, 225}, {109, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 115, 1}, {116, 116, 226}, {117, 122, 1}, {127, 65535, -3}, },
            {{0, 115, -149}, {116, 116, 227}, {117, 65535, -149}, },
            {{0, 65535, -3}, },
            {{0, 93, -3}, {95, 116, 1}, {117, 117, 228}, {118, 122, 1}, {127, 65535, -3}, },
            {},
            {{62, 62, 229}, },
            {{62, 62, 230}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{58, 58, 231}, },
            {},
            {{62, 62, 232}, },
            {{62, 62, 233}, },
            {},
            {},
            {},
            {},
            {{62, 62, 234}, },
            {{0, 57, -3}, {63, 68, 1}, {69, 69, 235}, {70, 91, 1}, {93, 65535, -3}, },
            {{0, 39, -3}, {48, 48, 1}, {49, 49, 236}, {50, 57, 1}, {63, 65535, -3}, },
            {{0, 48, -174}, {49, 49, 237}, {50, 65535, -174}, },
            {{0, 78, -23}, {79, 79, 238}, {80, 65535, -23}, },
            {{112, 112, 239}, },
            {{116, 116, 240}, },
            {{105, 105, 241}, },
            {{109, 109, 242}, {111, 111, 243}, },
            {{97, 97, 244}, },
            {{110, 110, 245}, },
            {{114, 114, 246}, },
            {{110, 110, 247}, },
            {{110, 110, 248}, },
            {{114, 114, 249}, },
            {{118, 118, 250}, },
            {{109, 109, 251}, },
            {{114, 114, 252}, },
            {{112, 112, 253}, },
            {{105, 105, 254}, {112, 112, 255}, },
            {{111, 111, 256}, },
            {{114, 114, 257}, },
            {{113, 113, 258}, },
            {{116, 116, 259}, },
            {{109, 109, 260}, {110, 110, 261}, },
            {{113, 113, 262}, },
            {{109, 109, 263}, },
            {{111, 111, 264}, },
            {{114, 114, 265}, },
            {{112, 112, 266}, },
            {{100, 100, 267}, },
            {{116, 116, 268}, },
            {{113, 113, 269}, },
            {{116, 116, 270}, },
            {{116, 116, 271}, },
            {{108, 108, 272}, },
            {{117, 117, 273}, },
            {{110, 110, 274}, },
            {{119, 119, 275}, },
            {{114, 114, 276}, },
            {{117, 117, 277}, },
            {{111, 111, 278}, },
            {{110, 110, 279}, },
            {{108, 108, 280}, },
            {{116, 116, 281}, },
            {{101, 101, 282}, },
            {{114, 114, 283}, },
            {{98, 98, 284}, },
            {{105, 105, 285}, },
            {{117, 117, 286}, },
            {{110, 110, 287}, },
            {{101, 101, 288}, },
            {{117, 117, 289}, },
            {},
            {{0, 93, -3}, {95, 98, 1}, {99, 99, 290}, {100, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 114, 1}, {115, 115, 291}, {116, 122, 1}, {127, 65535, -3}, },
            {{0, 65535, -3}, },
            {{0, 93, -3}, {95, 120, 1}, {121, 121, 292}, {122, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 100, 1}, {101, 101, 293}, {102, 122, 1}, {127, 65535, -3}, },
            {},
            {},
            {},
            {},
            {{62, 62, 294}, },
            {},
            {{0, 57, -3}, {63, 81, 1}, {82, 82, 295}, {83, 91, 1}, {93, 65535, -3}, },
            {{0, 65535, -3}, },
            {{0, 65535, -3}, },
            {{0, 77, -21}, {78, 78, 296}, {79, 65535, -21}, },
            {{116, 116, 297}, },
            {{101, 101, 298}, },
            {{111, 111, 299}, },
            {{101, 101, 300}, {105, 105, 301}, {115, 115, 302}, },
            {{109, 109, 303}, },
            {{108, 108, 304}, },
            {{116, 116, 305}, },
            {{117, 117, 306}, },
            {{105, 105, 307}, },
            {{118, 118, 308}, },
            {{111, 111, 309}, },
            {},
            {{114, 114, 310}, {115, 115, 311}, },
            {{111, 111, 312}, },
            {{116, 116, 313}, },
            {{115, 115, 314}, },
            {{110, 110, 315}, },
            {{109, 109, 316}, },
            {{97, 97, 317}, },
            {},
            {{103, 103, 318}, },
            {{98, 98, 319}, },
            {{100, 100, 320}, },
            {{118, 118, 321}, },
            {{112, 112, 322}, },
            {{116, 116, 323}, },
            {},
            {{115, 115, 324}, },
            {},
            {{49, 49, 325}, },
            {},
            {{105, 105, 326}, {115, 115, 327}, },
            {{121, 121, 328}, },
            {},
            {{110, 110, 329}, },
            {{106, 106, 330}, },
            {{49, 49, 331}, },
            {{111, 111, 332}, },
            {{114, 114, 333}, },
            {{116, 116, 334}, },
            {{114, 114, 335}, {115, 115, 336}, },
            {},
            {{109, 109, 337}, },
            {{108, 108, 338}, },
            {{101, 101, 339}, },
            {{115, 115, 340}, },
            {{106, 106, 341}, },
            {{110, 110, 342}, },
            {{106, 106, 343}, },
            {{108, 108, 344}, },
            {{114, 114, 345}, },
            {{0, 65535, -3}, },
            {{0, 100, -230}, {101, 101, 346}, {102, 65535, -230}, },
            {{0, 93, -3}, {95, 111, 1}, {112, 112, 347}, {113, 122, 1}, {127, 65535, -3}, },
            {{0, 65535, -3}, },
            {},
            {{0, 65535, -3}, },
            {{0, 65535, -3}, },
            {{111, 111, 348}, },
            {{114, 114, 349}, },
            {{110, 110, 350}, },
            {{113, 113, 351}, },
            {{110, 110, 352}, },
            {{117, 117, 353}, },
            {{112, 112, 354}, },
            {{115, 115, 355}, },
            {{101, 101, 356}, },
            {{101, 101, 357}, },
            {{111, 111, 358}, },
            {},
            {{100, 100, 359}, },
            {{101, 101, 360}, },
            {{117, 117, 361}, },
            {{100, 100, 362}, },
            {{121, 121, 363}, },
            {{116, 116, 364}, },
            {},
            {{112, 112, 365}, },
            {{108, 108, 366}, },
            {},
            {{100, 100, 367}, },
            {},
            {},
            {},
            {},
            {{116, 116, 368}, },
            {},
            {{110, 110, 369}, },
            {{117, 117, 370}, },
            {{112, 112, 371}, },
            {},
            {},
            {},
            {{100, 100, 372}, },
            {},
            {},
            {{101, 101, 373}, },
            {{117, 117, 374}, },
            {{105, 105, 375}, },
            {},
            {{108, 108, 376}, },
            {{101, 101, 377}, },
            {},
            {},
            {},
            {},
            {},
            {{0, 65535, -3}, },
            {{0, 100, -230}, {101, 101, 378}, {102, 65535, -230}, },
            {},
            {},
            {},
            {},
            {},
            {{99, 99, 379}, },
            {},
            {{101, 101, 380}, },
            {{114, 114, 381}, },
            {},
            {{110, 110, 382}, },
            {},
            {{115, 115, 383}, },
            {{98, 98, 384}, },
            {},
            {{115, 115, 385}, },
            {{115, 115, 386}, },
            {},
            {{108, 108, 387}, },
            {{97, 97, 388}, },
            {{111, 111, 389}, },
            {},
            {{98, 98, 390}, },
            {{101, 101, 391}, },
            {},
            {{115, 115, 392}, },
            {{98, 98, 393}, },
            {{110, 110, 394}, },
            {},
            {{116, 116, 395}, },
            {{0, 65535, -3}, },
            {{104, 104, 396}, },
            {},
            {},
            {},
            {},
            {},
            {{101, 101, 397}, },
            {},
            {},
            {},
            {},
            {{115, 115, 398}, },
            {},
            {},
            {},
            {{117, 117, 399}, },
            {{101, 101, 400}, },
            {},
            {{116, 116, 401}, },
            {{101, 101, 402}, },
            {{115, 115, 403}, },
            {{113, 113, 404}, },
            {},
            {{116, 116, 405}, },
            {},
            {},
            {{101, 101, 406}, },
            {{113, 113, 407}, },
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {69, 69, 70, 14, 0, 15, 25, 39, 71, 65, 71, 66, 43, 64, 3, 31, 71, 71, 71, 69, 69, 69, 69, 7, 54, 69, 69, 69, 69, 69, 71, 58, 44, 42, 43, 28, 64, 25, 8, 10, 57, 38, 48, 60, 52, 50, 16, 40, 41, 47, 14, 15, 11, 3, 27, 66, 7, 65, 32, 58, 35, 39, 55, 20, 19, 44, 36, 59, 62, 63, 18, 5, 6, 4, 34, 17, 13, 30, 29, 22, 21, 51, 49, 53, 26, 23, 24, 45, 46, 33, 61, 28, 2, -1, -1, -1, -1, 8, 1, 27, -1, 59, 20, -1, 37, 36, 12, 37, 12, 61, -1, 6, -1, 62, 21, 40, -1, -1, 34, 63, 69, 69, 69, 69, 19, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 69, 69, 69, 69, 55, 69, 11, -1, 22, 35, 9, 56, 47, 51, 48, 52, 4, -1, 67, 60, -1, 18, 23, 41, 49, 50, 38, 10, 57, 69, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 3, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 68, 69, 69, 42, 69, 69, 16, 24, 5, 46, 45, 53, 69, 9, 56, 69, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 64, -1, -1, -1, -1, -1, -1, -1, 63, -1, -1, -1, 62, -1, -1, 55, -1, 58, 10, 59, -1, -1, 61, -1, -1, 57, -1, -1, -1, -1, 60, -1, -1, -1, -1, -1, -1, -1, -1, -1, 32, 69, 69, 17, 33, 30, 29, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 44, -1, -1, -1, -1, -1, -1, 54, -1, -1, 38, -1, 39, 41, 40, 42, -1, 9, -1, -1, -1, 47, 49, 56, -1, 51, 43, -1, -1, -1, 46, -1, -1, 53, 48, 50, 45, 52, 13, 69, 8, 30, 29, 36, 37, -1, 32, -1, -1, 17, -1, 28, -1, -1, 34, -1, -1, 31, -1, -1, -1, 27, -1, -1, 35, -1, -1, -1, 33, -1, 26, -1, 13, 20, 19, 21, 23, -1, 15, 14, 25, 16, -1, 26, 22, 24, -1, 18, 12, -1, -1, -1, -1, 11, -1, 7, 6, 5, -1, 4, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
