/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.classicalb.core.parser.lexer;

import java.io.*;
import java.util.*;
import de.be4.classicalb.core.parser.node.*;
import de.hhu.stups.sablecc.patch.*;
import java.util.concurrent.LinkedBlockingQueue;

@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.SECTION;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;
    private final Queue<IToken> nextList = new LinkedBlockingQueue<IToken>();

	private IToken tok;

    public Queue<IToken> getNextList() {
        return nextList;
    }

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
              nextList.add(token);
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return (Token) nextList.peek();
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = (Token) nextList.poll();
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.SHEBANG; break;
                                case 0: state = State.SHEBANG; break;
                                case 4: state = State.SHEBANG; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.SHEBANG; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.SECTION; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.PRAGMA; break;
                                case 0: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.NORMAL; break;
                                case 7: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.UNIT; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.UNIT; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.UNIT; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.UNIT; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.DESCRIPTION; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 6: state = State.DESCRIPTION; break;
                            }
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 7: state = State.UNIT; break;
                            }
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 7: state = State.UNIT; break;
                            }
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.COMMENT; break;
                                case 0: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                                case 6: state = State.DESCRIPTION; break;
                            }
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 25:
                        {
                              Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                                case 6: state = State.DESCRIPTION; break;
                            }
                            return token;
                        }
                    case 26:
                        {
                              Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                                case 6: state = State.DESCRIPTION; break;
                            }
                            return token;
                        }
                    case 27:
                        {
                              Token token = new27(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.MULTILINE_STRING_STATE; break;
                                case 0: state = State.MULTILINE_STRING_STATE; break;
                            }
                            return token;
                        }
                    case 28:
                        {
                              Token token = new28(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 29:
                        {
                              Token token = new29(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.MULTILINE_STRING_STATE; break;
                            }
                            return token;
                        }
                    case 30:
                        {
                              Token token = new30(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 31:
                        {
                              Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 32:
                        {
                              Token token = new32(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 33:
                        {
                              Token token = new33(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 34:
                        {
                              Token token = new34(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 35:
                        {
                              Token token = new35(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 36:
                        {
                              Token token = new36(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 37:
                        {
                              Token token = new37(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 38:
                        {
                              Token token = new38(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 39:
                        {
                              Token token = new39(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 40:
                        {
                              Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 41:
                        {
                              Token token = new41(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 42:
                        {
                              Token token = new42(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 43:
                        {
                              Token token = new43(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 44:
                        {
                              Token token = new44(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 45:
                        {
                              Token token = new45(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 46:
                        {
                              Token token = new46(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 47:
                        {
                              Token token = new47(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 48:
                        {
                              Token token = new48(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 49:
                        {
                              Token token = new49(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 50:
                        {
                              Token token = new50(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 51:
                        {
                              Token token = new51(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 52:
                        {
                              Token token = new52(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 53:
                        {
                              Token token = new53(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 54:
                        {
                              Token token = new54(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 55:
                        {
                              Token token = new55(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 56:
                        {
                              Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 57:
                        {
                              Token token = new57(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 58:
                        {
                              Token token = new58(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 59:
                        {
                              Token token = new59(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 60:
                        {
                              Token token = new60(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 61:
                        {
                              Token token = new61(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 62:
                        {
                              Token token = new62(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 63:
                        {
                              Token token = new63(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 64:
                        {
                              Token token = new64(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 65:
                        {
                              Token token = new65(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 66:
                        {
                              Token token = new66(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 67:
                        {
                              Token token = new67(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 68:
                        {
                              Token token = new68(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 69:
                        {
                              Token token = new69(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 70:
                        {
                              Token token = new70(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 71:
                        {
                              Token token = new71(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 72:
                        {
                              Token token = new72(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 73:
                        {
                              Token token = new73(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 74:
                        {
                              Token token = new74(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 75:
                        {
                              Token token = new75(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 76:
                        {
                              Token token = new76(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 77:
                        {
                              Token token = new77(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 78:
                        {
                              Token token = new78(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 79:
                        {
                              Token token = new79(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 80:
                        {
                              Token token = new80(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 81:
                        {
                              Token token = new81(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 82:
                        {
                              Token token = new82(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 83:
                        {
                              Token token = new83(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 84:
                        {
                              Token token = new84(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 85:
                        {
                              Token token = new85(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 86:
                        {
                              Token token = new86(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 87:
                        {
                              Token token = new87(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 88:
                        {
                              Token token = new88(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 89:
                        {
                              Token token = new89(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 90:
                        {
                              Token token = new90(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 91:
                        {
                              Token token = new91(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 92:
                        {
                              Token token = new92(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 93:
                        {
                              Token token = new93(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 94:
                        {
                              Token token = new94(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 95:
                        {
                              Token token = new95(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 96:
                        {
                              Token token = new96(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 97:
                        {
                              Token token = new97(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 98:
                        {
                              Token token = new98(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 99:
                        {
                              Token token = new99(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 100:
                        {
                              Token token = new100(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 101:
                        {
                              Token token = new101(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 102:
                        {
                              Token token = new102(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 103:
                        {
                              Token token = new103(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 104:
                        {
                              Token token = new104(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 105:
                        {
                              Token token = new105(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 106:
                        {
                              Token token = new106(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 107:
                        {
                              Token token = new107(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 108:
                        {
                              Token token = new108(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 109:
                        {
                              Token token = new109(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 110:
                        {
                              Token token = new110(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 111:
                        {
                              Token token = new111(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 112:
                        {
                              Token token = new112(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 113:
                        {
                              Token token = new113(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 114:
                        {
                              Token token = new114(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 115:
                        {
                              Token token = new115(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 116:
                        {
                              Token token = new116(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 117:
                        {
                              Token token = new117(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 118:
                        {
                              Token token = new118(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 119:
                        {
                              Token token = new119(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 120:
                        {
                              Token token = new120(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 121:
                        {
                              Token token = new121(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 122:
                        {
                              Token token = new122(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 123:
                        {
                              Token token = new123(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 124:
                        {
                              Token token = new124(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 125:
                        {
                              Token token = new125(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 126:
                        {
                              Token token = new126(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 127:
                        {
                              Token token = new127(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 128:
                        {
                              Token token = new128(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 129:
                        {
                              Token token = new129(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 130:
                        {
                              Token token = new130(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 131:
                        {
                              Token token = new131(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 132:
                        {
                              Token token = new132(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 133:
                        {
                              Token token = new133(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 134:
                        {
                              Token token = new134(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 135:
                        {
                              Token token = new135(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 136:
                        {
                              Token token = new136(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 137:
                        {
                              Token token = new137(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 138:
                        {
                              Token token = new138(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 139:
                        {
                              Token token = new139(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 140:
                        {
                              Token token = new140(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 141:
                        {
                              Token token = new141(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 142:
                        {
                              Token token = new142(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 143:
                        {
                              Token token = new143(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 144:
                        {
                              Token token = new144(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 145:
                        {
                              Token token = new145(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 146:
                        {
                              Token token = new146(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 147:
                        {
                              Token token = new147(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 148:
                        {
                              Token token = new148(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 149:
                        {
                              Token token = new149(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 150:
                        {
                              Token token = new150(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 151:
                        {
                              Token token = new151(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 152:
                        {
                              Token token = new152(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 153:
                        {
                              Token token = new153(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 154:
                        {
                              Token token = new154(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 155:
                        {
                              Token token = new155(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 156:
                        {
                              Token token = new156(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 157:
                        {
                              Token token = new157(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 158:
                        {
                              Token token = new158(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 159:
                        {
                              Token token = new159(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 160:
                        {
                              Token token = new160(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 161:
                        {
                              Token token = new161(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 162:
                        {
                              Token token = new162(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 163:
                        {
                              Token token = new163(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 164:
                        {
                              Token token = new164(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 165:
                        {
                              Token token = new165(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 166:
                        {
                              Token token = new166(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 167:
                        {
                              Token token = new167(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 168:
                        {
                              Token token = new168(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 169:
                        {
                              Token token = new169(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 170:
                        {
                              Token token = new170(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 171:
                        {
                              Token token = new171(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 172:
                        {
                              Token token = new172(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 173:
                        {
                              Token token = new173(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 174:
                        {
                              Token token = new174(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 175:
                        {
                              Token token = new175(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 176:
                        {
                              Token token = new176(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 177:
                        {
                              Token token = new177(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 178:
                        {
                              Token token = new178(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 179:
                        {
                              Token token = new179(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 180:
                        {
                              Token token = new180(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 181:
                        {
                              Token token = new181(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 182:
                        {
                              Token token = new182(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 183:
                        {
                              Token token = new183(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 184:
                        {
                              Token token = new184(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 185:
                        {
                              Token token = new185(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 186:
                        {
                              Token token = new186(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 187:
                        {
                              Token token = new187(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 188:
                        {
                              Token token = new188(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 189:
                        {
                              Token token = new189(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 190:
                        {
                              Token token = new190(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 191:
                        {
                              Token token = new191(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 192:
                        {
                              Token token = new192(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 193:
                        {
                              Token token = new193(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 194:
                        {
                              Token token = new194(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 195:
                        {
                              Token token = new195(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 196:
                        {
                              Token token = new196(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 197:
                        {
                              Token token = new197(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 198:
                        {
                              Token token = new198(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 199:
                        {
                              Token token = new199(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 200:
                        {
                              Token token = new200(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 201:
                        {
                              Token token = new201(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 202:
                        {
                              Token token = new202(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 203:
                        {
                              Token token = new203(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 204:
                        {
                              Token token = new204(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 205:
                        {
                              Token token = new205(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 206:
                        {
                              Token token = new206(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 207:
                        {
                              Token token = new207(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 208:
                        {
                              Token token = new208(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 209:
                        {
                              Token token = new209(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 210:
                        {
                              Token token = new210(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 211:
                        {
                              Token token = new211(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 212:
                        {
                              Token token = new212(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 213:
                        {
                              Token token = new213(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 214:
                        {
                              Token token = new214(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 215:
                        {
                              Token token = new215(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 216:
                        {
                              Token token = new216(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 217:
                        {
                              Token token = new217(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 218:
                        {
                              Token token = new218(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 219:
                        {
                              Token token = new219(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 220:
                        {
                              Token token = new220(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 221:
                        {
                              Token token = new221(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 222:
                        {
                              Token token = new222(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 223:
                        {
                              Token token = new223(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 224:
                        {
                              Token token = new224(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 225:
                        {
                              Token token = new225(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 226:
                        {
                              Token token = new226(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 227:
                        {
                              Token token = new227(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 228:
                        {
                              Token token = new228(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 229:
                        {
                              Token token = new229(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 230:
                        {
                              Token token = new230(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 231:
                        {
                              Token token = new231(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 232:
                        {
                              Token token = new232(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 233:
                        {
                              Token token = new233(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 234:
                        {
                              Token token = new234(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 235:
                        {
                              Token token = new235(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 236:
                        {
                              Token token = new236(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 237:
                        {
                              Token token = new237(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 238:
                        {
                              Token token = new238(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 239:
                        {
                              Token token = new239(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 240:
                        {
                              Token token = new240(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 241:
                        {
                              Token token = new241(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 242:
                        {
                              Token token = new242(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 243:
                        {
                              Token token = new243(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 244:
                        {
                              Token token = new244(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 245:
                        {
                              Token token = new245(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 246:
                        {
                              Token token = new246(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 247:
                        {
                              Token token = new247(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 248:
                        {
                              Token token = new248(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 249:
                        {
                              Token token = new249(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 250:
                        {
                              Token token = new250(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 251:
                        {
                              Token token = new251(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 252:
                        {
                              Token token = new252(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 253:
                        {
                              Token token = new253(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 254:
                        {
                              Token token = new254(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 255:
                        {
                              Token token = new255(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 256:
                        {
                              Token token = new256(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 257:
                        {
                              Token token = new257(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 258:
                        {
                              Token token = new258(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 259:
                        {
                              Token token = new259(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 260:
                        {
                              Token token = new260(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 261:
                        {
                              Token token = new261(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 262:
                        {
                              Token token = new262(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 263:
                        {
                              Token token = new263(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 264:
                        {
                              Token token = new264(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 265:
                        {
                              Token token = new265(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 266:
                        {
                              Token token = new266(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 267:
                        {
                              Token token = new267(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 268:
                        {
                              Token token = new268(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 269:
                        {
                              Token token = new269(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 270:
                        {
                              Token token = new270(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 271:
                        {
                              Token token = new271(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 272:
                        {
                              Token token = new272(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 273:
                        {
                              Token token = new273(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 274:
                        {
                              Token token = new274(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 275:
                        {
                              Token token = new275(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 276:
                        {
                              Token token = new276(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 277:
                        {
                              Token token = new277(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 278:
                        {
                              Token token = new278(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 279:
                        {
                              Token token = new279(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 280:
                        {
                              Token token = new280(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 281:
                        {
                              Token token = new281(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 282:
                        {
                              Token token = new282(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 283:
                        {
                              Token token = new283(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 284:
                        {
                              Token token = new284(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 285:
                        {
                              Token token = new285(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 286:
                        {
                              Token token = new286(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 287:
                        {
                              Token token = new287(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 288:
                        {
                              Token token = new288(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 289:
                        {
                              Token token = new289(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 290:
                        {
                              Token token = new290(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  int line,   int pos) { return new TShebang(line, pos); }
    Token new1(  String text,   int line,   int pos) { return new TShebangEnd(text, line, pos); }
    Token new2(  String text,   int line,   int pos) { return new TShebangChar(text, line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TLineComment(text, line, pos); }
    Token new4(  int line,   int pos) { return new TPragmaStart(line, pos); }
    Token new5(  int line,   int pos) { return new TPragmaEnd(line, pos); }
    Token new6(  int line,   int pos) { return new TPragmaUnit(line, pos); }
    Token new7(  int line,   int pos) { return new TNewPragmaUnit(line, pos); }
    Token new8(  int line,   int pos) { return new TIpragmaUnit(line, pos); }
    Token new9(  int line,   int pos) { return new TPragmaUnitAlias(line, pos); }
    Token new10(  int line,   int pos) { return new TPragmaGenerated(line, pos); }
    Token new11(  int line,   int pos) { return new TPragmaSymbolic(line, pos); }
    Token new12(  int line,   int pos) { return new TPragmaLabel(line, pos); }
    Token new13(  int line,   int pos) { return new TPragmaFile(line, pos); }
    Token new14(  int line,   int pos) { return new TPragmaPackage(line, pos); }
    Token new15(  String text,   int line,   int pos) { return new TPragmaImportPackage(text, line, pos); }
    Token new16(  String text,   int line,   int pos) { return new TPragmaDescription(text, line, pos); }
    Token new17(  int line,   int pos) { return new TPragmaConversion(line, pos); }
    Token new18(  String text,   int line,   int pos) { return new TPragmaIdOrString(text, line, pos); }
    Token new19(  String text,   int line,   int pos) { return new TPragmaFreeText(text, line, pos); }
    Token new20(  String text,   int line,   int pos) { return new TUnitContent(text, line, pos); }
    Token new21(  String text,   int line,   int pos) { return new TUnitId(text, line, pos); }
    Token new22(  String text,   int line,   int pos) { return new TComment(text, line, pos); }
    Token new23(  String text,   int line,   int pos) { return new TCommentEnd(text, line, pos); }
    Token new24(  String text,   int line,   int pos) { return new TCommentBody(text, line, pos); }
    Token new25(  int line,   int pos) { return new TStar(line, pos); }
    Token new26(  int line,   int pos) { return new TSlash(line, pos); }
    Token new27(  String text,   int line,   int pos) { return new TMultilineStringStart(text, line, pos); }
    Token new28(  String text,   int line,   int pos) { return new TMultilineStringEnd(text, line, pos); }
    Token new29(  String text,   int line,   int pos) { return new TMultilineStringContent(text, line, pos); }
    Token new30(  String text,   int line,   int pos) { return new TStringLiteral(text, line, pos); }
    Token new31(  String text,   int line,   int pos) { return new TForAny(text, line, pos); }
    Token new32(  String text,   int line,   int pos) { return new TExists(text, line, pos); }
    Token new33(  int line,   int pos) { return new TDollar(line, pos); }
    Token new34(  String text,   int line,   int pos) { return new TLambda(text, line, pos); }
    Token new35(  String text,   int line,   int pos) { return new TConjunction(text, line, pos); }
    Token new36(  String text,   int line,   int pos) { return new TSingleQuotation(text, line, pos); }
    Token new37(  int line,   int pos) { return new TLeftPar(line, pos); }
    Token new38(  int line,   int pos) { return new TRightPar(line, pos); }
    Token new39(  String text,   int line,   int pos) { return new TProduct(text, line, pos); }
    Token new40(  int line,   int pos) { return new TPowerOf(line, pos); }
    Token new41(  String text,   int line,   int pos) { return new TPlus(text, line, pos); }
    Token new42(  String text,   int line,   int pos) { return new TPartialFunction(text, line, pos); }
    Token new43(  String text,   int line,   int pos) { return new TPartialSurjection(text, line, pos); }
    Token new44(  int line,   int pos) { return new TComma(line, pos); }
    Token new45(  String text,   int line,   int pos) { return new TMinus(text, line, pos); }
    Token new46(  String text,   int line,   int pos) { return new TTotalFunction(text, line, pos); }
    Token new47(  String text,   int line,   int pos) { return new TTotalSurjection(text, line, pos); }
    Token new48(  String text,   int line,   int pos) { return new TInsertStartSequence(text, line, pos); }
    Token new49(  int line,   int pos) { return new TDot(line, pos); }
    Token new50(  String text,   int line,   int pos) { return new TInterval(text, line, pos); }
    Token new51(  String text,   int line,   int pos) { return new TDivision(text, line, pos); }
    Token new52(  String text,   int line,   int pos) { return new TNotBelonging(text, line, pos); }
    Token new53(  String text,   int line,   int pos) { return new TNonInclusion(text, line, pos); }
    Token new54(  String text,   int line,   int pos) { return new TStrictNonInclusion(text, line, pos); }
    Token new55(  String text,   int line,   int pos) { return new TNotEqual(text, line, pos); }
    Token new56(  int line,   int pos) { return new TSetSubtraction(line, pos); }
    Token new57(  String text,   int line,   int pos) { return new TIntersection(text, line, pos); }
    Token new58(  String text,   int line,   int pos) { return new TRestrictHeadSequence(text, line, pos); }
    Token new59(  String text,   int line,   int pos) { return new TElementOf(text, line, pos); }
    Token new60(  String text,   int line,   int pos) { return new TDoubleColon(text, line, pos); }
    Token new61(  String text,   int line,   int pos) { return new TAssign(text, line, pos); }
    Token new62(  int line,   int pos) { return new TSemicolon(line, pos); }
    Token new63(  String text,   int line,   int pos) { return new TLess(text, line, pos); }
    Token new64(  String text,   int line,   int pos) { return new TOverwriteRelation(text, line, pos); }
    Token new65(  String text,   int line,   int pos) { return new TSetRelation(text, line, pos); }
    Token new66(  String text,   int line,   int pos) { return new TInsertEndSequence(text, line, pos); }
    Token new67(  String text,   int line,   int pos) { return new TOutputParameters(text, line, pos); }
    Token new68(  String text,   int line,   int pos) { return new TInclusion(text, line, pos); }
    Token new69(  String text,   int line,   int pos) { return new TStrictInclusion(text, line, pos); }
    Token new70(  String text,   int line,   int pos) { return new TDomainSubtraction(text, line, pos); }
    Token new71(  String text,   int line,   int pos) { return new TLessEqual(text, line, pos); }
    Token new72(  String text,   int line,   int pos) { return new TEquivalence(text, line, pos); }
    Token new73(  String text,   int line,   int pos) { return new TDomainRestriction(text, line, pos); }
    Token new74(  String text,   int line,   int pos) { return new TEqual(text, line, pos); }
    Token new75(  String text,   int line,   int pos) { return new TDoubleEqual(text, line, pos); }
    Token new76(  String text,   int line,   int pos) { return new TImplies(text, line, pos); }
    Token new77(  String text,   int line,   int pos) { return new TGreater(text, line, pos); }
    Token new78(  String text,   int line,   int pos) { return new TPartialInjection(text, line, pos); }
    Token new79(  String text,   int line,   int pos) { return new TTotalInjection(text, line, pos); }
    Token new80(  String text,   int line,   int pos) { return new TPartialBijection(text, line, pos); }
    Token new81(  String text,   int line,   int pos) { return new TTotalBijection(text, line, pos); }
    Token new82(  String text,   int line,   int pos) { return new TDirectProduct(text, line, pos); }
    Token new83(  String text,   int line,   int pos) { return new TGreaterEqual(text, line, pos); }
    Token new84(  int line,   int pos) { return new TAbstractConstants(line, pos); }
    Token new85(  int line,   int pos) { return new TAbstractVariables(line, pos); }
    Token new86(  int line,   int pos) { return new TAny(line, pos); }
    Token new87(  int line,   int pos) { return new TAssert(line, pos); }
    Token new88(  int line,   int pos) { return new TAssertions(line, pos); }
    Token new89(  int line,   int pos) { return new TBe(line, pos); }
    Token new90(  int line,   int pos) { return new TBegin(line, pos); }
    Token new91(  int line,   int pos) { return new TBool(line, pos); }
    Token new92(  int line,   int pos) { return new TBfalse(line, pos); }
    Token new93(  int line,   int pos) { return new TCase(line, pos); }
    Token new94(  int line,   int pos) { return new TChoice(line, pos); }
    Token new95(  int line,   int pos) { return new TConcreteConstants(line, pos); }
    Token new96(  int line,   int pos) { return new TConcreteVariables(line, pos); }
    Token new97(  int line,   int pos) { return new TConstants(line, pos); }
    Token new98(  int line,   int pos) { return new TConstraints(line, pos); }
    Token new99(  int line,   int pos) { return new TDefinitions(line, pos); }
    Token new100(  int line,   int pos) { return new TExpressions(line, pos); }
    Token new101(  int line,   int pos) { return new TPredicates(line, pos); }
    Token new102(  int line,   int pos) { return new TDo(line, pos); }
    Token new103(  int line,   int pos) { return new TEither(line, pos); }
    Token new104(  int line,   int pos) { return new TElse(line, pos); }
    Token new105(  int line,   int pos) { return new TElsif(line, pos); }
    Token new106(  int line,   int pos) { return new TEnd(line, pos); }
    Token new107(  int line,   int pos) { return new TExtends(line, pos); }
    Token new108(  String text,   int line,   int pos) { return new TFalse(text, line, pos); }
    Token new109(  int line,   int pos) { return new TFin(line, pos); }
    Token new110(  int line,   int pos) { return new TFin1(line, pos); }
    Token new111(  int line,   int pos) { return new TIf(line, pos); }
    Token new112(  int line,   int pos) { return new TImplementation(line, pos); }
    Token new113(  int line,   int pos) { return new TImports(line, pos); }
    Token new114(  int line,   int pos) { return new TIn(line, pos); }
    Token new115(  int line,   int pos) { return new TIncludes(line, pos); }
    Token new116(  String text,   int line,   int pos) { return new TInitialisation(text, line, pos); }
    Token new117(  int line,   int pos) { return new TInt(line, pos); }
    Token new118(  String text,   int line,   int pos) { return new TInteger(text, line, pos); }
    Token new119(  String text,   int line,   int pos) { return new TQuantifiedInter(text, line, pos); }
    Token new120(  int line,   int pos) { return new TInvariant(line, pos); }
    Token new121(  int line,   int pos) { return new TLet(line, pos); }
    Token new122(  int line,   int pos) { return new TLocalOperations(line, pos); }
    Token new123(  int line,   int pos) { return new TMachine(line, pos); }
    Token new124(  int line,   int pos) { return new TModel(line, pos); }
    Token new125(  int line,   int pos) { return new TSystem(line, pos); }
    Token new126(  int line,   int pos) { return new TMaxInt(line, pos); }
    Token new127(  int line,   int pos) { return new TMinInt(line, pos); }
    Token new128(  int line,   int pos) { return new TNat(line, pos); }
    Token new129(  int line,   int pos) { return new TNat1(line, pos); }
    Token new130(  String text,   int line,   int pos) { return new TNatural(text, line, pos); }
    Token new131(  String text,   int line,   int pos) { return new TNatural1(text, line, pos); }
    Token new132(  int line,   int pos) { return new TOf(line, pos); }
    Token new133(  String text,   int line,   int pos) { return new TOperations(text, line, pos); }
    Token new134(  int line,   int pos) { return new TOr(line, pos); }
    Token new135(  String text,   int line,   int pos) { return new TPi(text, line, pos); }
    Token new136(  String text,   int line,   int pos) { return new TPow(text, line, pos); }
    Token new137(  String text,   int line,   int pos) { return new TPow1(text, line, pos); }
    Token new138(  int line,   int pos) { return new TPre(line, pos); }
    Token new139(  int line,   int pos) { return new TPromotes(line, pos); }
    Token new140(  int line,   int pos) { return new TProperties(line, pos); }
    Token new141(  int line,   int pos) { return new TRefines(line, pos); }
    Token new142(  int line,   int pos) { return new TRefinement(line, pos); }
    Token new143(  int line,   int pos) { return new TSees(line, pos); }
    Token new144(  int line,   int pos) { return new TSelect(line, pos); }
    Token new145(  int line,   int pos) { return new TSets(line, pos); }
    Token new146(  int line,   int pos) { return new TQuantifiedSet(line, pos); }
    Token new147(  String text,   int line,   int pos) { return new TSigma(text, line, pos); }
    Token new148(  int line,   int pos) { return new TString(line, pos); }
    Token new149(  int line,   int pos) { return new TThen(line, pos); }
    Token new150(  String text,   int line,   int pos) { return new TTrue(text, line, pos); }
    Token new151(  String text,   int line,   int pos) { return new TQuantifiedUnion(text, line, pos); }
    Token new152(  int line,   int pos) { return new TUses(line, pos); }
    Token new153(  int line,   int pos) { return new TValue(line, pos); }
    Token new154(  int line,   int pos) { return new TVar(line, pos); }
    Token new155(  int line,   int pos) { return new TVariant(line, pos); }
    Token new156(  int line,   int pos) { return new TVariables(line, pos); }
    Token new157(  int line,   int pos) { return new TWhen(line, pos); }
    Token new158(  int line,   int pos) { return new TWhere(line, pos); }
    Token new159(  int line,   int pos) { return new TWhile(line, pos); }
    Token new160(  int line,   int pos) { return new TLeftBracket(line, pos); }
    Token new161(  int line,   int pos) { return new TRightBracket(line, pos); }
    Token new162(  String text,   int line,   int pos) { return new TUnion(text, line, pos); }
    Token new163(  String text,   int line,   int pos) { return new TRestrictTailSequence(text, line, pos); }
    Token new164(  String text,   int line,   int pos) { return new TConcatSequence(text, line, pos); }
    Token new165(  int line,   int pos) { return new TArity(line, pos); }
    Token new166(  int line,   int pos) { return new TBin(line, pos); }
    Token new167(  int line,   int pos) { return new TBoolCast(line, pos); }
    Token new168(  int line,   int pos) { return new TBtree(line, pos); }
    Token new169(  int line,   int pos) { return new TCard(line, pos); }
    Token new170(  int line,   int pos) { return new TClosure(line, pos); }
    Token new171(  int line,   int pos) { return new TClosure1(line, pos); }
    Token new172(  int line,   int pos) { return new TConc(line, pos); }
    Token new173(  int line,   int pos) { return new TConst(line, pos); }
    Token new174(  int line,   int pos) { return new TDom(line, pos); }
    Token new175(  int line,   int pos) { return new TFather(line, pos); }
    Token new176(  int line,   int pos) { return new TFirst(line, pos); }
    Token new177(  int line,   int pos) { return new TFnc(line, pos); }
    Token new178(  int line,   int pos) { return new TFront(line, pos); }
    Token new179(  int line,   int pos) { return new TId(line, pos); }
    Token new180(  int line,   int pos) { return new TInfix(line, pos); }
    Token new181(  int line,   int pos) { return new TGeneralizedInter(line, pos); }
    Token new182(  int line,   int pos) { return new TIseq(line, pos); }
    Token new183(  int line,   int pos) { return new TIseq1(line, pos); }
    Token new184(  int line,   int pos) { return new TIterate(line, pos); }
    Token new185(  int line,   int pos) { return new TLast(line, pos); }
    Token new186(  int line,   int pos) { return new TLeft(line, pos); }
    Token new187(  int line,   int pos) { return new TMax(line, pos); }
    Token new188(  int line,   int pos) { return new TMin(line, pos); }
    Token new189(  int line,   int pos) { return new TMirror(line, pos); }
    Token new190(  int line,   int pos) { return new TMod(line, pos); }
    Token new191(  String text,   int line,   int pos) { return new TNot(text, line, pos); }
    Token new192(  String text,   int line,   int pos) { return new TLogicalOr(text, line, pos); }
    Token new193(  int line,   int pos) { return new TPerm(line, pos); }
    Token new194(  int line,   int pos) { return new TPostfix(line, pos); }
    Token new195(  int line,   int pos) { return new TPred(line, pos); }
    Token new196(  int line,   int pos) { return new TPrefix(line, pos); }
    Token new197(  int line,   int pos) { return new TPrj1(line, pos); }
    Token new198(  int line,   int pos) { return new TPrj2(line, pos); }
    Token new199(  int line,   int pos) { return new TRank(line, pos); }
    Token new200(  int line,   int pos) { return new TRan(line, pos); }
    Token new201(  int line,   int pos) { return new TRec(line, pos); }
    Token new202(  int line,   int pos) { return new TRel(line, pos); }
    Token new203(  int line,   int pos) { return new TRev(line, pos); }
    Token new204(  int line,   int pos) { return new TRight(line, pos); }
    Token new205(  int line,   int pos) { return new TSeq(line, pos); }
    Token new206(  int line,   int pos) { return new TSeq1(line, pos); }
    Token new207(  int line,   int pos) { return new TSizet(line, pos); }
    Token new208(  int line,   int pos) { return new TSize(line, pos); }
    Token new209(  int line,   int pos) { return new TSkip(line, pos); }
    Token new210(  int line,   int pos) { return new TSons(line, pos); }
    Token new211(  int line,   int pos) { return new TSon(line, pos); }
    Token new212(  int line,   int pos) { return new TStruct(line, pos); }
    Token new213(  int line,   int pos) { return new TSubtree(line, pos); }
    Token new214(  int line,   int pos) { return new TSucc(line, pos); }
    Token new215(  int line,   int pos) { return new TTail(line, pos); }
    Token new216(  int line,   int pos) { return new TTop(line, pos); }
    Token new217(  int line,   int pos) { return new TTree(line, pos); }
    Token new218(  int line,   int pos) { return new TGeneralizedUnion(line, pos); }
    Token new219(  String text,   int line,   int pos) { return new TEmptySet(text, line, pos); }
    Token new220(  int line,   int pos) { return new TLeftBrace(line, pos); }
    Token new221(  int line,   int pos) { return new TRightBrace(line, pos); }
    Token new222(  int line,   int pos) { return new TVerticalBar(line, pos); }
    Token new223(  String text,   int line,   int pos) { return new TDoubleVerticalBar(text, line, pos); }
    Token new224(  String text,   int line,   int pos) { return new TMaplet(text, line, pos); }
    Token new225(  String text,   int line,   int pos) { return new TRangeRestriction(text, line, pos); }
    Token new226(  String text,   int line,   int pos) { return new TRangeSubtraction(text, line, pos); }
    Token new227(  String text,   int line,   int pos) { return new TTilde(text, line, pos); }
    Token new228(  String text,   int line,   int pos) { return new TTotalRelation(text, line, pos); }
    Token new229(  String text,   int line,   int pos) { return new TSurjectionRelation(text, line, pos); }
    Token new230(  String text,   int line,   int pos) { return new TTotalSurjectionRelation(text, line, pos); }
    Token new231(  int line,   int pos) { return new TKwFreetypes(line, pos); }
    Token new232(  int line,   int pos) { return new TKwExpression(line, pos); }
    Token new233(  int line,   int pos) { return new TKwPredicate(line, pos); }
    Token new234(  int line,   int pos) { return new TKwFormula(line, pos); }
    Token new235(  int line,   int pos) { return new TKwSubstitution(line, pos); }
    Token new236(  int line,   int pos) { return new TKwAbstractConstants(line, pos); }
    Token new237(  int line,   int pos) { return new TKwAbstractVariables(line, pos); }
    Token new238(  int line,   int pos) { return new TKwAssertions(line, pos); }
    Token new239(  int line,   int pos) { return new TKwConcreteConstants(line, pos); }
    Token new240(  int line,   int pos) { return new TKwConcreteVariables(line, pos); }
    Token new241(  int line,   int pos) { return new TKwConstants(line, pos); }
    Token new242(  int line,   int pos) { return new TKwConstraints(line, pos); }
    Token new243(  int line,   int pos) { return new TKwDefinitions(line, pos); }
    Token new244(  int line,   int pos) { return new TKwDefinition(line, pos); }
    Token new245(  int line,   int pos) { return new TKwExtends(line, pos); }
    Token new246(  int line,   int pos) { return new TKwImports(line, pos); }
    Token new247(  int line,   int pos) { return new TKwIncludes(line, pos); }
    Token new248(  int line,   int pos) { return new TKwInitialisation(line, pos); }
    Token new249(  int line,   int pos) { return new TKwInvariant(line, pos); }
    Token new250(  int line,   int pos) { return new TKwLocalOperations(line, pos); }
    Token new251(  int line,   int pos) { return new TKwOperations(line, pos); }
    Token new252(  int line,   int pos) { return new TKwPromotes(line, pos); }
    Token new253(  int line,   int pos) { return new TKwProperties(line, pos); }
    Token new254(  int line,   int pos) { return new TKwSees(line, pos); }
    Token new255(  int line,   int pos) { return new TKwSets(line, pos); }
    Token new256(  int line,   int pos) { return new TKwUses(line, pos); }
    Token new257(  int line,   int pos) { return new TKwVariables(line, pos); }
    Token new258(  int line,   int pos) { return new TKwValues(line, pos); }
    Token new259(  int line,   int pos) { return new TKwOppattern(line, pos); }
    Token new260(  int line,   int pos) { return new TKwMachineClause(line, pos); }
    Token new261(  String text,   int line,   int pos) { return new TIdentifierLiteral(text, line, pos); }
    Token new262(  String text,   int line,   int pos) { return new TDefLiteralSubstitution(text, line, pos); }
    Token new263(  String text,   int line,   int pos) { return new TDefLiteralPredicate(text, line, pos); }
    Token new264(  String text,   int line,   int pos) { return new TPredicateIdentifier(text, line, pos); }
    Token new265(  int line,   int pos) { return new TTruthPredicate(line, pos); }
    Token new266(  String text,   int line,   int pos) { return new TIntegerLiteral(text, line, pos); }
    Token new267(  String text,   int line,   int pos) { return new THexLiteral(text, line, pos); }
    Token new268(  String text,   int line,   int pos) { return new TUnderscore(text, line, pos); }
    Token new269(  String text,   int line,   int pos) { return new TWhiteSpace(text, line, pos); }
    Token new270(  int line,   int pos) { return new TKwRulesMachine(line, pos); }
    Token new271(  int line,   int pos) { return new TKwRule(line, pos); }
    Token new272(  String text,   int line,   int pos) { return new TKwSubstitutionOperator(text, line, pos); }
    Token new273(  String text,   int line,   int pos) { return new TKwPredicateOperator(text, line, pos); }
    Token new274(  String text,   int line,   int pos) { return new TKwExpressionOperator(text, line, pos); }
    Token new275(  String text,   int line,   int pos) { return new TKwPredicateAttribute(text, line, pos); }
    Token new276(  String text,   int line,   int pos) { return new TKwAttributeIdentifier(text, line, pos); }
    Token new277(  int line,   int pos) { return new TKwFor(line, pos); }
    Token new278(  int line,   int pos) { return new TKwRuleForAll(line, pos); }
    Token new279(  int line,   int pos) { return new TKwRuleFail(line, pos); }
    Token new280(  int line,   int pos) { return new TKwRuleErrorType(line, pos); }
    Token new281(  int line,   int pos) { return new TKwExpect(line, pos); }
    Token new282(  int line,   int pos) { return new TKwComputation(line, pos); }
    Token new283(  int line,   int pos) { return new TKwDefine(line, pos); }
    Token new284(  int line,   int pos) { return new TKwType(line, pos); }
    Token new285(  int line,   int pos) { return new TKwValue(line, pos); }
    Token new286(  int line,   int pos) { return new TKwBody(line, pos); }
    Token new287(  int line,   int pos) { return new TKwDummyValue(line, pos); }
    Token new288(  int line,   int pos) { return new TKwCounterexample(line, pos); }
    Token new289(  int line,   int pos) { return new TKwFunction(line, pos); }
    Token new290(  int line,   int pos) { return new TKwReferences(line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // SECTION
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {35, 35, 3}, {39, 39, 4}, {47, 47, 5}, {65, 67, 6}, {68, 68, 7}, {69, 72, 6}, {73, 73, 8}, {74, 76, 6}, {77, 77, 9}, {78, 81, 6}, {82, 82, 10}, {83, 83, 11}, {84, 90, 6}, {97, 122, 12}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 8233, -2}, },
            {},
            {{33, 33, 13}, {65, 65, 14}, {67, 67, 15}, {68, 68, 16}, {69, 69, 17}, {70, 70, 18}, {73, 73, 19}, {76, 76, 20}, {77, 77, 21}, {79, 79, 22}, {80, 80, 23}, {83, 83, 24}, {85, 85, 25}, {86, 86, 26}, },
            {{39, 39, 27}, },
            {{42, 42, 28}, {47, 47, 29}, },
            {{48, 57, 30}, {65, 90, 31}, {95, 95, 32}, {97, 122, 33}, },
            {{48, 57, 30}, {65, 68, 31}, {69, 69, 34}, {70, 90, 31}, {95, 122, -8}, },
            {{48, 57, 30}, {65, 76, 31}, {77, 77, 35}, {78, 90, 31}, {95, 122, -8}, },
            {{48, 57, 30}, {65, 65, 36}, {66, 78, 31}, {79, 79, 37}, {80, 90, 31}, {95, 122, -8}, },
            {{48, 68, -9}, {69, 69, 38}, {70, 122, -9}, },
            {{48, 57, 30}, {65, 88, 31}, {89, 89, 39}, {90, 90, 31}, {95, 122, -8}, },
            {{48, 122, -8}, },
            {},
            {{66, 66, 40}, {83, 83, 41}, },
            {{79, 79, 42}, },
            {{69, 69, 43}, },
            {{88, 88, 44}, },
            {{79, 79, 45}, },
            {{77, 77, 46}, {78, 78, 47}, },
            {{79, 79, 48}, },
            {{65, 65, 49}, },
            {{80, 80, 50}, },
            {{82, 82, 51}, },
            {{69, 69, 52}, {85, 85, 53}, },
            {{83, 83, 54}, },
            {{65, 65, 55}, },
            {{39, 39, 56}, },
            {{64, 64, 57}, },
            {{0, 9, 58}, {10, 10, 59}, {11, 12, 58}, {13, 13, 59}, {14, 65535, 58}, },
            {{48, 122, -8}, },
            {{48, 122, -8}, },
            {{48, 122, -8}, },
            {{48, 122, -8}, },
            {{48, 57, 30}, {65, 69, 31}, {70, 70, 60}, {71, 90, 31}, {95, 122, -8}, },
            {{48, 57, 30}, {65, 79, 31}, {80, 80, 61}, {81, 90, 31}, {95, 122, -8}, },
            {{48, 57, 30}, {65, 66, 31}, {67, 67, 62}, {68, 90, 31}, {95, 122, -8}, },
            {{48, 57, 30}, {65, 67, 31}, {68, 68, 63}, {69, 90, 31}, {95, 122, -8}, },
            {{48, 69, -36}, {70, 70, 64}, {71, 122, -36}, },
            {{48, 57, 30}, {65, 82, 31}, {83, 83, 65}, {84, 90, 31}, {95, 122, -8}, },
            {{83, 83, 66}, },
            {{83, 83, 67}, },
            {{78, 78, 68}, },
            {{70, 70, 69}, },
            {{80, 80, 70}, {84, 84, 71}, },
            {{82, 82, 72}, },
            {{80, 80, 73}, },
            {{67, 67, 74}, {73, 73, 75}, {86, 86, 76}, },
            {{67, 67, 77}, },
            {{67, 67, 78}, },
            {{69, 69, 79}, {80, 80, 80}, },
            {{69, 69, 81}, {79, 79, 82}, },
            {{69, 69, 83}, {84, 84, 84}, },
            {{66, 66, 85}, },
            {{69, 69, 86}, },
            {{76, 76, 87}, {82, 82, 88}, },
            {},
            {},
            {{0, 65535, -31}, },
            {},
            {{48, 57, 30}, {65, 72, 31}, {73, 73, 89}, {74, 90, 31}, {95, 122, -8}, },
            {{48, 57, 30}, {65, 75, 31}, {76, 76, 90}, {77, 90, 31}, {95, 122, -8}, },
            {{48, 57, 30}, {65, 71, 31}, {72, 72, 91}, {73, 90, 31}, {95, 122, -8}, },
            {{48, 68, -9}, {69, 69, 92}, {70, 122, -9}, },
            {{48, 72, -62}, {73, 73, 93}, {74, 122, -62}, },
            {{48, 57, 30}, {65, 83, 31}, {84, 84, 94}, {85, 90, 31}, {95, 122, -8}, },
            {{84, 84, 95}, },
            {{69, 69, 96}, },
            {{67, 67, 97}, {83, 83, 98}, },
            {{73, 73, 99}, },
            {{82, 82, 100}, },
            {{69, 69, 101}, },
            {{77, 77, 102}, },
            {{79, 79, 103}, },
            {{76, 76, 104}, },
            {{84, 84, 105}, },
            {{65, 65, 106}, },
            {{65, 65, 107}, },
            {{72, 72, 108}, },
            {{82, 82, 109}, },
            {{65, 65, 110}, },
            {{68, 68, 111}, },
            {{77, 77, 112}, {80, 80, 113}, },
            {{83, 83, 114}, },
            {{83, 83, 115}, },
            {{83, 83, 116}, },
            {{83, 83, 117}, },
            {{85, 85, 118}, },
            {{73, 73, 119}, },
            {{48, 57, 30}, {65, 77, 31}, {78, 78, 120}, {79, 90, 31}, {95, 122, -8}, },
            {{48, 68, -9}, {69, 69, 121}, {70, 122, -9}, },
            {{48, 72, -62}, {73, 73, 122}, {74, 122, -62}, },
            {{48, 75, -63}, {76, 76, 123}, {77, 122, -63}, },
            {{48, 77, -91}, {78, 78, 124}, {79, 122, -91}, },
            {{48, 68, -9}, {69, 69, 125}, {70, 122, -9}, },
            {{82, 82, 126}, },
            {{82, 82, 127}, },
            {{82, 82, 128}, },
            {{84, 84, 129}, },
            {{78, 78, 130}, },
            {{69, 69, 131}, },
            {{78, 78, 132}, },
            {{85, 85, 133}, },
            {{82, 82, 134}, },
            {{85, 85, 135}, },
            {{73, 73, 136}, },
            {{82, 82, 137}, },
            {{76, 76, 138}, },
            {{73, 73, 139}, },
            {{65, 65, 140}, },
            {{84, 84, 141}, },
            {{73, 73, 142}, },
            {{79, 79, 143}, },
            {{69, 69, 144}, },
            {},
            {},
            {{84, 84, 145}, },
            {},
            {{69, 69, 146}, },
            {{65, 65, 147}, },
            {{48, 72, -62}, {73, 73, 148}, {74, 122, -62}, },
            {{48, 76, -10}, {77, 77, 149}, {78, 122, -10}, },
            {{48, 77, -91}, {78, 78, 150}, {79, 122, -91}, },
            {{48, 122, -8}, },
            {{48, 68, -9}, {69, 69, 151}, {70, 122, -9}, },
            {{48, 76, -10}, {77, 77, 152}, {78, 122, -10}, },
            {{65, 65, 153}, },
            {{84, 84, 154}, },
            {{69, 69, 155}, },
            {{65, 65, 156}, {82, 82, 157}, },
            {{73, 73, 158}, },
            {{83, 83, 159}, },
            {{68, 68, 160}, },
            {{76, 76, 161}, },
            {{84, 84, 162}, },
            {{68, 68, 163}, },
            {{65, 65, 164}, },
            {{73, 73, 165}, },
            {{95, 95, 166}, },
            {{78, 78, 167}, },
            {{84, 84, 168}, },
            {{84, 84, 169}, },
            {{67, 67, 170}, },
            {{84, 84, 171}, },
            {{82, 82, 172}, },
            {{73, 73, 173}, },
            {{83, 83, 174}, },
            {{66, 66, 175}, },
            {{48, 83, -67}, {84, 84, 176}, {85, 122, -67}, },
            {{48, 68, -9}, {69, 69, 177}, {70, 122, -9}, },
            {{48, 68, -9}, {69, 69, 178}, {70, 122, -9}, },
            {{48, 76, -10}, {77, 77, 179}, {78, 122, -10}, },
            {{48, 122, -8}, },
            {{67, 67, 180}, },
            {{73, 73, 181}, },
            {{84, 84, 182}, },
            {{78, 78, 183}, },
            {{65, 65, 184}, },
            {{84, 84, 185}, },
            {{83, 83, 186}, },
            {{83, 83, 187}, },
            {{65, 65, 188}, },
            {{83, 83, 189}, },
            {{69, 69, 190}, },
            {{76, 76, 191}, },
            {{65, 65, 192}, },
            {{79, 79, 193}, },
            {{69, 69, 194}, },
            {{73, 73, 195}, },
            {{69, 69, 196}, },
            {{65, 65, 197}, },
            {{69, 69, 198}, },
            {{84, 84, 199}, },
            {{84, 84, 200}, },
            {},
            {{76, 76, 201}, },
            {{48, 72, -62}, {73, 73, 202}, {74, 122, -62}, },
            {{48, 77, -91}, {78, 78, 203}, {79, 122, -91}, },
            {{48, 122, -8}, },
            {{48, 68, -9}, {69, 69, 204}, {70, 122, -9}, },
            {{84, 84, 205}, },
            {{79, 79, 206}, },
            {{69, 69, 207}, },
            {{84, 84, 208}, },
            {{73, 73, 209}, },
            {{73, 73, 210}, },
            {{73, 73, 211}, },
            {},
            {},
            {},
            {{83, 83, 212}, },
            {{73, 73, 213}, },
            {{78, 78, 214}, },
            {{80, 80, 215}, },
            {{67, 67, 216}, },
            {{79, 79, 217}, },
            {{82, 82, 218}, },
            {{84, 84, 219}, },
            {{83, 83, 220}, },
            {{73, 73, 221}, },
            {{85, 85, 222}, },
            {{69, 69, 223}, },
            {{48, 57, 30}, {65, 78, 31}, {79, 79, 224}, {80, 122, -11}, },
            {{48, 83, -67}, {84, 84, 225}, {85, 122, -67}, },
            {{48, 77, -91}, {78, 78, 226}, {79, 122, -91}, },
            {{95, 95, 227}, },
            {{78, 78, 228}, },
            {{95, 95, 229}, },
            {{83, 83, 230}, },
            {{78, 78, 231}, },
            {{79, 79, 232}, },
            {{79, 79, 233}, },
            {},
            {{83, 83, 234}, },
            {{84, 84, 235}, },
            {{69, 69, 236}, },
            {{76, 76, 237}, },
            {{78, 78, 238}, },
            {{78, 78, 239}, },
            {{69, 69, 240}, },
            {},
            {{69, 69, 241}, },
            {{84, 84, 242}, },
            {{83, 83, 243}, },
            {{48, 77, -91}, {78, 78, 244}, {79, 122, -91}, },
            {{48, 57, 30}, {65, 65, 245}, {66, 90, 31}, {95, 122, -8}, },
            {{48, 83, -67}, {84, 84, 246}, {85, 122, -67}, },
            {{67, 67, 247}, {86, 86, 248}, },
            {{83, 83, 249}, },
            {{67, 67, 250}, {86, 86, 251}, },
            {},
            {{84, 84, 252}, },
            {{78, 78, 253}, },
            {{78, 78, 254}, },
            {{65, 65, 255}, },
            {},
            {{82, 82, 256}, },
            {{65, 65, 257}, },
            {{83, 83, 258}, },
            {},
            {},
            {{83, 83, 259}, },
            {{73, 73, 260}, },
            {},
            {{48, 82, -41}, {83, 83, 261}, {84, 122, -41}, },
            {{48, 83, -67}, {84, 84, 262}, {85, 122, -67}, },
            {{48, 122, -8}, },
            {{79, 79, 263}, },
            {{65, 65, 264}, },
            {},
            {{79, 79, 265}, },
            {{65, 65, 266}, },
            {{83, 83, 267}, },
            {{83, 83, 268}, },
            {},
            {{84, 84, 269}, },
            {{65, 65, 270}, },
            {{85, 85, 271}, },
            {},
            {},
            {{79, 79, 272}, },
            {{48, 122, -8}, },
            {{48, 72, -62}, {73, 73, 273}, {74, 122, -62}, },
            {{78, 78, 274}, },
            {{82, 82, 275}, },
            {{78, 78, 276}, },
            {{82, 82, 277}, },
            {},
            {},
            {{73, 73, 278}, },
            {{84, 84, 279}, },
            {{83, 83, 280}, },
            {{78, 78, 281}, },
            {{48, 78, -204}, {79, 79, 282}, {80, 122, -11}, },
            {{83, 83, 283}, },
            {{73, 73, 284}, },
            {{83, 83, 285}, },
            {{73, 73, 286}, },
            {{79, 79, 287}, },
            {{73, 73, 288}, },
            {{69, 69, 289}, },
            {},
            {{48, 77, -91}, {78, 78, 290}, {79, 122, -91}, },
            {{84, 84, 291}, },
            {{65, 65, 292}, },
            {{84, 84, 293}, },
            {{65, 65, 294}, },
            {{78, 78, 295}, },
            {{79, 79, 296}, },
            {},
            {{48, 122, -8}, },
            {{65, 65, 297}, },
            {{66, 66, 298}, },
            {{65, 65, 299}, },
            {{66, 66, 300}, },
            {},
            {{78, 78, 301}, },
            {{78, 78, 302}, },
            {{76, 76, 303}, },
            {{78, 78, 304}, },
            {{76, 76, 305}, },
            {{83, 83, 306}, },
            {{84, 84, 307}, },
            {{69, 69, 308}, },
            {{84, 84, 309}, },
            {{69, 69, 310}, },
            {},
            {{83, 83, 311}, },
            {{83, 83, 312}, },
            {{83, 83, 313}, },
            {{83, 83, 314}, },
            {},
            {},
            {},
            {},
        }
        { // NORMAL
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 33, 3}, {34, 34, 4}, {35, 35, 5}, {36, 36, 6}, {37, 37, 7}, {38, 38, 8}, {39, 39, 9}, {40, 40, 10}, {41, 41, 11}, {42, 42, 12}, {43, 43, 13}, {44, 44, 14}, {45, 45, 15}, {46, 46, 16}, {47, 47, 17}, {48, 48, 18}, {49, 57, 19}, {58, 58, 20}, {59, 59, 21}, {60, 60, 22}, {61, 61, 23}, {62, 62, 24}, {65, 65, 25}, {66, 66, 26}, {67, 67, 27}, {68, 68, 28}, {69, 69, 29}, {70, 70, 30}, {71, 72, 31}, {73, 73, 32}, {74, 75, 31}, {76, 76, 33}, {77, 77, 34}, {78, 78, 35}, {79, 79, 36}, {80, 80, 37}, {81, 81, 31}, {82, 82, 38}, {83, 83, 39}, {84, 84, 40}, {85, 85, 41}, {86, 86, 42}, {87, 87, 43}, {88, 90, 31}, {91, 91, 44}, {92, 92, 45}, {93, 93, 46}, {94, 94, 47}, {95, 95, 48}, {97, 97, 49}, {98, 98, 50}, {99, 99, 51}, {100, 100, 52}, {101, 101, 53}, {102, 102, 54}, {103, 104, 53}, {105, 105, 55}, {106, 107, 53}, {108, 108, 56}, {109, 109, 57}, {110, 110, 58}, {111, 111, 59}, {112, 112, 60}, {113, 113, 53}, {114, 114, 61}, {115, 115, 62}, {116, 116, 63}, {117, 117, 64}, {118, 122, 53}, {123, 123, 65}, {124, 124, 66}, {125, 125, 67}, {126, 126, 68}, {127, 160, 1}, {172, 172, 69}, {215, 215, 70}, {247, 247, 71}, {955, 955, 72}, {8206, 8207, 1}, {8229, 8229, 73}, {8232, 8233, 1}, {8315, 8315, 74}, {8469, 8469, 75}, {8473, 8473, 76}, {8484, 8484, 77}, {8592, 8592, 78}, {8593, 8593, 79}, {8594, 8594, 80}, {8595, 8595, 81}, {8596, 8596, 82}, {8608, 8608, 83}, {8611, 8611, 84}, {8614, 8614, 85}, {8658, 8658, 86}, {8660, 8660, 87}, {8696, 8696, 88}, {8701, 8701, 89}, {8702, 8702, 90}, {8704, 8704, 91}, {8707, 8707, 92}, {8709, 8709, 93}, {8712, 8712, 94}, {8713, 8713, 95}, {8719, 8719, 96}, {8721, 8721, 97}, {8722, 8722, 98}, {8741, 8741, 99}, {8743, 8743, 100}, {8744, 8744, 101}, {8745, 8745, 102}, {8746, 8746, 103}, {8764, 8764, 104}, {8800, 8800, 105}, {8804, 8804, 106}, {8805, 8805, 107}, {8834, 8834, 108}, {8836, 8836, 109}, {8838, 8838, 110}, {8840, 8840, 111}, {8855, 8855, 112}, {8868, 8868, 113}, {8869, 8869, 114}, {8898, 8898, 115}, {8899, 8899, 116}, {8918, 8918, 117}, {8978, 8978, 118}, {9654, 9654, 119}, {9655, 9655, 120}, {9664, 9664, 121}, {9665, 9665, 122}, {10496, 10496, 123}, {10516, 10516, 124}, {10518, 10518, 125}, {10852, 10852, 126}, {10853, 10853, 127}, {57600, 57600, 128}, {57601, 57601, 129}, {57602, 57602, 130}, {57603, 57603, 131}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {},
            {},
            {{0, 9, 132}, {11, 12, 132}, {14, 33, 132}, {34, 34, 133}, {35, 91, 132}, {92, 92, 134}, {93, 65535, 132}, },
            {{33, 33, 135}, {108, 108, 136}, {112, 112, 137}, {116, 116, 138}, },
            {},
            {},
            {},
            {{39, 39, 139}, },
            {},
            {},
            {{42, 42, 140}, },
            {{45, 45, 141}, {8722, 8722, 142}, },
            {},
            {{45, 45, 143}, {62, 62, 144}, {8722, 8722, 145}, },
            {{46, 46, 146}, },
            {{42, 42, 147}, {47, 47, 148}, {58, 58, 149}, {60, 60, 150}, {61, 61, 151}, {92, 92, 152}, {124, 124, 153}, },
            {{48, 57, 19}, {120, 120, 154}, },
            {{48, 57, 19}, },
            {{58, 58, 155}, {61, 61, 156}, {8712, 8712, 157}, },
            {},
            {{43, 43, 158}, {45, 45, 159}, {58, 58, 160}, {60, 60, 161}, {61, 61, 162}, {124, 124, 163}, {8722, 8722, 164}, },
            {{61, 61, 165}, {62, 62, 166}, },
            {{43, 43, 167}, {45, 45, 168}, {60, 60, 169}, {61, 61, 170}, {8722, 8722, 171}, },
            {{48, 57, 172}, {65, 65, 173}, {66, 66, 174}, {67, 77, 173}, {78, 78, 175}, {79, 82, 173}, {83, 83, 176}, {84, 90, 173}, {95, 95, 177}, {97, 122, 178}, },
            {{48, 57, 172}, {65, 68, 173}, {69, 69, 179}, {70, 78, 173}, {79, 79, 180}, {80, 90, 173}, {95, 122, -27}, },
            {{48, 57, 172}, {65, 65, 181}, {66, 71, 173}, {72, 72, 182}, {73, 78, 173}, {79, 79, 183}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 184}, {70, 78, 173}, {79, 79, 185}, {80, 84, 173}, {85, 85, 186}, {86, 90, 173}, {95, 122, -27}, },
            {{48, 57, 172}, {65, 72, 173}, {73, 73, 187}, {74, 75, 173}, {76, 76, 188}, {77, 77, 173}, {78, 78, 189}, {79, 81, 173}, {82, 82, 190}, {83, 85, 173}, {86, 86, 191}, {87, 87, 173}, {88, 88, 192}, {89, 90, 173}, {95, 122, -27}, },
            {{48, 57, 172}, {65, 65, 193}, {66, 72, 173}, {73, 73, 194}, {74, 78, 173}, {79, 79, 195}, {80, 81, 173}, {82, 82, 196}, {83, 84, 173}, {85, 85, 197}, {86, 122, -30}, },
            {{48, 57, 172}, {65, 90, 173}, {95, 122, -27}, },
            {{48, 57, 172}, {65, 69, 173}, {70, 70, 198}, {71, 76, 173}, {77, 77, 199}, {78, 78, 200}, {79, 90, 173}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 201}, {70, 78, 173}, {79, 79, 202}, {80, 122, -28}, },
            {{48, 57, 172}, {65, 65, 203}, {66, 72, 173}, {73, 73, 204}, {74, 78, 173}, {79, 79, 205}, {80, 122, -28}, },
            {{48, 57, 172}, {65, 65, 206}, {66, 90, 173}, {95, 122, -27}, },
            {{48, 69, -34}, {70, 70, 207}, {71, 79, 173}, {80, 80, 208}, {81, 81, 173}, {82, 82, 209}, {83, 90, 173}, {95, 122, -27}, },
            {{48, 72, -31}, {73, 73, 210}, {74, 78, 173}, {79, 79, 211}, {80, 81, 173}, {82, 82, 212}, {83, 122, -38}, },
            {{48, 68, -28}, {69, 69, 213}, {70, 84, 173}, {85, 85, 214}, {86, 122, -30}, },
            {{48, 68, -28}, {69, 69, 215}, {70, 72, 173}, {73, 73, 216}, {74, 83, 173}, {84, 84, 217}, {85, 88, 173}, {89, 89, 218}, {90, 90, 173}, {95, 122, -27}, },
            {{48, 57, 172}, {65, 71, 173}, {72, 72, 219}, {73, 81, 173}, {82, 82, 220}, {83, 88, 173}, {89, 89, 221}, {90, 122, -41}, },
            {{48, 57, 172}, {65, 77, 173}, {78, 78, 222}, {79, 82, 173}, {83, 83, 223}, {84, 122, -27}, },
            {{48, 57, 172}, {65, 65, 224}, {66, 122, -37}, },
            {{48, 71, -42}, {72, 72, 225}, {73, 90, 173}, {95, 122, -27}, },
            {},
            {{47, 47, 226}, {124, 124, 227}, },
            {},
            {},
            {},
            {{48, 95, -33}, {97, 113, 178}, {114, 114, 228}, {115, 122, 178}, },
            {{48, 95, -33}, {97, 101, 178}, {102, 102, 229}, {103, 104, 178}, {105, 105, 230}, {106, 110, 178}, {111, 111, 231}, {112, 115, 178}, {116, 116, 232}, {117, 122, 178}, },
            {{48, 95, -33}, {97, 97, 233}, {98, 107, 178}, {108, 108, 234}, {109, 110, 178}, {111, 111, 235}, {112, 122, 178}, },
            {{48, 95, -33}, {97, 110, 178}, {111, 111, 236}, {112, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 95, -33}, {97, 97, 237}, {98, 104, 178}, {105, 105, 238}, {106, 109, 178}, {110, 110, 239}, {111, 113, 178}, {114, 114, 240}, {115, 122, 178}, },
            {{48, 95, -33}, {97, 99, 178}, {100, 100, 241}, {101, 109, 178}, {110, 110, 242}, {111, 114, 178}, {115, 115, 243}, {116, 116, 244}, {117, 122, 178}, },
            {{48, 95, -33}, {97, 97, 245}, {98, 100, 178}, {101, 101, 246}, {102, 122, 178}, },
            {{48, 95, -33}, {97, 97, 247}, {98, 104, 178}, {105, 105, 248}, {106, 110, 178}, {111, 111, 249}, {112, 122, 178}, },
            {{48, 110, -54}, {111, 111, 250}, {112, 122, 178}, },
            {{48, 113, -51}, {114, 114, 251}, {115, 122, 178}, },
            {{48, 95, -33}, {97, 100, 178}, {101, 101, 252}, {102, 110, 178}, {111, 111, 253}, {112, 113, 178}, {114, 114, 254}, {115, 122, 178}, },
            {{48, 95, -33}, {97, 97, 255}, {98, 100, 178}, {101, 101, 256}, {102, 104, 178}, {105, 105, 257}, {106, 122, 178}, },
            {{48, 100, -62}, {101, 101, 258}, {102, 104, 178}, {105, 105, 259}, {106, 106, 178}, {107, 107, 260}, {108, 110, 178}, {111, 111, 261}, {112, 115, 178}, {116, 116, 262}, {117, 117, 263}, {118, 122, 178}, },
            {{48, 95, -33}, {97, 97, 264}, {98, 110, 178}, {111, 111, 265}, {112, 113, 178}, {114, 114, 266}, {115, 122, 178}, },
            {{48, 95, -33}, {97, 109, 178}, {110, 110, 267}, {111, 122, 178}, },
            {},
            {{45, 45, 268}, {62, 62, 269}, {124, 124, 270}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{185, 185, 271}, },
            {{49, 49, 272}, {8321, 8321, 273}, },
            {{49, 49, 274}, {8321, 8321, 275}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{45, 8722, -17}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{0, 65535, -6}, },
            {},
            {{0, 9, 276}, {11, 12, 276}, {14, 65535, 276}, },
            {},
            {{105, 105, 277}, },
            {{114, 114, 278}, },
            {{114, 114, 279}, },
            {{39, 39, 280}, },
            {},
            {{62, 62, 281}, },
            {{62, 62, 281}, },
            {{62, 62, 282}, },
            {},
            {{62, 62, 282}, },
            {},
            {{64, 64, 283}, },
            {{0, 9, 284}, {10, 10, 285}, {11, 12, 284}, {13, 13, 285}, {14, 65535, 284}, },
            {},
            {{58, 58, 286}, {60, 60, 287}, },
            {},
            {},
            {{92, 92, 288}, },
            {{48, 57, 289}, {65, 70, 289}, {97, 102, 289}, },
            {},
            {},
            {},
            {},
            {{45, 45, 290}, {62, 62, 291}, },
            {},
            {{45, 45, 292}, {58, 58, 293}, {124, 124, 294}, {8722, 8722, 295}, },
            {{62, 62, 296}, },
            {},
            {{62, 62, 291}, },
            {},
            {},
            {{62, 62, 297}, },
            {{62, 62, 298}, },
            {},
            {},
            {{62, 62, 298}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 172}, {65, 82, 173}, {83, 83, 299}, {84, 122, -27}, },
            {{48, 57, 172}, {65, 88, 173}, {89, 89, 300}, {90, 122, -41}, },
            {{48, 82, -176}, {83, 83, 301}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 172}, {65, 70, 173}, {71, 71, 302}, {72, 90, 173}, {95, 122, -27}, },
            {{48, 57, 172}, {65, 67, 173}, {68, 68, 303}, {69, 78, 173}, {79, 79, 304}, {80, 122, -28}, },
            {{48, 82, -176}, {83, 83, 305}, {84, 122, -27}, },
            {{48, 57, 172}, {65, 78, 173}, {79, 79, 306}, {80, 122, -28}, },
            {{48, 57, 172}, {65, 76, 173}, {77, 77, 307}, {78, 78, 308}, {79, 84, 173}, {85, 85, 309}, {86, 122, -30}, },
            {{48, 69, -34}, {70, 70, 310}, {71, 90, 173}, {95, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 76, -185}, {77, 77, 311}, {78, 90, 173}, {95, 122, -27}, },
            {{48, 57, 172}, {65, 83, 173}, {84, 84, 312}, {85, 90, 173}, {95, 122, -27}, },
            {{48, 82, -176}, {83, 83, 313}, {84, 122, -27}, },
            {{48, 67, -182}, {68, 68, 314}, {69, 90, 173}, {95, 122, -27}, },
            {{48, 57, 172}, {65, 81, 173}, {82, 82, 315}, {83, 122, -38}, },
            {{48, 68, -28}, {69, 69, 316}, {70, 90, 173}, {95, 122, -27}, },
            {{48, 57, 172}, {65, 79, 173}, {80, 80, 317}, {81, 83, 173}, {84, 84, 318}, {85, 122, -189}, },
            {{48, 57, 172}, {65, 75, 173}, {76, 76, 319}, {77, 90, 173}, {95, 122, -27}, },
            {{48, 77, -43}, {78, 78, 320}, {79, 122, -34}, },
            {{48, 81, -192}, {82, 82, 321}, {83, 122, -38}, },
            {{48, 68, -28}, {69, 69, 322}, {70, 122, -193}, },
            {{48, 77, -43}, {78, 78, 323}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 79, -194}, {80, 80, 324}, {81, 90, 173}, {95, 122, -27}, },
            {{48, 57, 172}, {65, 66, 173}, {67, 67, 325}, {68, 72, 173}, {73, 73, 326}, {74, 83, 173}, {84, 84, 327}, {85, 85, 173}, {86, 86, 328}, {87, 90, 173}, {95, 122, -27}, },
            {{48, 83, -189}, {84, 84, 329}, {85, 122, -189}, },
            {{48, 66, -202}, {67, 67, 330}, {68, 90, 173}, {95, 122, -27}, },
            {{48, 66, -202}, {67, 67, 331}, {68, 87, 173}, {88, 88, 332}, {89, 122, -31}, },
            {{48, 77, -43}, {78, 78, 333}, {79, 122, -34}, },
            {{48, 67, -182}, {68, 68, 334}, {69, 122, -191}, },
            {{48, 83, -189}, {84, 84, 335}, {85, 122, -189}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 336}, {70, 122, -193}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 172}, {65, 86, 173}, {87, 87, 337}, {88, 90, 173}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 338}, {70, 78, 173}, {79, 79, 339}, {80, 122, -28}, },
            {{48, 69, -34}, {70, 70, 340}, {71, 122, -186}, },
            {{48, 75, -195}, {76, 76, 341}, {77, 122, -195}, },
            {{48, 68, -28}, {69, 69, 342}, {70, 75, 173}, {76, 76, 343}, {77, 83, 173}, {84, 84, 344}, {85, 122, -189}, },
            {{48, 70, -181}, {71, 71, 345}, {72, 122, -181}, },
            {{48, 81, -192}, {82, 82, 346}, {83, 122, -38}, },
            {{48, 82, -176}, {83, 83, 347}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 348}, {70, 122, -193}, },
            {{48, 57, 172}, {65, 84, 173}, {85, 85, 349}, {86, 122, -30}, },
            {{48, 79, -194}, {80, 80, 350}, {81, 122, -201}, },
            {{48, 72, -31}, {73, 73, 351}, {74, 90, 173}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 352}, {70, 122, -193}, },
            {{48, 75, -195}, {76, 76, 353}, {77, 81, 173}, {82, 82, 354}, {83, 122, -38}, },
            {{48, 68, -28}, {69, 69, 355}, {70, 72, 173}, {73, 73, 356}, {74, 122, -224}, },
            {},
            {{47, 47, 357}, },
            {{48, 95, -33}, {97, 104, 178}, {105, 105, 358}, {106, 122, 178}, },
            {{48, 95, -33}, {97, 97, 359}, {98, 122, 178}, },
            {{48, 109, -66}, {110, 110, 360}, {111, 122, 178}, },
            {{48, 110, -54}, {111, 111, 361}, {112, 122, 178}, },
            {{48, 113, -51}, {114, 114, 362}, {115, 122, 178}, },
            {{48, 113, -51}, {114, 114, 363}, {115, 122, 178}, },
            {{48, 110, -54}, {111, 111, 364}, {112, 122, 178}, },
            {{48, 109, -66}, {110, 110, 365}, {111, 122, 178}, },
            {{48, 95, -33}, {97, 108, 178}, {109, 109, 366}, {110, 122, 178}, },
            {{48, 95, -33}, {97, 115, 178}, {116, 116, 367}, {117, 122, 178}, },
            {{48, 113, -51}, {114, 114, 368}, {115, 122, 178}, },
            {{48, 95, -33}, {97, 98, 178}, {99, 99, 369}, {100, 122, 178}, },
            {{48, 110, -54}, {111, 111, 370}, {112, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 101, -52}, {102, 102, 371}, {103, 115, 178}, {116, 116, 372}, {117, 122, 178}, },
            {{48, 100, -62}, {101, 101, 373}, {102, 122, 178}, },
            {{48, 100, -62}, {101, 101, 374}, {102, 122, 178}, },
            {{48, 95, -33}, {97, 114, 178}, {115, 115, 375}, {116, 122, 178}, },
            {{48, 101, -52}, {102, 102, 376}, {103, 122, 178}, },
            {{48, 95, -33}, {97, 119, 178}, {120, 120, 377}, {121, 122, 178}, },
            {{48, 109, -66}, {110, 110, 378}, {111, 113, 178}, {114, 114, 379}, {115, 122, 178}, },
            {{48, 99, -57}, {100, 100, 380}, {101, 122, 178}, },
            {{48, 115, -239}, {116, 116, 381}, {117, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 382}, {115, 122, 178}, },
            {{48, 114, -247}, {115, 115, 383}, {116, 122, 178}, },
            {{48, 100, -62}, {101, 101, 384}, {102, 105, 178}, {106, 106, 385}, {107, 122, 178}, },
            {{48, 109, -66}, {110, 110, 386}, {111, 122, 178}, },
            {{48, 98, -241}, {99, 99, 387}, {100, 107, 178}, {108, 108, 388}, {109, 117, 178}, {118, 118, 389}, {119, 122, 178}, },
            {{48, 95, -33}, {97, 102, 178}, {103, 103, 390}, {104, 122, 178}, },
            {{48, 95, -33}, {97, 112, 178}, {113, 113, 391}, {114, 122, 178}, },
            {{48, 95, -33}, {97, 121, 178}, {122, 122, 392}, },
            {{48, 104, -230}, {105, 105, 393}, {106, 122, 178}, },
            {{48, 109, -66}, {110, 110, 394}, {111, 122, 178}, },
            {{48, 113, -51}, {114, 114, 395}, {115, 122, 178}, },
            {{48, 95, -33}, {97, 97, 178}, {98, 98, 396}, {99, 99, 397}, {100, 122, 178}, },
            {{48, 104, -230}, {105, 105, 398}, {106, 122, 178}, },
            {{48, 95, -33}, {97, 111, 178}, {112, 112, 399}, {113, 122, 178}, },
            {{48, 100, -62}, {101, 101, 400}, {102, 122, 178}, },
            {{48, 104, -230}, {105, 105, 401}, {106, 122, 178}, },
            {{62, 62, 402}, },
            {{62, 62, 403}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{0, 65535, -6}, },
            {{116, 116, 404}, },
            {{101, 101, 405}, },
            {{117, 117, 406}, },
            {},
            {{62, 62, 407}, },
            {{62, 62, 408}, },
            {},
            {{0, 65535, -150}, },
            {},
            {},
            {{58, 58, 409}, },
            {},
            {{48, 102, -156}, },
            {},
            {{62, 62, 410}, },
            {{62, 62, 411}, },
            {},
            {},
            {{62, 62, 411}, },
            {},
            {{62, 62, 412}, },
            {{62, 62, 413}, },
            {{48, 83, -189}, {84, 84, 414}, {85, 122, -189}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 415}, {70, 122, -193}, },
            {{48, 72, -31}, {73, 73, 416}, {74, 122, -224}, },
            {{48, 88, -177}, {89, 89, 417}, {90, 122, -41}, },
            {{48, 75, -195}, {76, 76, 418}, {77, 122, -195}, },
            {{48, 68, -28}, {69, 69, 419}, {70, 122, -193}, },
            {{48, 72, -31}, {73, 73, 420}, {74, 122, -224}, },
            {{48, 79, -194}, {80, 80, 421}, {81, 122, -201}, },
            {{48, 66, -202}, {67, 67, 422}, {68, 82, 173}, {83, 83, 423}, {84, 122, -27}, },
            {{48, 77, -43}, {78, 78, 424}, {79, 122, -34}, },
            {{48, 72, -31}, {73, 73, 425}, {74, 122, -224}, },
            {{48, 76, -185}, {77, 77, 426}, {78, 122, -188}, },
            {{48, 71, -42}, {72, 72, 427}, {73, 122, -45}, },
            {{48, 68, -28}, {69, 69, 428}, {70, 72, 173}, {73, 73, 429}, {74, 122, -224}, },
            {{48, 122, -33}, },
            {{48, 78, -184}, {79, 79, 430}, {80, 122, -28}, },
            {{48, 77, -43}, {78, 78, 431}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 432}, {70, 81, 173}, {82, 82, 433}, {83, 122, -38}, },
            {{48, 68, -28}, {69, 69, 434}, {70, 122, -193}, },
            {{48, 82, -176}, {83, 83, 435}, {84, 122, -27}, },
            {{48, 48, 172}, {49, 49, 436}, {50, 57, 172}, {65, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 437}, {70, 122, -193}, },
            {{48, 66, -202}, {67, 67, 438}, {68, 122, -204}, },
            {{48, 75, -195}, {76, 76, 439}, {77, 78, 173}, {79, 79, 440}, {80, 122, -28}, },
            {{48, 75, -195}, {76, 76, 441}, {77, 122, -195}, },
            {{48, 83, -189}, {84, 84, 442}, {85, 122, -189}, },
            {{48, 68, -28}, {69, 69, 443}, {70, 122, -193}, },
            {{48, 57, 172}, {65, 65, 444}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 57, 172}, {65, 65, 445}, {66, 122, -37}, },
            {{48, 71, -42}, {72, 72, 446}, {73, 122, -45}, },
            {{48, 72, -31}, {73, 73, 447}, {74, 122, -224}, },
            {{48, 72, -31}, {73, 73, 448}, {74, 122, -224}, },
            {{48, 68, -28}, {69, 69, 449}, {70, 122, -193}, },
            {{48, 48, 172}, {49, 49, 450}, {50, 57, 172}, {65, 84, 173}, {85, 85, 451}, {86, 122, -30}, },
            {{48, 81, -192}, {82, 82, 452}, {83, 122, -38}, },
            {{48, 48, 172}, {49, 49, 453}, {50, 122, -322}, },
            {{48, 67, -182}, {68, 68, 454}, {69, 122, -191}, },
            {{48, 76, -185}, {77, 77, 455}, {78, 79, 173}, {80, 80, 456}, {81, 122, -201}, },
            {{48, 68, -28}, {69, 69, 457}, {70, 72, 173}, {73, 73, 458}, {74, 122, -224}, },
            {{48, 68, -28}, {69, 69, 459}, {70, 122, -193}, },
            {{48, 82, -176}, {83, 83, 460}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 461}, {70, 122, -193}, },
            {{48, 82, -176}, {83, 83, 462}, {84, 122, -27}, },
            {{48, 76, -185}, {77, 77, 463}, {78, 122, -188}, },
            {{48, 72, -31}, {73, 73, 464}, {74, 122, -224}, },
            {{48, 83, -189}, {84, 84, 465}, {85, 122, -189}, },
            {{48, 77, -43}, {78, 78, 466}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 467}, {70, 122, -193}, },
            {{48, 68, -28}, {69, 69, 468}, {70, 122, -193}, },
            {{48, 78, -184}, {79, 79, 469}, {80, 122, -28}, },
            {{48, 82, -176}, {83, 83, 470}, {84, 122, -27}, },
            {{48, 84, -222}, {85, 85, 471}, {86, 122, -30}, },
            {{48, 72, -31}, {73, 73, 472}, {74, 122, -224}, },
            {{48, 77, -43}, {78, 78, 473}, {79, 81, 173}, {82, 82, 474}, {83, 122, -38}, },
            {{48, 75, -195}, {76, 76, 475}, {77, 122, -195}, },
            {},
            {{48, 115, -239}, {116, 116, 476}, {117, 122, 178}, },
            {{48, 95, -33}, {97, 107, 178}, {108, 108, 477}, {109, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 107, -361}, {108, 108, 478}, {109, 122, 178}, },
            {{48, 100, -62}, {101, 101, 479}, {102, 122, 178}, },
            {{48, 99, -57}, {100, 100, 480}, {101, 122, 178}, },
            {{48, 114, -247}, {115, 115, 481}, {116, 122, 178}, },
            {{48, 98, -241}, {99, 99, 482}, {100, 114, 178}, {115, 115, 483}, {116, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 95, -33}, {97, 103, 178}, {104, 104, 484}, {105, 122, 178}, },
            {{48, 114, -247}, {115, 115, 485}, {116, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 109, -66}, {110, 110, 486}, {111, 122, 178}, },
            {{48, 104, -230}, {105, 105, 487}, {106, 122, 178}, },
            {{48, 100, -62}, {101, 101, 488}, {102, 122, 178}, },
            {{48, 112, -260}, {113, 113, 489}, {114, 122, 178}, },
            {{48, 113, -51}, {114, 114, 490}, {115, 122, 178}, },
            {{48, 115, -239}, {116, 116, 491}, {117, 122, 178}, },
            {{48, 115, -239}, {116, 116, 492}, {117, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 493}, {115, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 108, -238}, {109, 109, 494}, {110, 122, 178}, },
            {{48, 115, -239}, {116, 116, 495}, {117, 122, 178}, },
            {{48, 99, -57}, {100, 100, 496}, {101, 101, 178}, {102, 102, 497}, {103, 122, 178}, },
            {{48, 48, 172}, {49, 49, 498}, {50, 50, 499}, {51, 57, 172}, {65, 122, -33}, },
            {{48, 95, -33}, {97, 106, 178}, {107, 107, 500}, {108, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 103, -369}, {104, 104, 501}, {105, 122, 178}, },
            {{48, 48, 172}, {49, 49, 502}, {50, 122, -322}, },
            {{48, 100, -62}, {101, 101, 503}, {102, 122, 178}, },
            {{48, 111, -267}, {112, 112, 504}, {113, 122, 178}, },
            {{48, 114, -247}, {115, 115, 505}, {116, 122, 178}, },
            {{48, 95, -33}, {97, 116, 178}, {117, 117, 506}, {118, 122, 178}, },
            {{48, 115, -239}, {116, 116, 507}, {117, 122, 178}, },
            {{48, 98, -241}, {99, 99, 508}, {100, 122, 178}, },
            {{48, 107, -361}, {108, 108, 509}, {109, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 510}, {102, 122, 178}, },
            {{48, 110, -54}, {111, 111, 511}, {112, 122, 178}, },
            {},
            {},
            {{101, 101, 512}, },
            {{100, 100, 513}, },
            {{116, 116, 514}, },
            {},
            {},
            {},
            {},
            {{62, 62, 515}, },
            {},
            {},
            {{48, 81, -192}, {82, 82, 516}, {83, 122, -38}, },
            {{48, 81, -192}, {82, 82, 517}, {83, 122, -38}, },
            {{48, 77, -43}, {78, 78, 518}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 66, -202}, {67, 67, 519}, {68, 122, -204}, },
            {{48, 84, -222}, {85, 85, 520}, {86, 122, -30}, },
            {{48, 81, -192}, {82, 82, 521}, {83, 122, -38}, },
            {{48, 83, -189}, {84, 84, 522}, {85, 122, -189}, },
            {{48, 83, -189}, {84, 84, 523}, {85, 122, -189}, },
            {{48, 77, -43}, {78, 78, 524}, {79, 122, -34}, },
            {{48, 88, -177}, {89, 89, 525}, {90, 122, -41}, },
            {{48, 68, -28}, {69, 69, 526}, {70, 122, -193}, },
            {{48, 122, -33}, },
            {{48, 69, -34}, {70, 70, 527}, {71, 122, -186}, },
            {{48, 81, -192}, {82, 82, 528}, {83, 122, -38}, },
            {{48, 83, -189}, {84, 84, 529}, {85, 122, -189}, },
            {{48, 66, -202}, {67, 67, 530}, {68, 122, -204}, },
            {{48, 68, -28}, {69, 69, 531}, {70, 122, -193}, },
            {{48, 77, -43}, {78, 78, 532}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 533}, {70, 122, -193}, },
            {{48, 122, -33}, },
            {{48, 83, -189}, {84, 84, 534}, {85, 122, -189}, },
            {{48, 83, -189}, {84, 84, 535}, {85, 122, -189}, },
            {{48, 68, -28}, {69, 69, 536}, {70, 122, -193}, },
            {{48, 81, -192}, {82, 82, 537}, {83, 122, -38}, },
            {{48, 84, -222}, {85, 85, 538}, {86, 122, -30}, },
            {{48, 72, -31}, {73, 73, 539}, {74, 122, -224}, },
            {{48, 70, -181}, {71, 71, 540}, {72, 81, 173}, {82, 82, 541}, {83, 122, -38}, },
            {{48, 81, -192}, {82, 82, 542}, {83, 122, -38}, },
            {{48, 75, -195}, {76, 76, 543}, {77, 122, -195}, },
            {{48, 72, -31}, {73, 73, 544}, {74, 122, -224}, },
            {{48, 77, -43}, {78, 78, 545}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 546}, {79, 122, -34}, },
            {{48, 75, -195}, {76, 76, 547}, {77, 122, -195}, },
            {{48, 122, -33}, },
            {{48, 81, -192}, {82, 82, 548}, {83, 122, -38}, },
            {{48, 57, 172}, {65, 65, 549}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 72, -31}, {73, 73, 550}, {74, 122, -224}, },
            {{48, 78, -184}, {79, 79, 551}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 552}, {70, 122, -193}, },
            {{48, 81, -192}, {82, 82, 553}, {83, 122, -38}, },
            {{48, 77, -43}, {78, 78, 554}, {79, 122, -34}, },
            {{48, 82, -176}, {83, 83, 555}, {84, 90, 173}, {95, 95, 556}, {97, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 66, -202}, {67, 67, 557}, {68, 122, -204}, },
            {{48, 122, -33}, },
            {{48, 57, 172}, {65, 65, 558}, {66, 122, -37}, },
            {{48, 77, -43}, {78, 78, 559}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 560}, {70, 122, -193}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 561}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 562}, {70, 122, -193}, },
            {{48, 57, 172}, {65, 65, 563}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 564}, {70, 122, -193}, },
            {{48, 68, -28}, {69, 69, 565}, {70, 122, -193}, },
            {{48, 95, -33}, {97, 120, 178}, {121, 121, 566}, {122, 122, 178}, },
            {{48, 114, -247}, {115, 115, 567}, {116, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 568}, {102, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 116, -397}, {117, 117, 569}, {118, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 115, -239}, {116, 116, 570}, {117, 122, 178}, },
            {{48, 100, -62}, {101, 101, 571}, {102, 122, 178}, },
            {{48, 115, -239}, {116, 116, 572}, {117, 122, 178}, },
            {{48, 115, -239}, {116, 116, 573}, {117, 122, 178}, },
            {{48, 119, -249}, {120, 120, 574}, {121, 122, 178}, },
            {{48, 113, -51}, {114, 114, 575}, {115, 122, 178}, },
            {{48, 48, 172}, {49, 49, 576}, {50, 122, -322}, },
            {{48, 95, -33}, {97, 97, 577}, {98, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 110, -54}, {111, 111, 578}, {112, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 101, -52}, {102, 102, 579}, {103, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 104, -230}, {105, 105, 580}, {106, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -239}, {116, 116, 581}, {117, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 115, -239}, {116, 116, 582}, {117, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 98, -241}, {99, 99, 583}, {100, 122, 178}, },
            {{48, 113, -51}, {114, 114, 584}, {115, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 109, -66}, {110, 110, 585}, {111, 122, 178}, },
            {{114, 114, 586}, },
            {{105, 105, 587}, },
            {{104, 104, 588}, },
            {},
            {{48, 57, 172}, {65, 65, 589}, {66, 122, -37}, },
            {{48, 83, -189}, {84, 84, 590}, {85, 122, -189}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 591}, {70, 122, -193}, },
            {{48, 83, -189}, {84, 84, 592}, {85, 122, -189}, },
            {{48, 68, -28}, {69, 69, 593}, {70, 122, -193}, },
            {{48, 57, 172}, {65, 65, 594}, {66, 81, 173}, {82, 82, 595}, {83, 122, -38}, },
            {{48, 68, -28}, {69, 69, 596}, {70, 122, -193}, },
            {{48, 68, -28}, {69, 69, 597}, {70, 72, 173}, {73, 73, 598}, {74, 122, -224}, },
            {{48, 90, -33}, {95, 95, 599}, {97, 122, 178}, },
            {{48, 81, -192}, {82, 82, 600}, {83, 122, -38}, },
            {{48, 122, -33}, },
            {{48, 90, -33}, {95, 95, 601}, {97, 122, 178}, },
            {{48, 82, -176}, {83, 83, 602}, {84, 122, -27}, },
            {{48, 83, -189}, {84, 84, 603}, {85, 122, -189}, },
            {{48, 82, -176}, {83, 83, 604}, {84, 122, -27}, },
            {{48, 67, -182}, {68, 68, 605}, {69, 122, -191}, },
            {{48, 122, -33}, },
            {{48, 88, -177}, {89, 89, 606}, {90, 122, -41}, },
            {{48, 72, -31}, {73, 73, 607}, {74, 122, -224}, },
            {{48, 76, -185}, {77, 77, 608}, {78, 122, -188}, },
            {{48, 83, -189}, {84, 84, 609}, {85, 122, -189}, },
            {{48, 67, -182}, {68, 68, 610}, {69, 122, -191}, },
            {{48, 57, 172}, {65, 65, 611}, {66, 122, -37}, },
            {{48, 68, -28}, {69, 69, 612}, {70, 122, -193}, },
            {{48, 122, -33}, },
            {{48, 72, -31}, {73, 73, 613}, {74, 122, -224}, },
            {{48, 90, -33}, {95, 95, 614}, {97, 122, 178}, },
            {{48, 77, -43}, {78, 78, 615}, {79, 122, -34}, },
            {{48, 83, -189}, {84, 84, 616}, {85, 122, -189}, },
            {{48, 83, -189}, {84, 84, 617}, {85, 122, -189}, },
            {{48, 122, -33}, },
            {{48, 57, 172}, {65, 65, 618}, {66, 122, -37}, },
            {{48, 83, -189}, {84, 84, 619}, {85, 122, -189}, },
            {{48, 66, -202}, {67, 67, 620}, {68, 122, -204}, },
            {{48, 83, -189}, {84, 84, 621}, {85, 122, -189}, },
            {{48, 81, -192}, {82, 82, 622}, {83, 122, -38}, },
            {{48, 68, -28}, {69, 69, 623}, {70, 122, -193}, },
            {{48, 68, -28}, {69, 69, 624}, {70, 122, -193}, },
            {{48, 90, -33}, {95, 95, 625}, {97, 122, 178}, },
            {{48, 69, -34}, {70, 70, 626}, {71, 122, -186}, },
            {{48, 83, -189}, {84, 84, 627}, {85, 122, -189}, },
            {{48, 122, -33}, },
            {{48, 70, -181}, {71, 71, 628}, {72, 122, -181}, },
            {{48, 76, -185}, {77, 77, 629}, {78, 122, -188}, },
            {{48, 122, -33}, },
            {{48, 82, -176}, {83, 83, 630}, {84, 122, -27}, },
            {{48, 65, -27}, {66, 66, 631}, {67, 77, 173}, {78, 78, 632}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 633}, {102, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 634}, {115, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 635}, {115, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -239}, {116, 116, 636}, {117, 122, 178}, },
            {{48, 113, -51}, {114, 114, 637}, {115, 122, 178}, },
            {{48, 104, -230}, {105, 105, 638}, {106, 122, 178}, },
            {{48, 119, -249}, {120, 120, 639}, {121, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -239}, {116, 116, 640}, {117, 122, 178}, },
            {{48, 100, -62}, {101, 101, 641}, {102, 122, 178}, },
            {{48, 122, -33}, },
            {{97, 97, 642}, },
            {{99, 99, 643}, },
            {{95, 95, 644}, },
            {{48, 66, -202}, {67, 67, 645}, {68, 122, -204}, },
            {{48, 72, -31}, {73, 73, 646}, {74, 122, -224}, },
            {{48, 122, -33}, },
            {{48, 57, 172}, {65, 65, 647}, {66, 122, -37}, },
            {{48, 83, -189}, {84, 84, 648}, {85, 122, -189}, },
            {{48, 77, -43}, {78, 78, 649}, {79, 122, -34}, },
            {{48, 57, 172}, {65, 65, 650}, {66, 122, -37}, },
            {{48, 81, -192}, {82, 82, 651}, {83, 122, -38}, },
            {{48, 122, -33}, },
            {{48, 83, -189}, {84, 84, 652}, {85, 122, -189}, },
            {{48, 57, 172}, {65, 85, 173}, {86, 86, 653}, {87, 122, -202}, },
            {{48, 122, -33}, },
            {{48, 83, -189}, {84, 84, 654}, {85, 122, -189}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 82, -176}, {83, 83, 655}, {84, 122, -27}, },
            {{48, 82, -176}, {83, 83, 656}, {84, 122, -27}, },
            {{48, 79, -194}, {80, 80, 657}, {81, 122, -201}, },
            {{48, 78, -184}, {79, 79, 658}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 659}, {70, 122, -193}, },
            {{48, 82, -176}, {83, 83, 660}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 661}, {70, 122, -193}, },
            {{48, 75, -195}, {76, 76, 662}, {77, 122, -195}, },
            {{48, 81, -192}, {82, 82, 663}, {83, 122, -38}, },
            {{48, 57, 172}, {65, 65, 664}, {66, 122, -37}, },
            {{48, 78, -184}, {79, 79, 665}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 666}, {70, 122, -193}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 75, -195}, {76, 76, 667}, {77, 122, -195}, },
            {{48, 72, -31}, {73, 73, 668}, {74, 122, -224}, },
            {{48, 57, 172}, {65, 65, 669}, {66, 122, -37}, },
            {{48, 68, -28}, {69, 69, 670}, {70, 122, -193}, },
            {{48, 83, -189}, {84, 84, 671}, {85, 122, -189}, },
            {{48, 77, -43}, {78, 78, 672}, {79, 122, -34}, },
            {{48, 76, -185}, {77, 77, 673}, {78, 82, 173}, {83, 83, 674}, {84, 122, -27}, },
            {{48, 76, -185}, {77, 77, 675}, {78, 122, -188}, },
            {{48, 57, 172}, {65, 65, 676}, {66, 78, 173}, {79, 79, 677}, {80, 122, -28}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 75, -195}, {76, 76, 678}, {77, 122, -195}, },
            {{48, 83, -189}, {84, 84, 679}, {85, 122, -189}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 680}, {102, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 681}, {102, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 119, -249}, {120, 120, 682}, {121, 122, 178}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 683}, {102, 122, 178}, },
            {{108, 108, 684}, },
            {{97, 97, 685}, },
            {{112, 112, 686}, },
            {{48, 83, -189}, {84, 84, 687}, {85, 122, -189}, },
            {{48, 78, -184}, {79, 79, 688}, {80, 122, -28}, },
            {{48, 83, -189}, {84, 84, 689}, {85, 122, -189}, },
            {{48, 68, -28}, {69, 69, 690}, {70, 122, -193}, },
            {{48, 83, -189}, {84, 84, 691}, {85, 122, -189}, },
            {{48, 72, -31}, {73, 73, 692}, {74, 122, -224}, },
            {{48, 68, -28}, {69, 69, 693}, {70, 122, -193}, },
            {{48, 72, -31}, {73, 73, 694}, {74, 122, -224}, },
            {{48, 57, 172}, {65, 65, 695}, {66, 122, -37}, },
            {{48, 88, -177}, {89, 89, 696}, {90, 122, -41}, },
            {{48, 72, -31}, {73, 73, 697}, {74, 122, -224}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 698}, {70, 122, -193}, },
            {{48, 77, -43}, {78, 78, 699}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 700}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 82, -176}, {83, 83, 701}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 702}, {74, 122, -224}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 703}, {79, 122, -34}, },
            {{48, 79, -194}, {80, 80, 704}, {81, 122, -201}, },
            {{48, 122, -33}, },
            {{48, 48, 172}, {49, 49, 705}, {50, 122, -322}, },
            {{48, 78, -184}, {79, 79, 706}, {80, 122, -28}, },
            {{48, 83, -189}, {84, 84, 707}, {85, 122, -189}, },
            {{48, 82, -176}, {83, 83, 708}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 709}, {74, 122, -224}, },
            {{48, 66, -202}, {67, 67, 710}, {68, 122, -204}, },
            {{48, 68, -28}, {69, 69, 711}, {70, 122, -193}, },
            {{48, 122, -33}, },
            {{48, 57, 172}, {65, 65, 712}, {66, 122, -37}, },
            {{48, 72, -31}, {73, 73, 713}, {74, 122, -224}, },
            {{48, 81, -192}, {82, 82, 714}, {83, 122, -38}, },
            {{48, 68, -28}, {69, 69, 715}, {70, 122, -193}, },
            {{48, 122, -33}, },
            {{48, 48, 172}, {49, 49, 716}, {50, 122, -322}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{95, 95, 717}, },
            {{116, 116, 718}, },
            {{114, 114, 719}, },
            {{48, 90, -33}, {95, 95, 720}, {97, 122, 178}, },
            {{48, 77, -43}, {78, 78, 721}, {79, 122, -34}, },
            {{48, 72, -31}, {73, 73, 722}, {74, 122, -224}, },
            {{48, 90, -33}, {95, 95, 723}, {97, 122, 178}, },
            {{48, 82, -176}, {83, 83, 724}, {84, 122, -27}, },
            {{48, 77, -43}, {78, 78, 725}, {79, 122, -34}, },
            {{48, 57, 172}, {65, 87, 173}, {88, 88, 726}, {89, 122, -31}, },
            {{48, 78, -184}, {79, 79, 727}, {80, 122, -28}, },
            {{48, 75, -195}, {76, 76, 728}, {77, 122, -195}, },
            {{48, 79, -194}, {80, 80, 729}, {81, 122, -201}, },
            {{48, 78, -184}, {79, 79, 730}, {80, 122, -28}, },
            {{48, 82, -176}, {83, 83, 731}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 83, -189}, {84, 84, 732}, {85, 122, -189}, },
            {{48, 122, -33}, },
            {{48, 82, -176}, {83, 83, 733}, {84, 89, 173}, {90, 90, 734}, {95, 122, -27}, },
            {{48, 83, -189}, {84, 84, 735}, {85, 122, -189}, },
            {{48, 68, -28}, {69, 69, 736}, {70, 122, -193}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 737}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 738}, {70, 122, -193}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 739}, {70, 122, -193}, },
            {{48, 68, -28}, {69, 69, 740}, {70, 122, -193}, },
            {{48, 77, -43}, {78, 78, 741}, {79, 122, -34}, },
            {{48, 66, -202}, {67, 67, 742}, {68, 122, -204}, },
            {{48, 75, -195}, {76, 76, 743}, {77, 122, -195}, },
            {{48, 57, 172}, {65, 65, 744}, {66, 122, -37}, },
            {{48, 82, -176}, {83, 83, 745}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{112, 112, 746}, {115, 115, 747}, },
            {{101, 101, 748}, },
            {{101, 101, 749}, },
            {{48, 66, -202}, {67, 67, 750}, {68, 85, 173}, {86, 86, 751}, {87, 122, -202}, },
            {{48, 82, -176}, {83, 83, 752}, {84, 122, -27}, },
            {{48, 78, -184}, {79, 79, 753}, {80, 122, -28}, },
            {{48, 66, -202}, {67, 67, 754}, {68, 85, 173}, {86, 86, 755}, {87, 122, -202}, },
            {{48, 122, -33}, },
            {{48, 83, -189}, {84, 84, 756}, {85, 122, -189}, },
            {{48, 57, 172}, {65, 65, 757}, {66, 122, -37}, },
            {{48, 77, -43}, {78, 78, 758}, {79, 122, -34}, },
            {{48, 84, -222}, {85, 85, 759}, {86, 122, -30}, },
            {{48, 68, -28}, {69, 69, 760}, {70, 122, -193}, },
            {{48, 77, -43}, {78, 78, 761}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 57, 172}, {65, 65, 762}, {66, 122, -37}, },
            {{48, 57, 172}, {65, 65, 763}, {66, 122, -37}, },
            {{48, 57, 172}, {65, 65, 764}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 81, -192}, {82, 82, 765}, {83, 122, -38}, },
            {{48, 82, -176}, {83, 83, 766}, {84, 122, -27}, },
            {{48, 82, -176}, {83, 83, 767}, {84, 122, -27}, },
            {{48, 82, -176}, {83, 83, 768}, {84, 122, -27}, },
            {{48, 82, -176}, {83, 83, 769}, {84, 122, -27}, },
            {{48, 83, -189}, {84, 84, 770}, {85, 122, -189}, },
            {{48, 71, -42}, {72, 72, 771}, {73, 122, -45}, },
            {{48, 122, -33}, },
            {{48, 75, -195}, {76, 76, 772}, {77, 122, -195}, },
            {{48, 122, -33}, },
            {{114, 114, 773}, },
            {{117, 117, 774}, },
            {{95, 95, 775}, },
            {{100, 100, 776}, },
            {{48, 78, -184}, {79, 79, 777}, {80, 122, -28}, },
            {{48, 57, 172}, {65, 65, 778}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 779}, {79, 122, -34}, },
            {{48, 78, -184}, {79, 79, 780}, {80, 122, -28}, },
            {{48, 57, 172}, {65, 65, 781}, {66, 122, -37}, },
            {{48, 82, -176}, {83, 83, 782}, {84, 122, -27}, },
            {{48, 76, -185}, {77, 77, 783}, {78, 122, -188}, },
            {{48, 82, -176}, {83, 83, 784}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 785}, {70, 122, -193}, },
            {{48, 122, -33}, },
            {{48, 82, -176}, {83, 83, 786}, {84, 122, -27}, },
            {{48, 83, -189}, {84, 84, 787}, {85, 122, -189}, },
            {{48, 83, -189}, {84, 84, 788}, {85, 122, -189}, },
            {{48, 83, -189}, {84, 84, 789}, {85, 122, -189}, },
            {{48, 57, 172}, {65, 65, 790}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 72, -31}, {73, 73, 791}, {74, 122, -224}, },
            {{48, 75, -195}, {76, 76, 792}, {77, 122, -195}, },
            {{101, 101, 793}, },
            {{98, 98, 794}, },
            {{105, 105, 795}, },
            {{105, 105, 796}, },
            {{48, 77, -43}, {78, 78, 797}, {79, 122, -34}, },
            {{48, 81, -192}, {82, 82, 798}, {83, 122, -38}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 799}, {79, 122, -34}, },
            {{48, 81, -192}, {82, 82, 800}, {83, 122, -38}, },
            {{48, 122, -33}, },
            {{48, 79, -194}, {80, 80, 801}, {81, 122, -201}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 72, -31}, {73, 73, 802}, {74, 122, -224}, },
            {{48, 72, -31}, {73, 73, 803}, {74, 122, -224}, },
            {{48, 72, -31}, {73, 73, 804}, {74, 122, -224}, },
            {{48, 83, -189}, {84, 84, 805}, {85, 122, -189}, },
            {{48, 77, -43}, {78, 78, 806}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{100, 100, 807}, },
            {{115, 115, 808}, },
            {{100, 100, 809}, },
            {{99, 99, 810}, },
            {{48, 82, -176}, {83, 83, 811}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 812}, {74, 122, -224}, },
            {{48, 82, -176}, {83, 83, 813}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 814}, {74, 122, -224}, },
            {{48, 75, -195}, {76, 76, 815}, {77, 122, -195}, },
            {{48, 78, -184}, {79, 79, 816}, {80, 122, -28}, },
            {{48, 78, -184}, {79, 79, 817}, {80, 122, -28}, },
            {{48, 78, -184}, {79, 79, 818}, {80, 122, -28}, },
            {{48, 72, -31}, {73, 73, 819}, {74, 122, -224}, },
            {{48, 68, -28}, {69, 69, 820}, {70, 122, -193}, },
            {{105, 105, 821}, },
            {{116, 116, 822}, },
            {{101, 101, 823}, },
            {{97, 97, 824}, },
            {{48, 83, -189}, {84, 84, 825}, {85, 122, -189}, },
            {{48, 57, 172}, {65, 65, 826}, {66, 122, -37}, },
            {{48, 83, -189}, {84, 84, 827}, {85, 122, -189}, },
            {{48, 57, 172}, {65, 65, 828}, {66, 122, -37}, },
            {{48, 68, -28}, {69, 69, 829}, {70, 122, -193}, },
            {{48, 77, -43}, {78, 78, 830}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 831}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 832}, {79, 122, -34}, },
            {{48, 78, -184}, {79, 79, 833}, {80, 122, -28}, },
            {{48, 122, -33}, },
            {{99, 99, 834}, },
            {{105, 105, 835}, },
            {{110, 110, 836}, },
            {{116, 116, 837}, },
            {{48, 57, 172}, {65, 65, 838}, {66, 122, -37}, },
            {{48, 65, -27}, {66, 66, 839}, {67, 90, 173}, {95, 122, -27}, },
            {{48, 57, 172}, {65, 65, 840}, {66, 122, -37}, },
            {{48, 65, -27}, {66, 66, 841}, {67, 122, -828}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 842}, {79, 122, -34}, },
            {{97, 97, 843}, },
            {{116, 116, 844}, },
            {{116, 116, 845}, },
            {{101, 101, 846}, },
            {{48, 77, -43}, {78, 78, 847}, {79, 122, -34}, },
            {{48, 75, -195}, {76, 76, 848}, {77, 122, -195}, },
            {{48, 77, -43}, {78, 78, 849}, {79, 122, -34}, },
            {{48, 75, -195}, {76, 76, 850}, {77, 122, -195}, },
            {{48, 82, -176}, {83, 83, 851}, {84, 122, -27}, },
            {{116, 116, 852}, },
            {{117, 117, 853}, },
            {{105, 105, 854}, },
            {},
            {{48, 83, -189}, {84, 84, 855}, {85, 122, -189}, },
            {{48, 68, -28}, {69, 69, 856}, {70, 122, -193}, },
            {{48, 83, -189}, {84, 84, 857}, {85, 122, -189}, },
            {{48, 68, -28}, {69, 69, 858}, {70, 122, -193}, },
            {{48, 122, -33}, },
            {{101, 101, 859}, },
            {{116, 116, 860}, },
            {{102, 102, 861}, },
            {{48, 82, -176}, {83, 83, 862}, {84, 122, -27}, },
            {{48, 82, -176}, {83, 83, 863}, {84, 122, -27}, },
            {{48, 82, -176}, {83, 83, 864}, {84, 122, -27}, },
            {{48, 82, -176}, {83, 83, 865}, {84, 122, -27}, },
            {{65, 90, 866}, {97, 122, 867}, },
            {{105, 105, 868}, },
            {{105, 105, 869}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{65, 122, -861}, },
            {{65, 122, -861}, },
            {{111, 111, 870}, },
            {{101, 101, 871}, },
            {{110, 110, 872}, },
            {{114, 114, 873}, },
            {{65, 90, 874}, {97, 122, 875}, },
            {{65, 90, 876}, {97, 122, 877}, },
            {{65, 122, -874}, },
            {{65, 122, -874}, },
            {{65, 122, -875}, },
            {{65, 122, -875}, },
        }
        { // COMMENT
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 41, 3}, {42, 42, 4}, {43, 46, 3}, {47, 47, 5}, {48, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 1}, {10, 10, 3}, {11, 12, 1}, {13, 13, 3}, {14, 41, -2}, {43, 46, 3}, {48, 65535, -2}, },
            {{0, 41, 3}, {43, 46, 3}, {48, 65535, 3}, },
            {{0, 65535, -4}, },
            {{47, 47, 6}, },
            {},
            {},
        }
        { // MULTILINE_STRING_STATE
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 38, 3}, {39, 39, 4}, {40, 91, 3}, {92, 92, 5}, {93, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 1}, {10, 10, 3}, {11, 12, 1}, {13, 13, 3}, {14, 38, -2}, {39, 39, 6}, {40, 65535, -2}, },
            {{0, 38, 3}, {39, 92, -3}, {93, 65535, 3}, },
            {{0, 65535, -4}, },
            {{0, 38, 7}, {39, 39, 8}, {40, 65535, 7}, },
            {{0, 38, 3}, {39, 39, 9}, {40, 65535, -4}, },
            {{0, 38, 7}, {39, 39, 10}, {40, 65535, 7}, },
            {{0, 65535, -4}, },
            {{0, 38, 11}, {39, 39, 12}, {40, 65535, 11}, },
            {{0, 38, 13}, {39, 39, 14}, {40, 91, 13}, {92, 92, 15}, {93, 65535, 13}, },
            {{0, 38, 11}, {40, 65535, 11}, },
            {{0, 65535, -4}, },
            {},
            {{0, 65535, -4}, },
            {{0, 38, 16}, {39, 39, 10}, {40, 65535, 16}, },
            {{0, 65535, -7}, },
            {{0, 65535, -4}, },
        }
        { // SHEBANG
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 34, 3}, {35, 35, 4}, {36, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 5}, {11, 12, 5}, {14, 32, 5}, {127, 160, 5}, {8206, 8207, 5}, {8232, 8233, 5}, },
            {},
            {},
            {{33, 33, 6}, },
            {{0, 8233, -3}, },
            {},
        }
        { // PRAGMA
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 33, 3}, {34, 34, 4}, {35, 41, 3}, {42, 42, 5}, {43, 64, 3}, {65, 90, 6}, {91, 96, 3}, {97, 98, 7}, {99, 99, 8}, {100, 100, 9}, {101, 101, 7}, {102, 102, 10}, {103, 103, 11}, {104, 104, 7}, {105, 105, 12}, {106, 107, 7}, {108, 108, 13}, {109, 109, 7}, {110, 110, 14}, {111, 111, 7}, {112, 112, 15}, {113, 114, 7}, {115, 115, 16}, {116, 116, 7}, {117, 117, 17}, {118, 122, 7}, {123, 126, 3}, {127, 160, 1}, {191, 254, 3}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 160, 1}, {8206, 8233, -2}, },
            {},
            {{33, 33, 3}, {35, 41, 3}, {43, 126, 3}, {191, 254, 3}, },
            {{0, 9, 18}, {11, 12, 18}, {14, 33, 18}, {34, 34, 19}, {35, 91, 18}, {92, 92, 20}, {93, 65535, 18}, },
            {{47, 47, 21}, },
            {{33, 41, -5}, {43, 47, 3}, {48, 57, 22}, {58, 64, 3}, {65, 90, 23}, {91, 94, 3}, {95, 95, 24}, {96, 96, 3}, {97, 122, 25}, {123, 126, 3}, {191, 254, 3}, },
            {{33, 254, -8}, },
            {{33, 96, -8}, {97, 110, 25}, {111, 111, 26}, {112, 122, 25}, {123, 254, -8}, },
            {{33, 96, -8}, {97, 100, 25}, {101, 101, 27}, {102, 122, 25}, {123, 254, -8}, },
            {{33, 96, -8}, {97, 104, 25}, {105, 105, 28}, {106, 122, 25}, {123, 254, -8}, },
            {{33, 100, -11}, {101, 101, 29}, {102, 254, -11}, },
            {{33, 96, -8}, {97, 108, 25}, {109, 109, 30}, {110, 110, 31}, {111, 122, 25}, {123, 254, -8}, },
            {{33, 96, -8}, {97, 97, 32}, {98, 122, 25}, {123, 254, -8}, },
            {{33, 100, -11}, {101, 101, 33}, {102, 254, -11}, },
            {{33, 96, -8}, {97, 97, 34}, {98, 254, -15}, },
            {{33, 96, -8}, {97, 120, 25}, {121, 121, 35}, {122, 122, 25}, {123, 254, -8}, },
            {{33, 96, -8}, {97, 109, 25}, {110, 110, 36}, {111, 254, -14}, },
            {{0, 65535, -6}, },
            {},
            {{0, 9, 37}, {11, 12, 37}, {14, 65535, 37}, },
            {},
            {{33, 254, -8}, },
            {{33, 254, -8}, },
            {{33, 254, -8}, },
            {{33, 254, -8}, },
            {{33, 109, -19}, {110, 110, 38}, {111, 254, -14}, },
            {{33, 96, -8}, {97, 114, 25}, {115, 115, 39}, {116, 122, 25}, {123, 254, -8}, },
            {{33, 96, -8}, {97, 107, 25}, {108, 108, 40}, {109, 122, 25}, {123, 254, -8}, },
            {{33, 109, -19}, {110, 110, 41}, {111, 254, -14}, },
            {{33, 96, -8}, {97, 111, 25}, {112, 112, 42}, {113, 122, 25}, {123, 254, -8}, },
            {{33, 96, -8}, {97, 101, 25}, {102, 102, 43}, {103, 122, 25}, {123, 254, -8}, },
            {{33, 96, -8}, {97, 97, 25}, {98, 98, 44}, {99, 122, 25}, {123, 254, -8}, },
            {{33, 96, -8}, {97, 118, 25}, {119, 119, 45}, {120, 122, 25}, {123, 254, -8}, },
            {{33, 96, -8}, {97, 98, 25}, {99, 99, 46}, {100, 122, 25}, {123, 254, -8}, },
            {{33, 108, -14}, {109, 109, 47}, {110, 122, 25}, {123, 254, -8}, },
            {{33, 104, -12}, {105, 105, 48}, {106, 254, -12}, },
            {{0, 65535, -6}, },
            {{33, 96, -8}, {97, 117, 25}, {118, 118, 49}, {119, 122, 25}, {123, 254, -8}, },
            {{33, 98, -36}, {99, 99, 50}, {100, 254, -36}, },
            {{33, 100, -11}, {101, 101, 51}, {102, 254, -11}, },
            {{33, 100, -11}, {101, 101, 52}, {102, 254, -11}, },
            {{33, 110, -10}, {111, 111, 53}, {112, 254, -10}, },
            {{33, 100, -11}, {101, 101, 54}, {102, 254, -11}, },
            {{33, 100, -11}, {101, 101, 55}, {102, 254, -11}, },
            {{33, 94, -8}, {95, 95, 56}, {96, 254, -8}, },
            {{33, 96, -8}, {97, 106, 25}, {107, 107, 57}, {108, 122, 25}, {123, 254, -8}, },
            {{33, 97, -34}, {98, 98, 58}, {99, 254, -34}, },
            {{33, 96, -8}, {97, 115, 25}, {116, 116, 59}, {117, 122, 25}, {123, 254, -8}, },
            {{33, 100, -11}, {101, 101, 60}, {102, 254, -11}, },
            {{33, 96, -8}, {97, 113, 25}, {114, 114, 61}, {115, 122, 25}, {123, 254, -8}, },
            {{33, 254, -8}, },
            {{33, 113, -52}, {114, 114, 62}, {115, 254, -52}, },
            {{33, 113, -52}, {114, 114, 63}, {115, 254, -52}, },
            {{33, 113, -52}, {114, 114, 64}, {115, 254, -52}, },
            {{33, 107, -30}, {108, 108, 65}, {109, 254, -30}, },
            {{33, 96, -8}, {97, 116, 25}, {117, 117, 66}, {118, 122, 25}, {123, 254, -8}, },
            {{33, 96, -8}, {97, 97, 67}, {98, 254, -15}, },
            {{33, 110, -10}, {111, 111, 68}, {112, 254, -10}, },
            {{33, 94, -8}, {95, 95, 69}, {96, 254, -8}, },
            {{33, 113, -52}, {114, 114, 70}, {115, 254, -52}, },
            {{33, 104, -12}, {105, 105, 71}, {106, 254, -12}, },
            {{33, 96, -8}, {97, 97, 72}, {98, 254, -15}, },
            {{33, 115, -50}, {116, 116, 73}, {117, 254, -50}, },
            {{33, 113, -52}, {114, 114, 74}, {115, 254, -52}, },
            {{33, 254, -8}, },
            {{33, 109, -19}, {110, 110, 75}, {111, 254, -14}, },
            {{33, 96, -8}, {97, 102, 25}, {103, 103, 76}, {104, 122, 25}, {123, 254, -8}, },
            {{33, 107, -30}, {108, 108, 77}, {109, 254, -30}, },
            {{33, 96, -8}, {97, 97, 78}, {98, 254, -15}, },
            {{33, 114, -29}, {115, 115, 79}, {116, 254, -29}, },
            {{33, 111, -32}, {112, 112, 80}, {113, 254, -32}, },
            {{33, 115, -50}, {116, 116, 81}, {117, 254, -50}, },
            {{33, 41, -5}, {43, 44, 3}, {45, 45, 82}, {46, 47, 3}, {48, 94, -8}, {95, 95, 83}, {96, 254, -8}, },
            {{33, 100, -11}, {101, 101, 84}, {102, 254, -11}, },
            {{33, 104, -12}, {105, 105, 85}, {106, 254, -12}, },
            {{33, 100, -11}, {101, 101, 86}, {102, 254, -11}, },
            {{33, 104, -12}, {105, 105, 87}, {106, 254, -12}, },
            {{33, 107, -30}, {108, 108, 88}, {109, 254, -30}, },
            {{33, 104, -12}, {105, 105, 89}, {106, 254, -12}, },
            {{33, 115, -50}, {116, 116, 90}, {117, 254, -50}, },
            {{33, 100, -11}, {101, 101, 91}, {102, 254, -11}, },
            {{33, 41, -5}, {43, 111, 3}, {112, 112, 92}, {113, 126, 3}, {191, 254, 3}, },
            {{33, 111, -32}, {112, 112, 93}, {113, 254, -32}, },
            {{33, 96, -8}, {97, 99, 25}, {100, 100, 94}, {101, 122, 25}, {123, 254, -8}, },
            {{33, 115, -50}, {116, 116, 95}, {117, 254, -50}, },
            {{33, 254, -8}, },
            {{33, 98, -36}, {99, 99, 96}, {100, 254, -36}, },
            {{33, 104, -12}, {105, 105, 97}, {106, 254, -12}, },
            {{33, 110, -10}, {111, 111, 98}, {112, 254, -10}, },
            {{33, 104, -12}, {105, 105, 99}, {106, 254, -12}, },
            {{33, 99, -86}, {100, 100, 100}, {101, 254, -86}, },
            {{33, 41, -5}, {43, 96, 3}, {97, 97, 101}, {98, 126, 3}, {191, 254, 3}, },
            {{33, 96, -8}, {97, 97, 102}, {98, 254, -15}, },
            {{33, 94, -8}, {95, 95, 103}, {96, 254, -8}, },
            {{33, 254, -8}, },
            {{33, 254, -8}, },
            {{33, 96, -8}, {97, 97, 104}, {98, 254, -15}, },
            {{33, 109, -19}, {110, 110, 105}, {111, 254, -14}, },
            {{33, 110, -10}, {111, 111, 106}, {112, 254, -10}, },
            {{33, 254, -8}, },
            {{33, 41, -5}, {43, 98, 3}, {99, 99, 107}, {100, 126, 3}, {191, 254, 3}, },
            {{33, 98, -36}, {99, 99, 108}, {100, 254, -36}, },
            {{33, 116, -58}, {117, 117, 109}, {118, 254, -58}, },
            {{33, 114, -29}, {115, 115, 110}, {116, 254, -29}, },
            {{33, 254, -8}, },
            {{33, 109, -19}, {110, 110, 111}, {111, 254, -14}, },
            {{33, 41, -5}, {43, 106, 3}, {107, 107, 112}, {108, 126, 3}, {191, 254, 3}, },
            {{33, 106, -48}, {107, 107, 113}, {108, 254, -48}, },
            {{33, 109, -19}, {110, 110, 114}, {111, 254, -14}, },
            {{33, 254, -8}, },
            {{33, 254, -8}, },
            {{33, 96, -94}, {97, 97, 115}, {98, 254, -94}, },
            {{33, 96, -8}, {97, 97, 116}, {98, 254, -15}, },
            {{33, 104, -12}, {105, 105, 117}, {106, 254, -12}, },
            {{33, 41, -5}, {43, 102, 3}, {103, 103, 118}, {104, 126, 3}, {191, 254, 3}, },
            {{33, 102, -69}, {103, 103, 119}, {104, 254, -69}, },
            {{33, 115, -50}, {116, 116, 120}, {117, 254, -50}, },
            {{33, 41, -5}, {43, 100, 3}, {101, 101, 121}, {102, 126, 3}, {191, 254, 3}, },
            {{33, 100, -11}, {101, 101, 122}, {102, 254, -11}, },
            {{33, 254, -8}, },
            {{33, 254, -5}, },
            {{33, 254, -8}, },
        }
        { // DESCRIPTION
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 41, 3}, {42, 42, 4}, {43, 46, 3}, {47, 47, 5}, {48, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 1}, {10, 10, 3}, {11, 12, 1}, {13, 13, 3}, {14, 41, -2}, {43, 46, 3}, {48, 65535, -2}, },
            {{0, 41, 3}, {43, 46, 3}, {48, 65535, 3}, },
            {{0, 65535, -4}, },
            {{47, 47, 6}, },
            {},
            {},
        }
        { // UNIT
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {34, 34, 3}, {42, 42, 4}, {65, 90, 5}, {97, 122, 6}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 8233, -2}, },
            {},
            {{0, 9, 7}, {11, 12, 7}, {14, 33, 7}, {34, 34, 8}, {35, 91, 7}, {92, 92, 9}, {93, 65535, 7}, },
            {{47, 47, 10}, },
            {{48, 57, 11}, {65, 90, 12}, {95, 95, 13}, {97, 122, 14}, },
            {{48, 122, -7}, },
            {{0, 65535, -5}, },
            {},
            {{0, 9, 15}, {11, 12, 15}, {14, 65535, 15}, },
            {},
            {{48, 122, -7}, },
            {{48, 122, -7}, },
            {{48, 122, -7}, },
            {{48, 122, -7}, },
            {{0, 65535, -5}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // SECTION
        {-1, 269, 269, -1, -1, -1, 261, 261, 261, 261, 261, 261, 261, 0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 22, 3, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 27, 4, 3, 3, 261, 261, 261, 261, 261, 261, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 261, 261, 261, 261, 261, 261, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 254, 255, -1, 256, -1, -1, 261, 261, 261, 124, 261, 261, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 261, 261, 261, 261, 125, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 258, -1, 261, 261, 123, 261, -1, -1, -1, -1, -1, -1, -1, 245, 234, 246, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 261, 261, 261, -1, -1, -1, -1, -1, -1, -1, 247, -1, -1, -1, -1, -1, -1, -1, 252, -1, -1, -1, 261, 261, 261, -1, -1, -1, 241, -1, -1, -1, -1, 249, -1, -1, -1, 259, 233, -1, -1, 257, 261, 261, 142, -1, -1, 238, -1, -1, -1, 244, 232, -1, -1, -1, 251, 253, -1, 99, 261, -1, -1, -1, -1, 242, 243, -1, -1, -1, -1, 261, -1, -1, -1, -1, -1, -1, -1, 235, 261, -1, -1, -1, -1, -1, -1, 260, 112, -1, -1, -1, -1, 248, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 250, -1, -1, -1, -1, 236, 237, 239, 240, },
        // NORMAL
        {-1, 269, 269, 31, -1, 32, 33, 34, 35, 36, 37, 38, 39, 41, 44, 45, 49, 51, 266, 266, 59, 62, 63, 74, 77, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 160, 56, 161, 164, 268, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 220, 222, 221, 227, 191, 39, 51, 34, 50, -1, 130, 136, 118, 67, 58, 46, 163, 65, 47, 79, 224, 76, 72, 42, 66, 48, 31, 32, 219, 59, 52, 135, 147, 45, 223, 35, 192, 57, 162, 227, 55, 71, 83, 69, 54, 68, 53, 82, 150, 108, 119, 151, 64, 164, 226, 225, 70, 73, 43, 78, 81, 70, 226, 228, 229, 230, 64, -1, 30, -1, 0, -1, -1, -1, -1, 40, -1, -1, -1, 48, -1, 50, 22, 3, 52, -1, 55, 57, -1, -1, 60, 61, 60, 64, 66, 68, -1, 71, 73, -1, 75, 76, -1, -1, 82, 83, -1, 261, 261, 261, 261, 261, 261, 261, 89, 261, 261, 261, 261, 261, 102, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 111, 261, 114, 261, 261, 261, 261, 261, 261, 132, 261, 134, 135, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 162, -1, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 179, 261, 261, 261, 261, 261, 261, 261, 261, 261, 192, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, -1, 225, 223, 227, 131, 131, 137, 137, -1, -1, -1, -1, 27, 42, 46, 4, 3, 3, 53, -1, 58, 267, 67, 65, -1, 69, 70, -1, 72, 78, 79, 261, 86, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 106, 261, 261, 261, 261, 261, 109, 261, 261, 261, 261, 261, 261, 117, 261, 121, 261, 261, 261, 261, 261, 128, 261, 136, 138, 261, 261, 261, 261, 261, 146, 261, 261, 261, 261, 261, 261, 261, 261, 261, 154, 261, 261, 163, 261, 261, 166, 261, 261, 261, 261, 261, 174, 261, 261, 177, 261, 261, 261, 261, 261, 261, 261, 187, 188, 261, 190, 191, 261, 261, 261, 261, 200, 201, 202, 203, 261, 205, 261, 261, 211, 261, 261, 261, 261, 216, 261, 261, 224, 226, -1, -1, -1, 43, 47, 54, 229, 228, 80, 81, 261, 261, 261, 261, 91, 93, 261, 261, 261, 261, 261, 261, 261, 261, 104, 261, 261, 261, 261, 261, 261, 261, 110, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 129, 261, 261, 137, 261, 261, 261, 261, 261, 261, 143, 261, 145, 261, 261, 261, 149, 150, 261, 261, 152, 261, 261, 157, 261, 261, 261, 261, 167, 261, 169, 261, 172, 261, 261, 261, 261, 261, 261, 182, 261, 185, 186, 261, 193, 261, 195, 261, 197, 198, 199, 261, 206, 208, 209, 210, 261, 261, 214, 215, 217, 261, -1, -1, -1, 230, 261, 261, 90, 261, 261, 261, 261, 261, 261, 261, 261, 105, 261, 261, 261, 261, 261, 108, 261, 261, 261, 261, 261, 261, 261, 119, 261, 261, 261, 261, 261, 124, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 147, 261, 261, 151, 261, 261, 158, 159, 165, 261, 168, 261, 173, 261, 176, 178, 180, 181, 183, 261, 261, 261, 261, 204, 207, 261, 261, 218, -1, -1, -1, 261, 87, 94, 261, 261, 261, 261, 261, 261, 261, 261, 103, 261, 133, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 126, 127, 261, 261, 261, 261, 261, 261, 261, 261, 261, 144, 148, 125, 153, 261, 261, 92, 261, 175, 261, 189, 261, 196, 212, 261, -1, -1, -1, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 107, 261, 261, 261, 113, 261, 261, 118, 261, 261, 123, 130, 261, 261, 261, 261, 261, 261, 141, 261, 261, 261, 261, 155, 170, 184, 194, 213, -1, -1, -1, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 115, 261, 261, 261, 131, 261, 261, 139, 261, 261, 261, 261, 261, 261, 261, 171, -1, -1, -1, 261, 261, 261, 261, 97, 261, 261, 261, 261, 261, 261, 231, 261, 261, 261, 120, 261, 261, 261, 261, 261, 261, 261, 261, 261, 156, -1, -1, -1, -1, 261, 261, 88, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, 133, 101, 140, 261, 142, 261, 261, -1, -1, -1, -1, 261, 261, 261, 261, 261, 98, 261, 99, 261, 100, 261, 261, 261, 261, 261, 261, -1, -1, -1, -1, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, -1, -1, -1, -1, 261, 261, 261, 261, 261, 261, 261, 261, 261, 261, -1, -1, -1, -1, 261, 261, 261, 261, 261, 112, 116, 116, 261, -1, -1, -1, -1, 261, 261, 261, 261, 261, -1, -1, -1, 265, 261, 261, 261, 261, 122, -1, -1, -1, 261, 261, 261, 261, 263, -1, -1, 84, 85, 95, 96, 263, 263, -1, -1, -1, -1, 262, 264, 262, 262, 264, 264, },
        // COMMENT
        {24, 24, 24, 24, 25, 26, 23, },
        // MULTILINE_STRING_STATE
        {29, 29, 29, 29, -1, 29, -1, 29, -1, 29, -1, 29, 28, 29, -1, 29, 29, },
        // SHEBANG
        {-1, 2, 1, 2, 2, 269, 0, },
        // PRAGMA
        {-1, 269, 269, 18, -1, -1, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, -1, 18, -1, 5, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, -1, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 16, 13, 18, 18, 18, 18, 18, 18, 18, 6, 18, 18, 18, 18, 18, 12, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 14, 18, 18, 18, 18, 18, 18, 18, 18, 7, 11, 18, 18, 18, 10, 18, 18, 18, 18, 17, 18, 18, 18, 18, 9, 16, 18, 18, 18, 18, 18, 18, 18, 18, 8, 15, 15, },
        // DESCRIPTION
        {19, 19, 19, 19, 25, 26, 23, },
        // UNIT
        {-1, 269, 269, -1, -1, 21, 21, -1, 20, -1, 5, 21, 21, 21, 21, -1, },

    };*/

    public static class State
    {
        public final static State SECTION = new State(0);
        public final static State NORMAL = new State(1);
        public final static State COMMENT = new State(2);
        public final static State MULTILINE_STRING_STATE = new State(3);
        public final static State SHEBANG = new State(4);
        public final static State PRAGMA = new State(5);
        public final static State DESCRIPTION = new State(6);
        public final static State UNIT = new State(7);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
